*=$0801

                  byte        $0b, $08, $0a, $00, $9e, $32, $31, $39, $32, $00, $00, $00

;############################################################################################################################################################

;GENERAL NOTES
; - the "number of cycles passed" information in the irxx comments may not be a 100% correct :\ - could not be bothered to update after every little raster fix
; - 1 bar in Soundmaster equals $c0 cycles
; - Exomizer: win32>exomizer sfx basic,$0801,$0820,$0820 -n otg.prg -o otgp.prg

;############################################################################################################################################################

;ZERO PAGE USE
;potential zero page locations: $92-$96, $a3-$b1, $f7-$fa, $fb-$fe
;in use:    $fb-$fe,$a3-a8

;############################################################################################################################################################

;SOUND

soundsrc          = $87f0                       ;(original: $67f0) - must always be the start of the sound data (see _SOUND_DATA, **0f) + $2e1

;############################################################################################################################################################

;SCROLLER
scrspr            = $4c00                       ;start of data for seven scroller sprites

scrlclfrms        = #$08                        ;number of frames for displaying a color of the scroll

scrlcls           = #$06                        ;number of colors used in scroller


;############################################################################################################################################################

;VARIABLES
;the address is given for each variable just to make debugging easier

*=$0810

;ELECTRIC ARC ANIMATION
eafrmndx          = $0810                       ;pointer to current frame of electric arc animation ($00-$0a)
                                                ;in order so avoid compare functions for the index, $09 is the first slice and $00 the last
                                                ;also serves as pointer to the color to use in the animation frame
                  byte        $0a               ;set pointer to first electric arc animation frame

eactv             = $0811                       ;flag for an active animation ($00 = no animation running, >$00 = animation running)
                  byte        $00

eadly             = $0812                       ;determines how many frames are skipped befor the next animation frame of the arc is shown
                  byte        $03

eandx             = $0813                       ;pointer to current animation
                  byte        $04

;GRID SCROLL
dirscrll          = $0814                       ;direction of grid scroll
                                                ;direction is based on bits 0-3
                                                ;%0001 = up
                                                ;%0010 = right
                                                ;%0100 = down
                                                ;%1000 = left
                  byte        $02

grdscrldly        = $0815                       ;delay counter for grid scroll (number of frames before next scroll step)
                  byte        $03

;MONITOR ANIMATION GENERAL
mnanipt           = $0816                       ;determines which part of the monitor animation currently plays
                                                ;$00 = wipe in grid left to right
                                                ;$01 = bring in sawtooth lines
                                                ;$02 = display sawtooth for n frames
                                                ;$03 = bring in flatline
                                                ;$04 = display flatline for n frames
                                                ;$05 = wipe out monitor with flatline top to bottom
                                                ;$06 = flicker grid into dark monitor
                                                ;$07 = bring in line to expand rectangle
                                                ;$08 = expand line to rectangle
                                                ;$09 = rotating rectangle
                                                ;$0a = pixel in pyramid in rectangle
                                                ;$0b = rotating pyramid in rectangle
                                                ;$0c = blinking eye in pyramid
                                                ;$0d = rotating pyramid in rectangle (same as $0b)
                                                ;$0e = pixel out pyramid in rectangle
                                                ;$0f = rotating rectangle (same as $09)
                                                ;$10 = welding & erasing the rectangle
                                                ;$11 = move the small square to 3 positions, expand, rotate and finally rise them out of the screen
                                                ;$12 = pixel scroller left > right
                                                ;$13 = pixel waves
                                                ;$14 = set up monitor for $15
                                                ;$15 = wavy pixel scroller right > left
                                                ;$16 = white noise
                                                ;$17 = switch off monitor
                                                ;$18 = reset for restart

_ANIPTVAR         byte        $00

;MONITOR ANIMATION $00 (WIPE IN GRID LEFT TO RIGHT)
wpindly           = $0817                       ;delay counter
                  byte        $04

wpinndx           = $0818                       ;index for current animation frame
                  byte        $03

mcolndx           = $0819                       ;index for column of monitor being processed
                  byte        $00

;MONITOR ANMIMATION $01 (BRING IN SAWTOOTH LINES)
swtanindx         = $081a                       ;offset for fetching sawtooth character data
                  byte        $0b

swtrw1            = $081b                       ;index for bringing sawtooth in row 1 of monitor
                  byte        $11               ;timed to sound: starts with 1st bar that plays track 3 sphere sound displaying

swtrw3            = $081c                       ;index for bringing sawtooth in row 3 of monitor
                  byte        $30               ;timed to sound: 1 bar passes after row 1 has started displaying

swtrw5            = $081d                       ;index for bringing sawtooth in row 5 of monitor
                  byte        $50               ;timed to sound: 1 bar passes after row 2 has started displaying

swtindly          = $081e                       ;delay between animation phases, used in parts $01,$02 and $03
                  byte        $60               ;inital delay for timing to sound, actual value $06

swtclrndx         = $081f                       ;index for fetching sawtooth color information
                  byte        $01

;MONITOR ANIMATION $02 (DISPLAY SAWTOOTH FOR N FRAMES)
swtdur            = $0820                       ;duration for display of sawtooth in frames / swtindly (e.g. 48 frames / delay 6 frames = 8)
                  byte        $4e

;MONITOR ANIMATION $03 (BRING IN FLATLINE)
fltlnrw1          = $0821                       ;index for bringing flatline in row 1 of monitor
                  byte        $12

fltlnrw3          = $0822                       ;index for bringing flatline in row 3 of monitor
                  byte        $40

fltlnrw5          = $0823                       ;index for bringing flatline in row 5 of monitor
                  byte        $70

mnanidly3         = $0824                       ;delay for bringing in flatline
                  byte        $06

;MONITOR ANIMATION $04 (DISPLAY FLATLINE FOR N FRAMES)
fltldur           = $0825                       ;duration for display of flatline in frames * 2
                  byte        $a0

;MONITOR ANIMATION $05 (WIPE OUT MONITOR WITH FLATLINE TOP TO BOTTOM)
rw2prcss          = $0826                       ;index for currently processed row - $06 = row $00, $00 = row $06
                  byte        $06

ln2prcss          = $0827                       ;index for currently processed line in row - $00 = line $00
                  byte        $00

mnanidly4         = $0828                       ;delay before wiping out the next line of the monitor
                  byte        $02

;MONITOR ANIMATION $06 (flicker grid into dark monitor)
dsplmd            = $0829                       ;display mode (%xxxxxxx0 = dark grey square; %xxxxxxx1 = grid)
                  byte        $00

mnanidly8         = $082a                       ;delay between flickering grid
                  byte        $28

flckrndx          = $082b                       ;index within animation part
                  byte        $09

;MONITOR ANIMATION $07 (BRING IN LINE TO EXPAND RECTANGLE)
rctlndx1          = $082c                       ;index for animation frame
                  byte        $06

rctlndx2          = $082d                       ;index for animation subframe (during frames $04-$00)
                  byte        $03

mnanidly6         = $082e                       ;delay between animation frames
                  byte        $03

;MONITOR ANIMATION $08 (EXPAND LINE TO RECTANGLE)
rctexdx1          = $082f                       ;index for animation frame
                  byte        $08

mnanidly7         = $0830                       ;delay between animation frames
                  byte        $03

;MONITOR ANIMATION $09 (ROTATING RECTANGLE) - same values are used for part $0f
rtrctndx          = $0831                       ;index for animation frame
                  byte        $00

mnanidly5         = $0832                       ;delay between animation frames - the delay is actually reset to $01 in the $09/$0f routine,
                  byte        $a8               ;the value in initally higher to have some delay before the animation starts

rtrctdur          = $0833                       ;duration of animation (n animation frames)
                  byte        $33

rectclrndx        = $0834                       ;index for fetching rectangle colors
                  byte        $03

;MONITOR ANIMATION $0a (PIXEL IN PYRAMID IN RECTANGLE)
pyrpxlndx         = $0835                       ;index for animation frame
                  byte        $07

mnanidly10        = $0836                       ;delay between animation frames
                  byte        $50               ;set higher initally for sound timing reasons, normal value = $04  

;MONITOR ANIMATION $0b (ROTATING PYRAMID IN RECTANGLE) - same values are used for part $0d
pyrndx            = $0837                       ;index for animation frame (has to be decreased in $0e steps because it also serves as index for fetching animation characters)
                  byte        $b3

mnanidly9         = $0838                       ;delay between animation frames
                  byte        $98               ;set higher initally for sound timing reasons, normal value = $06

pyrdur            = $0839                       ;duration of animation (n complete aniamtions)
                  byte        $07

;MONITOR ANIMATION $0c (BLINKING EYE IN PYRAMID)
eyendx            = $083a                       ;index for animation frame
                  byte        $05

mnanidly11        = $083b                       ;delay between animation frames
                  byte        $40

eyedur            = $083c                       ;times animation is repeated
                  byte        $05

tmpscrlcol        = $083d                       ;temporary storage for current scroller color
                  byte        $00

;MONITOR ANIMATION $0e (PIXEL OUT PYRAMID IN RECTANGLE)
pyrpxlondx        = $083e                       ;index for animation frame
                  byte        $07

mnanidly12        = $083f                       ;delay between animation frames
                  byte        $20

;MONITOR ANIMATION $10 (WELDING THE RECTANGLE)
wldsprtdly        = $0840                       ;delay between welding sprite animation frames
                  byte        $03

wldsprtndx        = $0841                       ;index for welding sprite animation frames
                  byte        $03

wldsprtx          = $0842                       ;x coordinate or sprites $00,$01,$02
                  byte        $b1

wldsprty          = $0843                       ;y coordinate or sprites $00,$01,$02
                  byte        $b2

wldmvdly          = $0844                       ;delay for movement of welding sprites
                  byte        $00

wldmvndx          = $0845                       ;index for fetching welding sprite movement data
                  byte        $00

wldlnndx          = $0846                       ;index for fetching welding line chars
                  byte        $00

;MONITOR ANIMATION $11 (MOVE THE SMALL SQUARE TO THREE POSITIONS, EXPAND, ROTATE AND FINALLY RISE THEM OUT OF THE SCREEN)
indly             = $0847                       ;inital delay
                  byte        $50

dlymvmt           = $0848                       ;delay between movement
                  byte        $01

dlyrt             = $0849                       ;delay between expansion / rotation
                  byte        $02

sqsprtx1          = $084a                       ;x coordinate of sprites $00 and $03
                  byte        $a4

sqsprtx2          = $084b                       ;x coordinate of sprites $02 and $05
                  byte        $a4

sqsprty           = $084c                       ;y coordinate of sprites $00-$05
                  byte        $ba

sqsubpt           = $084d                       ;animation sub part ($00 = move squares; $01 = expand squares; $02 = rotates squares; $03 = rotate squares and rise them out of the monitor)
                  byte        $00

sqanindx          = $084e                       ;index for expanding square sprites (doubles as pointer value to square sprites)
                  byte        $ac

sqrtdur           = $084f                       ;duration of square rotation
                  byte        $15

;MONITOR ANIMATION $12 (PIXEL SCROLLER LEFT > RIGHT)
pxscrldly1        = $0850                       ;delay between animation frames
                  byte        $06

pxlscrllrndx      = $0851                       ;storage for index for putting animation characters on screen, needed because it is spread across ir**-part
                  byte        $00               ;and a full line cannot be drawn in a single ir** part

;MONITOR ANIMATION $13 (PIXEL WAVES)
pxlwvdly1         = $0852                       ;delay between animation frames for monitor row 1
                  byte        $06

pxlwvdly2         = $0853                       ;delay between animation frames for monitor row 2
                  byte        $07

pxlwvdly3         = $0854                       ;delay between animation frames for monitor row 3
                  byte        $08

pxlwvdly4         = $0855                       ;delay between animation frames for monitor row 4
                  byte        $06

pxlwvdly5         = $0856                       ;delay between animation frames for monitor row 5
                  byte        $06

pxlwvndx1         = $0857                       ;index for pixel wave characters in monitor row 1
                  byte        $05

pxlwvndx2         = $0858                       ;index for pixel wave characters in monitor row 2
                  byte        $03

pxlwvndx3         = $0859                       ;index for pixel wave characters in monitor row 3
                  byte        $01

pxlwvndx4         = $085a                      ;index for pixel wave characters in monitor row 4
                  byte        $03

pxlwvndx5         = $085b                       ;index for pixel wave characters in monitor row 5
                  byte        $05

pxlwvsubpt        = $085c                       ;index for subpart of pixel wave animation
                  byte        $00               ;$00 = bounce single pixel in monitor rows 1 & 5
                                                ;$01 = bounce single pixel in monitor rows 2 & 4
                                                ;$02 = bounce single pixel monitor row 3
                                                ;$03 = unveil complete pixelwave in row 3
                                                ;$04 = unveil complete pixel wave rows 2 & 4
                                                ;$05 = unveil complete pixel wave rows 2 & 5
                                                ;$06 = display all pixel waves for set duration
                                                ;$07 = hide pixel wave in monitor row 5
                                                ;$08 = hide pixel wave in monitor row 4
                                                ;$09 = hide pixel wave in monitor row 3
                                                ;$0a = hide pixel wave in monitor row 2
                                                ;$0b = hide pixel wave in monitor row 1
                                                ;$0c = single pixel wave in monitor row 3

pxlwvsubdly1      = $085d                       ;duration in animation frames for animation sub parts $00-$02
                  byte        $05

pxlwviondx        = $085e                       ;index for how many characters will (not) be overwritten (i.e. unveiled) by the PXLWV*IN and PXLWVOUT routines
                  byte        $00

pxlwvdur          = $085f                       ;duration of display of all pixel waves (n screen frames) - hi byte added (durexp2), see below
                  byte        $20

pxlwvmvndx1       = $0860                       ;index for position of single pixel wave ($ff = -1)
                  byte        $ff

pxlwvmvndx2       = $0861                       ;index for characters of single pixel wave
                  byte        $05

pxlwvmvdly        = $0862                       ;delay between animation frames (in screen frames)
                  byte        $06

;MONITOR ANIMATION $15 (WAVY PIXEL SCROLLER RIGHT > LEFT)
;note: variables pxscrldly1 and pxlscrllrndx from part $12 are also used here

pxlwvchrsdly      = $0863                       ;delay between changing the pixel position within the chars
                  byte        $06

pxlwvchrsndx      = $0864                       ;index for animation phase within the chars
                  byte        $05

;MONITOR ANIMATION $16 (WHITE NOISE)
whtnsndx          = $0865                       ;index for fetching white noise character codes
                  byte        $7d

whtnsdly          = $0866                       ;delay between character animation frames
                  byte        $ac

whtnsbry          = $0867                       ;y coordinate of white noise bar
                  byte        $9e

whtnsdur          = $0868                       ;duration of white noise animation part (measured by full passes of the bar)
                  byte        $03

;MONITOR ANIMATION $17 (SWITCH OFF MONITOR)

swtchffndx        = $0869
                  byte        $07

;MONITOR ANIMATION $18 (RESET FOR RESTART)

rstrtdly          = $086a                       ;delay before restarting (counted in screen frames)
                  byte        $28

;############################################################################################################################################################
;GENRAL & SCROLLER

scrlndx           = $086b                       ;counter for adding a new character to the scroller
                  byte        $01

scrldly           = $086c                       ;counter for scroller delay (delay in frames)
                  byte        $02

apstore           = $086d                       ;all purpose temporary storage for one value
                  byte        $00

scrlclndx         = $086e                       ;pointer for scroll text color @ scrlcol
                  byte        $24               ;scrlclfrms*scrlcls, i.e. number of frames per color multiplied with number of colors used

;############################################################################################################################################################
;LOGO ANIMATION

erlgslcndx        = $086f                       ;pointer to current slice of logo ($00-$0e)
                                                ;in order so avoid compare functions for the index, $0e is the first slice and $00 the last
                  byte        $0e               ;set pointer to first logo slice

erlgfrmndx        = $0870                       ;pointer to current frame of logo erase/build animation ($00-$09)
                                                ;in order so avoid compare functions for the index, $09 is the first slice and $00 the last
                                                ;also serves as pointer to the color to use in the animation frame
                  byte        $09               ;set pointer to first logo animation frame

erlganitype       = $0871                       ;determines if the logo is erased ($00) or build ($01)
                  byte        $01

erlgdly           = $0872                       ;determines how many frames are skipped befor the next animation frame is shown
                  byte        $01

erlgdly2          = $0873                       ;determines how many frames are skipped before build/erase takes place again
                  byte        $00               ;initally set to $00 because build should start right away

;############################################################################################################################################################
;HIDDEN FEATURE

bgcol             = $0874                       ;background color - normally $0f, constantly changed if hidden feature is turned on
                  byte        $0f

hfact             = $0875                       ;flag for activating hidden feature (bit 0 = 0: off; bit 0 = 1: = on)
                  byte        $00
                  
hfcolndx          = $0876                       ;index for fetching different background color in hidden feature
                  byte        $07
                  
;############################################################################################################################################################
;TIMING FIXERS

_FIXTIMING

durexp            = $0877                       ;used to expand durations beyond $ff frames (to max. $1ff)
                  byte        $01

tmngdly           = $0878                       ;delay for fixing timing; initial value is for animation part $06
                  byte        $90

durexp2           = $0879                       ;used to expand durations beyond $ff frames (to max. $ffff)
                  byte        $02
                  
;############################################################################################################################################################

;CODE

_CODE_0890

*=$0890

;STARTUP
                  jsr         $e544             ;clear screen
                  lda         #$00              ;set screen color to black
                  sta         $d020             
                  sta         $d021             
                  ldx         #$10              ;delay n frames
                  lda         $d011             
                  bmi         *-3               
                  lda         $d012             
                  bne         *-8               
                  dex
                  bne         *-11              
                  lda         #$0b              ;set screen color to dark grey
                  sta         $d020             
                  sta         $d021             
                  ldx         #$10              ;delay n frames
                  lda         $d011             
                  bmi         *-3               
                  lda         $d012             
                  bne         *-8               
                  dex
                  bne         *-11              
                  lda         #$0c              ;set screen to color medium grey
                  sta         $d020             
                  sta         $d021             
                  ldx         #$10              ;delay n frames
                  lda         $d011             
                  bmi         *-3               
                  lda         $d012             
                  bne         *-8               
                  dex
                  bne         *-11              
                  lda         #$0f              ;set screen to color light grey
                  sta         $d020             
                  sta         $d021             
                  lda         $dd00             ;switch to VIC bank 1 (leave other bits untouched)
                  and         #$02              
                  sta         $dd00             
                  lda         #$20              ;set font at $0000 and screen memory at $0800 in bank
                  sta         $d018             
                  lda         #$d8              ;activate multicolor character mode
                  sta         $d016             
                  lda         #$0b              ;set multicolor color #01
                  sta         $d022             
                  lda         #$0c              ;set multicolor color #02
                  sta         $d023             

;SET WHOLE COLOR MEMORY TO HIRES BLACK
                  lda         #$00              
                  ldx         #$fb              
                  sta         $d7ff,x           
                  sta         $d8f9,x           
                  sta         $d9f3,x           
                  sta         $daec,x           
                  dex
                  bne         *-13              

;SCROLLER SPRITES
                  lda         #$ff              ;set coordinates for sprite 6 (part of scroller) - done here because this sprite is not multiplexed
                  sta         $d00d             ;and therefore has it's coordinate NOT reset by SPRTRST so as not to waste cycles
                  lda         #$38              
                  sta         $d00c             


;SET UP ZERO PAGE ADDRESSES
                                                ;animation part $12
                  lda         #$61              ;address for fetching character data (used for all 5 rows of monitor in this animation part)
                  sta         $fd               
                  lda         #$a5              
                  sta         $fe               
                                                ;startup part $02
                  lda         #$00              ;screen memory address for bringing in vertical lines
                  sta         $fb               
                  lda         #$48              
                  sta         $fc               

;SET UP SOUND
                  ldy         #$53              
                  lda         #$00              
soundstp_01       sta         $0333,y
                  dey
                  bne         soundstp_01       
                  lda         #$00              
                  sta         $0377             
                  ldy         soundsrc+$4       
                  dey
                  sty         $037c             
                  ldy         soundsrc-$1       
                  sty         $0385             
                  jsr         irm_sub14         
                  jsr         irm_sub15         
                  ldy         #$1c              
                  lda         #$00              
soundstp_02       sta         $d400,y
                  sta         $02a7,y           
                  dey
                  bpl         soundstp_02       
                  lda         soundsrc+$a       
                  sta         $d418             
                  lda         soundsrc+$9       
                  sta         $d417             
                  lda         #$08              
                  sta         $d404             
                  sta         $d40b             
                  sta         $d412             

;SET UP INTERRUPT

_IRSTP            sei
                                                ;non-maskable interrupt(nmi) lock - avoids crashes on hitting restore
                                                ;taken from codebase 64: https://codebase64.org/doku.php?id=base:nmi_lock
                  lda         #<_NMI_UNACK      ;change nmi vector to unacknowledge "routine"
                  sta         $0318             
                  lda         #>_NMI_UNACK      
                  sta         $0319             
                  lda         #$00              
                  sta         $dd0e             ;stop timer a
                  sta         $dd04             ;set timer a to 0, after starting nmi will occur immediately
                  sta         $dd05             
                  lda         #$81              
                  sta         $dd0d             ;set timer a as source for nmi
                  lda         #$01              
                  sta         $dd0e             ;start timer a and trigger nmi

                  lda         #$7f              ;turn off interfering CIA interrupts
                  sta         $dc0d             
                  lda         #$01              ;enable raster interrupts (and only those)
                  sta         $d01a             
                  lda         #$00              ;set raster trigger (note: $2c for main demo routine)
                  sta         $d012             
                  lda         $d011             ;including clearing bit 8 of raster register
                  and         #$7f              
                  sta         $d011             
                  lda         #<strir_00        ;set address of 1st interrupt routine
                  sta         $fffe             
                  lda         #>strir_00        
                  sta         $ffff             
                  lsr         $dc0d             ;acknowledge any pending interrupts
                  lsr         $d019             
                  lda         #$35              ;switch off basic rom & kernal (bit 0 = 0)
                  sta         $01               
                  cli

;(DE)ACTIVATE HIDDEN FEATURE
lööp              lda         #$7f              ;set keyboard matrix to read keyboad matrix row 7 (bit 7 = 0)              
                  sta         $dc00             
                  lda         $dc01             ;read value for keyboard matrix row 7             
                  cmp         #$df              ;check if bit 5 is 0 (= C= key pressed)
                  bne         lööp              ;if not, loop
lööp_2            lda         $dc01             ;read value for keyboard matrix row 7
                  cmp         #$ff                            
                  bne         lööp_2
                  lda         #$01
                  sta         hfact
                  jmp         lööp             

;############################################################################################################################################################
;LEAVE NMI UNACKNOWLEDGED
                  
_NMI_UNACK        rti                           ;nmi left unacknowledged, thereby avoiding that the restore key interferes with the raster timing

;############################################################################################################################################################
;INTERRUPT ROUTINES
                                                ;zero page usage:
                                                ;     $a3-$aa: logo animation
                                                ;     $fb-$fc: copy new char into scoller
                                                ;     $fd-$fe:    animation parts $12 (pixel scroller) and $15 (pixel wave scroller)

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir00              lda         #<ir00_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir00_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir00 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir00_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir00_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $2D

ir00_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X


                  ldy         #$07              ;(2 cycles) load value for delay loop
                  dey                           ;(34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $2E
                                                ;=> 1-2 cycles have passed
                  sta         $d021             ;(4 cycles) set screen color to black
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT raster line
                  sta         $d020             ;(4 cycles) reset border color
                  sta         $d021             ;(4 cycles) reset screen color

;============================================================================================================================================================
                                                ;monitor wipe in left to right

MONWIPEIN         lda         mnanipt           ;check current monitor animation part
                  beq         monwipein_s1      ;if not $00, skip this animation part

                  jmp         DISPSAW1          

monwipein_s1      dec         wpindly           ;decrease delay counter
                  beq         monwipein_s2      ;if not $00, do not execute the animation part in this frame

                  jmp         ir00_e            
                                                ;the animation for wiping in one column consists of four frames
                                                ;the first three are handled by character masking, the fourth places the final
                                                ;character codes into the currently processed column
monwipein_s2      lda         #$04              ;reset delay counter
                  sta         wpindly           

                  dec         wpinndx           ;decrease index for animation frame
                  bpl         monwipein_s3      ;if index is <$00, the three animation frames that require masking are done
                  jmp         monwipein_s4      
                                                ;the grid char consists of only 4 discreet bytes
                                                ;therefore only bytes 0,2,4 and 6 of the char need to be loaded/processed
monwipein_s3      ldx         wpinndx           ;load index for animation frame
                  lda         $60f0             ;load byte 0 of current grid char data
                  and         mnwpers,x         ;mask out parts of the grid not seen
                  ora         mnwpdgm,x         ;mask in dark grey monitor part still seen
                  sta         $6790             ;store in byte 0 of $f2 character
                  sta         $6791             ;store in byte 1 of $f2 character

                  lda         $60f2             ;load byte 2 of current grid char data
                  and         mnwpers,x         ;mask out parts of the grid not seen
                  ora         mnwpdgm,x         ;mask in dark grey monitor part still seen
                  sta         $6792             ;store in byte 2 of $f2 character
                  sta         $6793             ;store in byte 3 of $f2 character

                  lda         $60f4             ;load byte 4 of current grid char data
                  and         mnwpers,x         ;mask out parts of the grid not seen
                  ora         mnwpdgm,x         ;mask in dark grey monitor part still seen
                  sta         $6794             ;store in byte 4 of $f2 character
                  sta         $6795             ;store in byte 5 of $f2 character

                  lda         $60f6             ;load byte 6 of current grid char data
                  and         mnwpers,x         ;mask out parts of the grid not seen
                  ora         mnwpdgm,x         ;mask in dark grey monitor part still seen
                  sta         $6796             ;store in byte 6 of $f2 character
                  sta         $6797             ;store in byte 7 of $f2 character

                  jmp         ir00_e            

monwipein_s4      lda         #$03              ;reset animation frame index
                  sta         wpinndx           
                  ldx         mcolndx           ;load column index
                  lda         #$ff              ;fill the column with the final character codes (=last frame of animation)
                  sta         $4a8b,x           ;each row that does not show a sawtooth line has its own code - needed for the wipe animation later
                  sta         $4ab3,x           ;the saw tooth rows themselves get their individual codes in a later animation part
                  sta         $4b03,x           
                  sta         $4b53,x           
                  lda         #$fe              
                  sta         $4adb,x           
                  lda         #$fd              
                  sta         $4b2b,x           
                  lda         #$fc              
                  sta         $4b7b,x           
                  inx                           ;increase column index
                  cpx         #$13              ;check if last column has been reached
                  bne         monwipein_s5      ;if not, continue with setting up next column
                  lda         #$01              ;activate next animation part
                  sta         mnanipt           

                  jmp         ir00_e            

monwipein_s5      stx         mcolndx           ;store new column index value
                  lda         #$55              ;restore $f2 to the dark grey square
                  sta         $6790             
                  sta         $6791             
                  sta         $6792             
                  sta         $6793             
                  sta         $6794             
                  sta         $6795             
                  sta         $6796             
                  sta         $6797             
                  lda         #$f2              ;set animation character $f2 in the current column
                  sta         $4a8b,x           
                  sta         $4ab3,x           
                  sta         $4b03,x           
                  sta         $4b53,x           
                  sta         $4adb,x           
                  sta         $4b2b,x           
                  sta         $4b7b,x           

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;display sawtooth part 1

DISPSAW1          beq         dispsaw1_1        ;check current monitor animation part
                  cmp         #$04              ;if not beweteen $01 and $03, skip
                  bcc         dispsaw1_2        
dispsaw1_1        jmp         GRIDFLCKRP1
                                                ;merge grid & sawtooth characters

                                                ;character $1f > $f6
dispsaw1_2        lda         $60f8             ;load byte 0 of sawtooth character
                  ora         $60f0             ;ORA with byte 0 of grid character
                  sta         $67b0             ;store in byte 0 of display character
                  sta         $67b1             ;store in byte 1 of display character
                  lda         $60fa             ;byte 2
                  ora         $60f2             
                  sta         $67b2             ;store in byte 2 of display character
                  sta         $67b3             ;store in byte 3 of display character
                  lda         $60fc             ;byte 4
                  ora         $60f4             
                  sta         $67b4             ;store in byte 4 of display character
                  sta         $67b5             ;store in byte 5 of display character
                  lda         $60fe             ;byte 6
                  ora         $60f6             
                  sta         $67b6             ;store in byte 0 of display character
                  sta         $67b7             ;store in byte 0 of display character
                                                ;character $20 > $f7
                  lda         $6100             ;byte 0
                  ora         $60f0             
                  sta         $67b8             
                  sta         $67b9             
                  lda         $6102             ;byte 2
                  ora         $60f2             
                  sta         $67ba             
                  sta         $67bb             
                  lda         $6104             ;byte 4
                  ora         $60f4             
                  sta         $67bc             
                  sta         $67bd             
                  lda         $6106             ;byte 6
                  ora         $60f6             
                  sta         $67be             
                  sta         $67bf             
                                                ;character $21 > $f8 (part 1 - continued @ DISPSAWTP2)
                  lda         $6108             ;byte 0
                  ora         $60f0             
                  sta         $67c0             
                  sta         $67c1             
                  lda         $610a             ;byte 2
                  ora         $60f2             
                  sta         $67c2             
                  sta         $67c3             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;flicker in the scrolling grid part 1

GRIDFLCKRP1       cmp         #$06              ;check current animation part
                  beq         gridflckrp1_s1    ;if not $06, skip ahead
                  
                  jmp         RECTLNIN  
        
gridflckrp1_s1    lda         tmngdly           ;check delay before starting flicker
                  beq         gridflckrp1_s1_1
                  lda         durexp            ;load flag for decreasing fltldur only every other frame
                  eor         #$01              ;flip flag (bit 0)              
                  sta         durexp            ;store flag
                  beq         gridflckrp1_s1_0  ;if flag = 0, skip ahead
                  dec         tmngdly           ;decrease delay before starting flicker

gridflckrp1_s1_0  jmp         ir00_e            ;skip ahead
         
gridflckrp1_s1_1  lda         mnanidly8         ;check if delay = $00
                  beq         gridflckrp1_s2    
                  ldx         #$00              ;if not, set display mode to $00 (i.e. the grid is flashed for one frame)
                  stx         dsplmd            
                  dec         mnanidly8         ;decrease delay
                  jmp         gridflckrp1_s4    ;skip ahead
gridflckrp1_s2    ldx         flckrndx          ;load animation frame index
                  bmi         gridflckrp1_s3    ;if < $00, skip ahead
                  lda         #$01              ;set display mode to $01
                  sta         dsplmd            
                  lda         dlyflckr,x        ;use animation index to load next delay
                  sta         mnanidly8         
                  dex                           ;decrease animation frame delay
                  stx         flckrndx          
                  jmp         gridflckrp1_s4    

gridflckrp1_s3    inc         dsplmd            ;when the animation frame index is <$00, the display mode is changed every frame for a fast flicker of grid/dark monitor
                  lda         dsplmd            ;check display mode
                  cmp         #$21              ;if <$21, jump to select display mode
                  bcc         gridflckrp1_s4    
                  cmp         #$80              ;if <> $80, always jump to display grid
                  bne         copygrd           
                  jmp         gridflckrp1_s5    ;if = $80, skip ahead

gridflckrp1_s4    lda         dsplmd            ;check display mode (is bit 0 set or not?) and branch accordingly
                  lsr
                  bcc         stgrysq           

copygrd           lda         $60f0             ;copy current grid character data to $f0 working character
                  sta         $6780             
                  sta         $6781             
                  lda         $60f2             
                  sta         $6782             
                  sta         $6783             
                  lda         $60f4             
                  sta         $6784             
                  sta         $6785             
                  lda         $60f6             
                  sta         $6786             
                  sta         $6787             

                  jmp         ir00_e            

stgrysq           lda         #$55              ;set $f0 working character to square with multicolor #01
                  sta         $6780             
                  sta         $6781             
                  sta         $6782             
                  sta         $6783             
                  sta         $6784             
                  sta         $6785             
                  sta         $6786             
                  sta         $6787             

                  jmp         ir00_e            

gridflckrp1_s5    lda         #$1e              ;set the monitor to $1e character for the next animation part
                  sta         $4a8b             
                  sta         $4a8c             
                  sta         $4a8d             
                  sta         $4a8e             
                  sta         $4a8f             
                  sta         $4a90             
                  sta         $4a91             
                  sta         $4a92             
                  sta         $4a93             
                  sta         $4a94             
                  sta         $4a95             
                  sta         $4a96             
                  sta         $4a97             
                  sta         $4a98             
                  sta         $4a99             
                  sta         $4a9a             
                  sta         $4a9b             
                  sta         $4a9c             
                  sta         $4a9d             
                  sta         $4ab3             
                  sta         $4ab4             
                  sta         $4ab5             
                  sta         $4ab6             
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ac2             
                  sta         $4ac3             
                  sta         $4ac4             
                  sta         $4ac5             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;bring in line to build rectangle
                                                ;each aniamtion frame is executed in every screen frame so the merge with the grid is correct

RECTLNIN          cmp         #$07              ;check animation part
                  beq         rectlnin_s1       ;if not $07, skip ahead
                  jmp         RECTEXPP1         
rectlnin_s1       dec         mnanidly6         ;decrease delay
                  bne         rectlnin_s3       ;check if $00
                  lda         #$03              ;reset delay
                  sta         mnanidly6         
                  lda         rctlndx1          ;check if index for rectangle animation frame is >=$05
                  cmp         #$05              ;if not, skip ahead
                  bcc         rectlnin_s2       
                  dec         rctlndx1          ;animation frames $05 and $06 have no subframes, so only rctlndx1 needs to be decreased
                  jmp         rectlnin_s3       
rectlnin_s2       dec         rctlndx2          ;decrease subframe index
                                                ;starting with animation frame $04, there are subframes; only if 4 subframes have been processed, the next animation frame is set
                  bpl         rectlnin_s3       ;check if all 4 subframes have been procesed  (subframe index < $00)
                  lda         #$03              ;restore subframe index
                  sta         rctlndx2          
                  dec         rctlndx1          ;decrease animation frame index
                  bpl         rectlnin_s3       ;if it is < $00, animation part $07 is finished
                  lda         #$08              ;activate next animation part
                  sta         mnanipt           

                  jmp         ir00_e            

rectlnin_s3       lda         $67e2             ;set up the $fc character so it displays the full line in bytes $02,$03,$04 & $05
                  ora         #$ff              ;(needed in all animation frames except the very first)
                  sta         $67e2             
                  sta         $67e3             
                  lda         $67e4             
                  ora         #$ff              
                  sta         $67e4             
                  sta         $67e5             
                                                ;animation frame $06: draw a 4x4 square in the center of the monitor by adding the needed bits to
                                                ;the temporary grid character $fd
                  lda         rctlndx1          ;check the animation frame index
                  cmp         #$06              
                  bne         rectlnin_s4       
                  lda         #$fd              ;set 1st character in center of monitor
                  sta         $4b0c             
                  lda         $67ea             ;merge in the character data for the first animation frame character
                  ora         #$3c              
                  sta         $67ea             
                  sta         $67eb             
                  lda         $67ec             
                  ora         #$3c              
                  sta         $67ec             
                  sta         $67ed             

                  jmp         ir00_e            

                                                ;animation frame $05: set the $fc character in the center of the monitor
rectlnin_s4       cmp         #$05
                  bne         rectlninf1        
                  lda         #$fc              
                  sta         $4b0c             

                  jmp         ir00_e            
                                                ;animation frames $00-$04: expand the line by adding 2 pixel left and right on each subframe
                                                ;the animation frame index doubles as a pointer to the required screen loocations here

                                                ;animation subframe $xx.00
rectlninf1        ldy         rctlndx2          ;check subframe index
                  beq         rectlnin_s5       ;if not $00, skip ahead
                  jmp         rectlninf2        
rectlnin_s5       ldx         rctlndx1          ;in the last subframe, the $fc character is set using the animation frame index as screen location pointer
                  lda         #$fc              
                  sta         $4b07,x           ;store in screen memory for left side of the line
                  lda         #$04              ;the animation frame index is decreased, but the screen locations on the right side of the line have to be increased
                  sec                           ;therefore, subtract the index from $04 to get the proper value
                  sbc         rctlndx1          
                  tax
                  lda         #$fc              
                  sta         $4b0d,x           ;store in screen memory for left side of the line

                  jmp         ir00_e            

rectlninf2        ldx         rctlndx1          ;the temporary grid characters $fd and $fe are stored in the screen memory, using the same method as above (RECTLNINF1)
                  lda         #$fd              ;this is done in every screen frame being drawn, which would not be necessary - but there is no lack of cycles in this
                  sta         $4b07,x           ;interrupt routine - saves the effort of coding more decisions :)
                  lda         #$04              
                  sec
                  sbc         rctlndx1          
                  tax
                  lda         #$fe              
                  sta         $4b0d,x           
                                                ;animation subframe $xx.03
rectlninf21       cpy         #$03              ;check subframe index
                  bne         rectlninf22       ;if not $03, skip ahead
                  lda         $67ea             ;add bits 0 and 1 to temporary grid character used on the left side, in bytes $02-$05
                  ora         #$03              ;bytes $02/$03 and $04/$05 are identical
                  sta         $67ea             ;has to be done every screen frame in order to keep it in synch with the grid scroll
                  sta         $67eb             
                  lda         $67ec             
                  ora         #$03              
                  sta         $67ec             
                  sta         $67ed             
                  lda         $67f2             
                  ora         #$c0              ;add bits 6 and 7 to temporary grid character used on the right side, in bytes $02-$05
                  sta         $67f2             ;bytes $02/$03 and $04/$05 are identical
                  sta         $67f3             ;has to be done every screen frame in order to keep it in synch with the grid scroll
                  lda         $67f4             
                  ora         #$c0              
                  sta         $67f4             
                  sta         $67f5             

                  jmp         ir00_e            

rectlninf22       cpy         #$02              ;check subframe index
                  bne         rectlninf23       ;if not $03, skip ahead
                  lda         $67ea             ;add bits 0-3 to temporary grid character used on the left side, in bytes $02-$05
                  ora         #$0f              
                  sta         $67ea             
                  sta         $67eb             
                  lda         $67ec             
                  ora         #$0f              
                  sta         $67ec             
                  sta         $67ed             
                  lda         $67f2             ;add bits 4-7 to temporary grid character used on the right side, in bytes $02-$05
                  ora         #$f0              
                  sta         $67f2             
                  sta         $67f3             
                  lda         $67f4             
                  ora         #$f0              
                  sta         $67f4             
                  sta         $67f5             

                  jmp         ir00_e            

rectlninf23       cpy         #$01              ;check subframe index
                  bne         rectlnin_s6       ;if not $03, skip ahead

                  lda         $67ea             ;add bits 0-5 to temporary grid character used on the left side, in bytes $02-$05
                  ora         #$3f              
                  sta         $67ea             
                  sta         $67eb             
                  lda         $67ec             
                  ora         #$3f              
                  sta         $67ec             
                  sta         $67ed             
                  lda         $67f2             ;add bits 2-7 to temporary grid character used on the right side, in bytes $02-$05
                  ora         #$fc              
                  sta         $67f2             
                  sta         $67f3             
                  lda         $67f4             
                  ora         #$fc              
                  sta         $67f4             
                  sta         $67f5             

rectlnin_s6       jmp         ir00_e

;============================================================================================================================================================
                                                ;expand the line vertically to create the complete rectangle - part 1

RECTEXPP1         lda         mnanipt           ;check animation part
                  cmp         #$08              ;if not $08, skip ahead
                  beq         rectexpp1_s1      
                  jmp         RECTROTP11        
rectexpp1_s1      dec         mnanidly7
                  bne         rectexpp1f8       
                  lda         #$03              
                  sta         mnanidly7         
                  dec         rctexdx1          
                  bpl         rectexpp1_s2      
                  lda         #$09              ;activate next animation part
                  sta         mnanipt           

                  jmp         ir00_e            

rectexpp1_s2      bne         rectexpp1f8
                  lda         #$80              
                  sta         mnanidly7         

rectexpp1f8       lda         rctexdx1
                  cmp         #$08              
                  bne         rectexpp1f7       
                  lda         #$8c              
                  sta         $4b07             
                  lda         #$8d              
                  sta         $4b11             
                  lda         #$6c              
                  ldx         #$08              
                  sta         $4b08,x           
                  dex
                  bpl         *-4               

                  jmp         ir00_e            

rectexpp1f7       cmp         #$07
                  bne         rectexpp1f6       
                  lda         #$fc              ;top row w/ temp grid char
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  lda         #$50              ;middle row
                  sta         $4b07             
                  lda         #$48              
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  lda         #$4c              
                  sta         $4b11             

                  jmp         ir00_e            

rectexpp1f6       cmp         #$06
                  bne         rectexpp1f5       
                  lda         #$51              ;top row
                  sta         $4adf             
                  lda         #$52              
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  lda         #$53              
                  sta         $4ae9             
                  lda         #$89              ;bottom row
                  sta         $4b2f             
                  lda         #$88              
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  lda         #$87              
                  sta         $4b39             
                  lda         $60f0             ;char merge
                  sta         $6288             
                  sta         $6289             
                  sta         $6290             
                  sta         $6291             
                  sta         $6298             
                  sta         $6299             

                  jmp         ir00_e            

rectexpp1f5       cmp         #$05
                  bne         rectexpp1f4       
                  lda         #$90              ;top row
                  sta         $4adf             
                  lda         #$83              
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  lda         #$91              
                  sta         $4ae9             
                  lda         #$92              ;bottom row
                  sta         $4b2f             
                  lda         #$7d              
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  lda         #$93              
                  sta         $4b39             

                  jmp         ir00_e            

rectexpp1f4       cmp         #$04
                  bne         rectexpp1f3       
                  lda         #$49              ;top row
                  sta         $4adf             
                  lda         #$4a              
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  lda         #$4b              
                  sta         $4ae9             
                  lda         #$4f              ;bottom row
                  sta         $4b2f             
                  lda         #$4e              
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  lda         #$4d              
                  sta         $4b39             

                  jmp         ir00_e            

rectexpp1f3       cmp         #$03
                  bne         rectexpp1f2       
                  lda         #$50              ;finished upper row
                  sta         $4adf             
                  lda         #$48              
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  lda         #$4c              
                  sta         $4ae9             
                  lda         #$50              ;finished lower row
                  sta         $4b2f             
                  lda         #$48              
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  lda         #$4c              
                  sta         $4b39             

                  jmp         ir00_e            

rectexpp1f2       cmp         #$02
                  bne         rectexpp1f1       
                  lda         #$51              ;top row
                  sta         $4ab7             
                  lda         #$52              
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  lda         #$53              
                  sta         $4ac1             
                  lda         #$89              ;bottom row
                  sta         $4b57             
                  lda         #$88              
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  lda         #$87              
                  sta         $4b61             

                  jmp         ir00_e            

rectexpp1f1       cmp         #$01
                  bne         rectexpp1f0       
                  lda         #$90              ;top row
                  sta         $4ab7             
                  lda         #$83              
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  lda         #$91              
                  sta         $4ac1             
                  lda         #$92              ;bottom row
                  sta         $4b57             
                  lda         #$7d              
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  lda         #$93              
                  sta         $4b61             

                  jmp         ir00_e            

rectexpp1f0       lda         #$49              ;top row
                  sta         $4ab7             
                  lda         #$4a              
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  lda         #$4b              
                  sta         $4ac1             
                  lda         #$4f              ;bottom row
                  sta         $4b57             
                  lda         #$4e              
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  lda         #$4d              
                  sta         $4b61             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;draw 3d rotating rectangle part 1.1
                                                ;to avoid timing drawing the next horizontal line while drawing the animation frames, the routine is split into 4 parts

RECTROTP11        cmp         #$09              ;check animation part
                  beq         rectrotp11_s1     ;if not $09, skip ahead
                  cmp         #$0f              
                  beq         rectrotp11_s1     ;if not $0f, skip ahead
                  jmp         EYEANI            
rectrotp11_s1     dec         mnanidly5         ;check if delay has reached zero (note if yes, reset happens in RECTROT2)
                  beq         rectrotp11_s2     

                  jmp         ir00_e            ;if not, skip ahead

rectrotp11_s2     dec         rtrctndx
                  bpl         rectrotp11_s3     
                  lda         #$06              ;reset index for animation frame to $06
                  sta         rtrctndx          
rectrotp11_s3     dec         rtrctdur          ;decrease duration counter
                  beq         rectrotp11_s4     ;skip ahead if counter is not $00

                  jmp         rectrotp11f6      

rectrotp11_s4     lda         #$00              ;restore variables for finished animation part
                  sta         rtrctndx          
                  lda         mnanipt           ;activate next animation part
                  cmp         #$09              ;since this routine is used for parts $09 and $0f, it has to be checked what next part is
                  beq         rectrotp11_s5     
                  lda         #$50              ;set initial delay for part $10              
                  sta         tmngdly
                  lda         #$10              ;set next animation part
                  ldx         #$a8              ;set delay needed for sound timing before start of part $09
                  ldy         #$33              ;set number of rectangle rotations needed in part $09   

                  jmp         rectrotp11_s6 
    
rectrotp11_s5     lda         #$0a              ;set next animation part
                  ldx         #$80              ;set delay needed for sound timing before start of part $0f
                  ldy         #$56              ;set number of rectangle rotations needed in part $0f   
                  
rectrotp11_s6     sta         mnanipt           ;next animation part
                  stx         mnanidly5         ;delay rotating rectangle   
                  sty         rtrctdur          ;duration rectangle rotation          
                  
                  jmp         ir00_e            

                                                ;draw animation frame $06
rectrotp11f6      lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if not $06, skip ahead
                  bne         rectrotp11f5      
                  lda         #$1e              
                  sta         $4ab6             
                  sta         $4ac2             
                  sta         $4ade             
                  sta         $4aea             
                  lda         #$48              
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             

                  jmp         ir00_e            

                                                ;draw animation frame $05
rectrotp11f5      cmp         #$05              ;check the current animation frame
                  bne         rectrotp11f4      ;if not $05, skip ahead
                  lda         #$1e              
                  sta         $4ab7             
                  sta         $4ac1             
                  lda         #$51              
                  sta         $4ab8             
                  lda         #$52              
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             

                  jmp         ir00_e            

                                                ;draw animation frame $04
rectrotp11f4      cmp         #$04              ;check the current animation frame
                  bne         rectrotp11f3      ;if not $04, skip ahead
                  lda         #$1e              
                  sta         $4ab5             
                  sta         $4ab6             
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ac2             
                  sta         $4ac3             
                  sta         $4b55             
                  sta         $4b56             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  sta         $4b62             
                  sta         $4b63             

                  jmp         ir00_e            

                                                ;draw animation frame $03
rectrotp11f3      cmp         #$03              ;check the current animation frame
                  bne         rectrotp11f2      ;if not $03, skip ahead
                  lda         #$1e              
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             

                  jmp         ir00_e            

                                                ;draw animation frame $02
rectrotp11f2      cmp         #$02              ;check the current animation frame
                  bne         rectrotp11f1      ;if not $02, skip ahead
                  lda         #$6f              
                  sta         $4b03             
                  lda         #$70              
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b13             
                  sta         $4b14             

                  jmp         ir00_e            

                                                ;draw animation frame $01
rectrotp11f1      cmp         #$01              ;check the current animation frame
                  bne         rectrotp11f0      ;if not $01, skip ahead
                  lda         #$1e              
                  sta         $4b03             
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b13             
                  sta         $4b14             
                  sta         $4b15             
                  lda         #$75              
                  sta         $4add             
                  lda         #$76              
                  sta         $4ade             
                  lda         #$4a              
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             

                  jmp         ir00_e            

                                                ;draw animation frame $00
rectrotp11f0      lda         #$82
                  sta         $4ab6             
                  lda         #$83              
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  lda         #$84              
                  sta         $4ac2             
                  lda         #$8a              
                  sta         $4ade             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;display eye in pyramid and have it blink

EYEANI            cmp         #$0c              ;check current animation part
                  beq         eyeani_s1         ;if not $0c, skip ahead

                  jmp         STPWVYPXLSCRL1    

eyeani_s1         lda         $d027             ;save current color of scroller sprites
                  sta         tmpscrlcol        
                  lda         #$00              ;turn off x/y expansion
                  sta         $d017             
                  sta         $d01d             
                  sta         $d027             ;set sprite $00 color to black
                  lda         #$b1              ;set x coordinate for sprites $00,$01,$02
                  sta         $d000             
                  sta         $d002             
                  sta         $d004             
                  lda         #$cb              ;set y coordinate for sprites $00,$01,$02
                  sta         $d001             
                  sta         $d003             
                  sta         $d005             
                  lda         #$01              ;set sprite $01 color to white
                  sta         $d028             
                  lda         #$0e              ;set sprite $02 color to light blue
                  sta         $d029             

                  dec         mnanidly11        ;decrease delay
                  bne         eyeani_s3         ;if not $0, skip ahead
                  dec         eyendx            ;decrease animation frame index
                  bmi         eyeani_s2         ;if < $00, skip ahead
                  lda         #$06              ;restore delay for blink animation frames
                  sta         mnanidly11        
                  jmp         eyeani_s3         
eyeani_s2         dec         eyedur            ;decrease duration (check if duration has passed is done @ EYEANI2
                  lda         #$05              ;restore animation frame index
                  sta         eyendx            
                  lda         #$6e              ;restore delay for unblinking eye
                  sta         mnanidly11        

eyeani_s3         lda         eyendx            ;check for animation frame
                  cmp         #$05              
                  bne         eyeani_2          
eyeani_1          lda         #$6e              ;set sprite pointers for animation frame $05
                  sta         $4bf8             
                  lda         #$6f              
                  sta         $4bf9             
                  lda         #$70              
                  sta         $4bfa             

                  jmp         ir00_e            

eyeani_2          cmp         #$04
                  beq         eyeani_s4         
                  cmp         #$00              
                  bne         eyeani_3          
eyeani_s4         lda         #$71              ;set sprite pointers for animation frame $04,$00
                  sta         $4bf8             
                  lda         #$72              
                  sta         $4bf9             
                  lda         #$70              
                  sta         $4bfa             

                  jmp         ir00_e            

eyeani_3          cmp         #$03
                  beq         eyeani_s5         
                  cmp         #$01              
                  bne         eyeani_4          
eyeani_s5         lda         #$73              ;set sprite pointers for animation frame $03,$01
                  sta         $4bf8             
                  lda         #$74              
                  sta         $4bf9             
                  lda         #$75              
                  sta         $4bfa             

                  jmp         ir00_e            

eyeani_4          lda         #$76              ;set sprite pointers for animation frame $02
                  sta         $4bf8             
                  lda         #$76              
                  sta         $4bf9             
                  lda         #$76              
                  sta         $4bfa             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;set up monitor for wavy pixel scroll (animation part $15)

STPWVYPXLSCRL1    cmp         #$14              ;check current animation part
                  beq         stpwvypxlscrl1_1  ;if not $014, skip ahead

                  jmp         WHTNS1            

stpwvypxlscrl1_1  lda         #$eb              ;set character $eb for all pixel rows
                  sta         $4ab3             
                  sta         $4ab4             
                  sta         $4ab5             
                  sta         $4ab6             
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ac2             
                  sta         $4ac3             
                  sta         $4ac4             
                  sta         $4ac5             
                  sta         $4adb             
                  sta         $4adc             
                  sta         $4add             
                  sta         $4ade             
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;display white noise character 1
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS1            cmp         #$16              ;check current animation part
                  beq         whtns1_1          ;if not $016, skip ahead

                  jmp         FLLMNTR1          

whtns1_1          lda         $dab3             ;12 bytes of color memory are left white by the rotating rectangle animation - they need to be set to black before
                  and         #$0f              ;the white noise animation can be displayed properly
                  cmp         #$09              
                  bne         whtns1_2          
                  lda         #$08              ;load color code for multicolor black
                  sta         $dab3             ;store in color memory locations
                  sta         $dab4             
                  sta         $dab5             
                  sta         $dac3             
                  sta         $dac4             
                  sta         $dac5             
                  sta         $db53             
                  sta         $db54             
                  sta         $db55             
                  sta         $db63             
                  sta         $db64             
                  sta         $db65             

whtns1_2          dec         whtnsdly          ;check delay
                  bne         whtns1_3          ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a8b             
                  sta         $4a90             
                  sta         $4a9d             
                  sta         $4ab4             
                  sta         $4abe             
                  sta         $4adb             
                  sta         $4adf             
                  sta         $4ae4             
                  sta         $4ae8             
                  sta         $4aec             
                  sta         $4b07             
                  sta         $4b11             
                  sta         $4b2d             
                  sta         $4b2f             
                  sta         $4b55             
                  sta         $4b5c             
                  sta         $4b5f             
                  sta         $4b61             
                  sta         $4b65             
                  sta         $4b7d             
                  sta         $4b84             
                  sta         $4b87             

                  dec         whtnsndx          ;decrease index for fetching characters codes

whtns1_3          jmp         ir00_e

;============================================================================================================================================================
                                                ;fill the complete monitor with the same char

FLLMNTR1          cmp         #$17              ;check current animation part
                  beq         fllmntr1_1        ;start routine if $17

                  jmp         RSTRT1            

fllmntr1_1        lda         #$f1
                  sta         $4a8b             ;monitor row 0
                  sta         $4a8c             
                  sta         $4a8d             
                  sta         $4a8e             
                  sta         $4a8f             
                  sta         $4a90             
                  sta         $4a91             
                  sta         $4a92             
                  sta         $4a93             
                  sta         $4a94             
                  sta         $4a95             
                  sta         $4a96             
                  sta         $4a97             
                  sta         $4a98             
                  sta         $4a99             
                  sta         $4a9a             
                  sta         $4a9b             
                  sta         $4a9c             
                  sta         $4a9d             

                  sta         $4ab3             ;monitor row 1
                  sta         $4ab4             
                  sta         $4ab5             
                  sta         $4ab6             
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ac2             
                  sta         $4ac3             

                  jmp         ir00_e            

;============================================================================================================================================================
                                                ;restore all variables and other data so monitor animation can restart

RSTRT1            cmp         #$18              ;check current animation part
                  beq         rstrt1_1          ;start routine if $18

                  jmp         ir00_e            

rstrt1_1          dec         rstrtdly
                  bne         rstrt1_1_1
                  dec         durexp2
                  bmi         rstrt1_2            

rstrt1_1_1        jmp         ir00_e            

rstrt1_2          lda         #$f2              ;reset the character codes in the first column of the monitor
                  sta         $4a8b             
                  sta         $4ab3             
                  sta         $4adb             
                  sta         $4b03             
                  sta         $4b2b             
                  sta         $4b53             
                  sta         $4b7b             
                  lda         #$55              ;restore $f0 and $f2 characters to their original state needed for MONWIPEIN and MONWIPEOUT*
                  sta         $6780             
                  sta         $6781             
                  sta         $6782             
                  sta         $6783             
                  sta         $6784             
                  sta         $6785             
                  sta         $6786             
                  sta         $6787             
                  sta         $6790             
                  sta         $6791             
                  sta         $6792             
                  sta         $6793             
                  sta         $6794             
                  sta         $6795             
                  sta         $6796             
                  sta         $6797             
                  lda         #$ff              ;restore $25-$27 characters to their original state (bytes $04 and $05 where changed by MONWIPEOUT*)
                  sta         $612c             
                  sta         $612d             
                  sta         $6134             
                  sta         $6135             
                  sta         $613c             
                  sta         $613d             

;============================================================================================================================================================

ir00_e            lda         #$34              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir01            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir01            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir01              lda         #<ir01_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir01_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir01 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir01_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir01_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $35

ir01_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $36
                                                ;=> 1-2 cycles have passed
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT raster line
                  sta         $d020             ;(4 cycles) reset border color

;============================================================================================================================================================
                                                ;display sawtooth part 2

DISPSAW2          lda         mnanipt           ;check current monitor animation part
                  beq         dispsaw2_1        ;if not between $01 or $04, skip
                  cmp         #$05              
                  bcc         dispsaw2_2        
dispsaw2_1        jmp         GRIDFLCKRP2
                                                ;merge grid & sawtooth characters
                                                ;character $21 > $f8 (part 2 - continued from DISPSAWTP3)
dispsaw2_2        lda         $610c             ;byte 4
                  ora         $60f4             
                  sta         $67c4             
                  sta         $67c5             
                  lda         $610e             ;byte 6
                  ora         $60f6             
                  sta         $67c6             
                  sta         $67c7             
                                                ;character $23 > $fa
                  lda         $6118             ;byte 0
                  ora         $60f0             
                  sta         $67d0             
                  sta         $67d1             
                  lda         $611a             ;byte 2
                  ora         $60f2             
                  sta         $67d2             
                  sta         $67d3             
                  lda         $611c             ;byte 4
                  ora         $60f4             
                  sta         $67d4             
                  sta         $67d5             
                  lda         $611e             ;byte 6
                  ora         $60f6             
                  sta         $67d6             
                  sta         $67d7             
                                                ;character $22 > $f9
                  lda         $6110             ;byte 0
                  ora         $60f0             
                  sta         $67c8             
                  sta         $67c9             
                  lda         $6112             ;byte 2
                  ora         $60f2             
                  sta         $67ca             
                  sta         $67cb             
                  lda         $6114             ;byte 4
                  ora         $60f4             
                  sta         $67cc             
                  sta         $67cd             
                  lda         $6116             ;byte 6
                  ora         $60f6             
                  sta         $67ce             
                  sta         $67cf             
                                                ;character $24 > $fb
                  lda         $6120             ;byte 0
                  ora         $60f0             
                  sta         $67d8             
                  sta         $67d9             
                  lda         $6122             ;byte 2
                  ora         $60f2             
                  sta         $67da             
                  sta         $67db             
                  lda         $6124             ;byte 4
                  ora         $60f4             
                  sta         $67dc             
                  sta         $67dd             
                  lda         $6126             ;byte 6
                  ora         $60f6             
                  sta         $67de             
                  sta         $67df             

                  jmp         ir01_e            

;============================================================================================================================================================
                                                ;flicker in the scrolling grid part 2

GRIDFLCKRP2       cmp         #$06              ;check animation part
                  beq         gridflckrp2_s1    ;if not $06, skip ahead
                  jmp         RECTEXPP2         
gridflckrp2_s1    lda         dsplmd            ;check display mode - if not = $80, the animation is still running; skip ahead
                  cmp         #$80              
                  beq         gridflckrp2_s2    

                  jmp         ir01_e            

gridflckrp2_s2    lda         #$1e              ;display mode = $80 - continue setting the monitor to $1e character for the next animation part
                  sta         $4adb             
                  sta         $4adc             
                  sta         $4add             
                  sta         $4ade             
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4aec             
                  sta         $4aed             
                  sta         $4b03             
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b06             
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  sta         $4b11             
                  sta         $4b12             
                  sta         $4b13             
                  sta         $4b14             
                  sta         $4b15             
                  sta         $4b2b             
                  sta         $4b2c             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             
                  sta         $4b3c             
                  sta         $4b3d             

                  jmp         ir01_e            

;============================================================================================================================================================
                                                ;expand the line vertically to create the complete rectangle cont'd

RECTEXPP2         lda         mnanipt
                  cmp         #$08              
                  beq         rectexpp2f5       
                  jmp         RECTROTP12        

rectexpp2f5       lda         rctexdx1
                  cmp         #$07              
                  bne         rectexpp2f4       
                  lda         #$fd              ;bottom row w/ temp grid char
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  lda         #$ff              ;char merge
                  sta         $67e6             
                  sta         $67e7             
                  sta         $67e8             
                  sta         $67e9             

                  jmp         ir01_e            

rectexpp2f4       cmp         #$06
                  bne         rectexpp2f3       
                  lda         $60f2             ;char merge
                  sta         $628a             
                  sta         $628b             
                  sta         $6292             
                  sta         $6293             
                  sta         $629a             
                  sta         $629b             
                  lda         $60f4             
                  sta         $643c             
                  sta         $643d             
                  sta         $6444             
                  sta         $6445             
                  sta         $644c             
                  sta         $644d             
                  lda         $60f6             
                  sta         $643e             
                  sta         $643f             
                  sta         $6446             
                  sta         $6447             
                  sta         $644e             
                  sta         $644f             

                  jmp         ir01_e            

rectexpp2f3       cmp         #$05
                  bne         rectexpp2f2       
                  lda         $60f0             ;merge chars
                  sta         $6480             
                  sta         $6481             
                  sta         $6418             
                  sta         $6419             
                  sta         $6488             
                  sta         $6489             
                  lda         $60f6             
                  sta         $63ee             
                  sta         $63ef             
                  sta         $64ae             
                  sta         $64af             

                  jmp         ir01_e            

rectexpp2f2       cmp         #$03
                  bne         rectexpp2f1       
                  lda         #$fc              ;top row w/ temp grid char
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  lda         #$fd              ;bottom row w/ temp grid char
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  lda         #$ff              ;char merge
                  sta         $67e6             
                  sta         $67e7             
                  sta         $67e8             
                  sta         $67e9             

                  jmp         ir01_e            

rectexpp2f1       cmp         #$02
                  bne         rectexpp2f0       
                  lda         $60f0             ;char merge
                  sta         $6288             
                  sta         $6289             
                  sta         $6290             
                  sta         $6291             
                  sta         $6298             
                  sta         $6299             
                  lda         $60f2             
                  sta         $628a             
                  sta         $628b             
                  sta         $6292             
                  sta         $6293             
                  sta         $629a             
                  sta         $629b             
                  lda         $60f4             
                  sta         $643c             
                  sta         $643d             
                  sta         $6444             
                  sta         $6445             
                  sta         $644c             
                  sta         $644d             
                  lda         $60f6             
                  sta         $643e             
                  sta         $643f             
                  sta         $6446             
                  sta         $6447             
                  sta         $644e             
                  sta         $644f             

                  jmp         ir01_e            

rectexpp2f0       cmp         #$01
                  bne         rectexpp2_s1      
                  lda         $60f0             ;merge chars
                  sta         $6480             
                  sta         $6481             
                  sta         $6418             
                  sta         $6419             
                  sta         $6488             
                  sta         $6489             
                  lda         $60f6             
                  sta         $6496             
                  sta         $6497             
                  sta         $63ee             
                  sta         $63ef             
                  sta         $649e             
                  sta         $649f             

rectexpp2_s1      jmp         ir01_e

;============================================================================================================================================================
                                                ;draw 3d rotating rectangle part 1.2

RECTROTP12        cmp         #$09              ;check animation part
                  beq         rectrotp12_s1     ;if not $09, skip ahead
                  cmp         #$0f              
                  beq         rectrotp12_s1     ;if not $0f, skip ahead

                  jmp         STPWVYPXLSCRL2    

rectrotp12_s1     lda         mnanidly5         ;check if delay has reached zero
                  beq         rectrotp12f6      

                  jmp         ir01_e            ;if not, skip ahead

                                                ;draw animation frame $06
rectrotp12f6      lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if not $06, skip ahead
                  bne         rectrotp12f5      
                  lda         #$49              
                  sta         $4ab7             
                  lda         #$4a              
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  lda         #$4b              
                  sta         $4ac1             
                  lda         #$4c              
                  sta         $4ae9             
                  sta         $4b11             
                  sta         $4b39             
                  lda         #$4f              
                  sta         $4b57             

                  jmp         ir01_e            

                                                ;draw animation frame $05
rectrotp12f5      cmp         #$05              ;check the current animation frame
                  bne         rectrotp12f4      ;if not $05, skip ahead
                  lda         #$53              
                  sta         $4ac0             
                  lda         #$54              
                  sta         $4ae9             
                  sta         $4b3a             
                  lda         #$55              
                  sta         $4b11             
                  lda         #$48              
                  sta         $4b2f             
                  sta         $4b39             
                  lda         #$58              
                  sta         $4b56             

                  jmp         ir01_e            

                                                ;draw animation frame $04
rectrotp12f4      cmp         #$04              ;check the current animation frame
                  bne         rectrotp12f3      ;if not $04, skip ahead
                  lda         #$5b              
                  sta         $4adf             
                  lda         #$5c              
                  sta         $4ae0             
                  lda         #$5d              
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             

                  jmp         ir01_e            

                                                ;draw animation frame $03
rectrotp12f3      cmp         #$03              ;check the current animation frame
                  bne         rectrotp12f2      ;if not $03, skip ahead
                  lda         #$1e              
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             

                  jmp         ir01_e            

                                                ;draw animation frame $02
rectrotp12f2      cmp         #$02              ;check the current animation frame
                  bne         rectrotp12f1      ;if not $02, skip ahead
                  lda         #$71              
                  sta         $4b06             

                  jmp         ir01_e            

                                                ;draw animation frame $01
rectrotp12f1      cmp         #$01              ;check the current animation frame
                  bne         rectrotp12f0      ;if not $01, skip ahead
                  lda         #$77              
                  sta         $4aea             
                  lda         #$78              
                  sta         $4aeb             
                  lda         #$81              
                  sta         $4b06             
                  lda         #$80              
                  sta         $4b07             

                  jmp         ir01_e            

                                                ;draw animation frame $00
rectrotp12f0      lda         #$48
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             

                  jmp         ir01_e            

;============================================================================================================================================================
                                                ;continue setting up monitor for wavy pixel scroll (animation part $15)

STPWVYPXLSCRL2    cmp         #$14              ;check current animation part
                  beq         stpwvypxlscrl2_1  ;if not $014, skip ahead

                  jmp         WHTNS2            

stpwvypxlscrl2_1  lda         #$eb              ;set character $eb for all pixel rows
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4aec             
                  sta         $4aed             
                  sta         $4b03             
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b06             
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  sta         $4b11             
                  sta         $4b12             
                  sta         $4b13             
                  sta         $4b14             
                  sta         $4b15             
                  sta         $4b2b             
                  sta         $4b2c             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             

                  jmp         ir01_e            

;============================================================================================================================================================
                                                ;display white noise character 2
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS2            cmp         #$16              ;check current animation part
                  beq         whtns2_1          ;if not $016, skip ahead

                  jmp         FLLMNTR2          

whtns2_1          lda         $db53             ;6 bytes of color memory are left PRPL by the CLRSAW* routines - they need to be set to black before
                  and         #$0f              ;the white noise animation can be displayed properly
                  cmp         #$0c              
                  bne         whtns2_2          
                  lda         #$08              ;load color code for multicolor black
                  sta         $db53             ;store in color memory locations
                  sta         $db54             
                  sta         $db55             
                  sta         $db63             
                  sta         $db64             
                  sta         $db65             

whtns2_2          lda         whtnsdly          ;check delay
                  bne         whtns2_3          ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a8f             
                  sta         $4a95             
                  sta         $4ab3             
                  sta         $4ab5             
                  sta         $4abd             
                  sta         $4abf             
                  sta         $4ae2             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4b06             
                  sta         $4b08             
                  sta         $4b10             
                  sta         $4b12             
                  sta         $4b2c             
                  sta         $4b3b             
                  sta         $4b57             
                  sta         $4b7f             
                  sta         $4b80             
                  sta         $4b81             
                  sta         $4b83             
                  sta         $4b86             
                  sta         $4b88             

                  dec         whtnsndx          ;decrease index for fetching characters codes

whtns2_3          jmp         ir01_e

;============================================================================================================================================================
                                                ;fill the complete monitor with the same char

FLLMNTR2          cmp         #$17              ;check current animation part
                  beq         fllmntr2_1        ;start routine if $17

                  jmp         RSTRT2            

fllmntr2_1        lda         #$f1
                  sta         $4ac4             ;monitor row 1             
                  sta         $4ac5
                  sta         $4adb             ;monitor row 2
                  sta         $4adc             
                  sta         $4add             
                  sta         $4ade             
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4aec             
                  sta         $4aed             
                  sta         $4b03             ;monitor row 3
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b06             
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  sta         $4b11             

                  jmp         ir01_e            

;============================================================================================================================================================
                                                ;restore all variables and other data so monitor animation can restart


RSTRT2            cmp         #$18              ;check current animation part
                  beq         rstrt2_1          ;start routine if $18

                  jmp         ir01_e            

rstrt2_1          lda         durexp2
                  bmi         rstrt2_2          

                  jmp         ir01_e            

rstrt2_2          lda         #$03              ;restore animation part variables
                  sta         wpinndx           
                  lda         #$00              
                  sta         mcolndx           
                  sta         wldlnndx          
                  lda         grdscrldly        ;the wipe delay must be synced with the delay for the grid scroll
                  sta         wpindly           
                  lda         #$06              
                  sta         rctlndx1          
                  lda         #$03              
                  sta         rctlndx2          
                  lda         #$08              
                  sta         rctexdx1          
                  lda         #$07              
                  sta         pyrpxlondx        
                  lda         #$06              
                  sta         rw2prcss          
                  lda         #$00              
                  sta         ln2prcss          
                  sta         pxlwvsubpt        
                  lda         #$03              
                  sta         whtnsdur          
                  lda         #$07              
                  sta         pyrpxlndx         
                  sta         swtchffndx        
                  lda         #$50              
                  sta         indly             
                  lda         #$01              
                  sta         dlymvmt           
                  lda         #$02              
                  sta         dlyrt             
                  lda         #$a4              
                  sta         sqsprtx1          
                  sta         sqsprtx2          
                  lda         #$ba              
                  sta         sqsprty           
                  lda         #$15              
                  sta         sqrtdur           
                  lda         #$ac               
                  sta         whtnsdly

;============================================================================================================================================================

ir01_e            lda         #$3c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir02            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir02            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir02              lda         #<ir02_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir02_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir02 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir02_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir02_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $3D
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir02_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

                  ldy         #$08              ;(2 cycles)
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $3E
                                                ;=> 1-2 cycles have passed

                  lda         $d00f             ;(4 cycles) check if sprite 7 (electric arc) is displayed on the NEXT line
                  cmp         #$3d              ;(2 cycles)
                  bne         ir02_2            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 IS displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles)
                  bne         ir02_3            ;(3 cycles) branch is always taken

ir02_2            nop                           ;(2 cycles)
                  ldy         #$08              ;(2 cycles)
ir02_3            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)

                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if Sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;display sawtooth part 3

DISPSAW3          ldx         mnanipt           ;check current monitor animation part
                  beq         dispsaw3_1        ;if not $01, $02 or $03 skip
                  cpx         #$04              
                  bcc         dispsaw3_2        
dispsaw3_1        jmp         GRIDFLCKRP3
dispsaw3_2        dec         swtindly          ;check delay for animation
                  beq         dispsaw3_3        ;skip ahead if not $00

                  jmp         ir02_e            

                                                ;draw sawtooth for monitor rows 1, 3 & 5
                                                ;6 differenct characters are used in each row
dispsaw3_3        ldx         swtanindx         ;load offset for fetching sawtooth characters
                  cpx         #$05              ;if the offset is <$05, it needs to be reset
                  bcs         dispsaw3_4        
                  ldx         #$0a              
                  stx         swtanindx         
dispsaw3_4        lda         swtrwd1+3,x       ;load & store character data for sawtooth row 3
                  sta         $4b08             
                  sta         $4b0e             
                  sta         $4b14             
                  lda         swtrwd1,x         ;load & store character data for sawtooth rows 1 and 5
                  sta         $4ab8             ;row 1
                  sta         $4abe             
                  sta         $4ac4             
                  sta         $4b58             ;row 5
                  sta         $4b5e             
                  sta         $4b64             
                  dex
                  lda         swtrwd1+3,x       ;row 3
                  sta         $4b07             
                  sta         $4b0d             
                  sta         $4b13             
                  lda         swtrwd1,x         
                  sta         $4ab7             ;row 1
                  sta         $4abd             
                  sta         $4ac3             
                  sta         $4b57             ;row 5
                  sta         $4b5d             
                  sta         $4b63             
                  dex
                  lda         swtrwd1+3,x       ;row 3
                  sta         $4b06             
                  sta         $4b0c             
                  sta         $4b12             
                  lda         swtrwd1,x         
                  sta         $4ab6             ;row 1
                  sta         $4abc             
                  sta         $4ac2             
                  sta         $4b56             ;row 5
                  sta         $4b5c             
                  sta         $4b62             
                  dex
                  lda         swtrwd1+3,x       ;row 3
                  sta         $4b05             
                  sta         $4b0b             
                  sta         $4b11             
                  lda         swtrwd1,x         
                  sta         $4ab5             ;row 1
                  sta         $4abb             
                  sta         $4ac1             
                  sta         $4b55             ;row 5
                  sta         $4b5b             
                  sta         $4b61             
                  stx         swtanindx         

                  jmp         ir02_e            

;============================================================================================================================================================
                                                ;flicker in the scrolling grid part 3

GRIDFLCKRP3       cpx         #$06              ;check animation part
                  beq         gridflckrp3_s1    ;if not $06, skip ahead
                  jmp         RECTROTP21        
gridflckrp3_s1    lda         dsplmd            ;check display mode - if not = $80, the animation is still running; skip ahead
                  cmp         #$80              
                  beq         gridflckrp3_s2    

                  jmp         ir02_e            

gridflckrp3_s2    lda         #$07              ;display mode = $80 - activate next animation part
                  sta         mnanipt           
                  lda         #$00              ;restore variables for finished animation part
                  sta         dsplmd            
                  lda         #$28              
                  sta         mnanidly8         
                  lda         #$09              
                  sta         flckrndx          
                  lda         #$1e              ;continue setting the monitor to $1e character for the next animation part
                  sta         $4b53             
                  sta         $4b54             
                  sta         $4b55             
                  sta         $4b56             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  sta         $4b62             
                  sta         $4b63             
                  sta         $4b64             
                  sta         $4b65             
                  sta         $4b7b             
                  sta         $4b7c             
                  sta         $4b7d             
                  sta         $4b7e             
                  sta         $4b7f             
                  sta         $4b80             
                  sta         $4b81             
                  sta         $4b82             
                  sta         $4b83             
                  sta         $4b84             
                  sta         $4b85             
                  sta         $4b86             
                  sta         $4b87             
                  sta         $4b88             
                  sta         $4b89             
                  sta         $4b8a             
                  sta         $4b8b             
                  sta         $4b8c             
                  sta         $4b8d             

                  jmp         ir02_e            

;============================================================================================================================================================
                                                ;draw 3d rotating rectangle part 2.1

RECTROTP21        cpx         #$09              ;check animation part
                  beq         rectrotp21_s1     ;if not $09, skip ahead
                  cpx         #$0f              
                  beq         rectrotp21_s1     ;if not $0f, skip ahead

                  jmp         STPWVYPXLSCRL3    

rectrotp21_s1     lda         mnanidly5         ;check if delay has reached zero
                  beq         rectrotp21f6      

                  jmp         ir02_e            ;if not, skip ahead

                                                ;draw animation frame $06
rectrotp21f6      lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if not $06, skip ahead
                  bne         rectrotp21f5      
                  lda         #$4e              
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             

                  jmp         ir02_e            

                                                ;draw animation frame $05
rectrotp21f5      cmp         #$05              ;check the current animation frame
                  bne         rectrotp21f4      ;if not $05, skip ahead
                  lda         #$57              
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             

                  jmp         ir02_e            

                                                ;draw animation frame $04 cont'd
rectrotp21f4      cmp         #$04              ;check the current animation frame
                  bne         rectrotp21f3      ;if not $04, skip ahead
                  lda         #$5e              
                  sta         $4ae8             
                  lda         #$5f              
                  sta         $4ae9             
                  lda         #$60              
                  sta         $4b11             
                  lda         #$61              
                  sta         $4b12             
                  lda         #$65              
                  sta         $4b2d             
                  lda         #$64              
                  sta         $4b2e             
                  lda         #$4e              
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             

                  jmp         ir02_e            

                                                ;draw animation frame $03 cont'd
rectrotp21f3      cmp         #$03              ;check the current animation frame
                  bne         rectrotp21f2      ;if not $03, skip ahead
                  lda         #$68              
                  sta         $4b03             
                  lda         #$69              
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b13             
                  sta         $4b14             
                  lda         #$6a              
                  sta         $4b06             
                  lda         #$6b              
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b10             
                  sta         $4b11             

                  jmp         ir02_e            

                                                ;draw animation frame $02 cont'd
rectrotp21f2      cmp         #$02              ;check the current animation frame
                  bne         rectrotp21f1      ;if not $02, skip ahead
                  lda         #$72              
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b10             
                  sta         $4b11             

                  jmp         ir02_e            

                                                ;draw animation frame $01 cont'd
rectrotp21f1      cmp         #$01              ;check the current animation frame
                  bne         rectrotp21f0      ;if not $01, skip ahead
                  lda         #$48              
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  lda         #$7a              
                  sta         $4b11             
                  lda         #$79              
                  sta         $4b12             
                  lda         #$7f              
                  sta         $4b2f             
                  lda         #$7e              
                  sta         $4b30             

                  jmp         ir02_e            

                                                ;draw animation frame $00 cont'd
rectrotp21f0      lda         #$85
                  sta         $4aea             
                  sta         $4b39             
                  lda         #$1e              
                  sta         $4add             
                  sta         $4aeb             
                  sta         $4b06             
                  sta         $4b12             
                  lda         #$8b              
                  sta         $4b07             
                  lda         #$86              
                  sta         $4b11             
                  lda         #$8a              
                  sta         $4b2f             
                  lda         #$89              
                  sta         $4b58             

                  jmp         ir02_e            

;============================================================================================================================================================
                                                ;continue setting up monitor for wavy pixel scroll (animation part $15)

STPWVYPXLSCRL3    cpx         #$14              ;check current animation part
                  beq         stpwvypxlscrl3_1  ;if not $014, skip ahead

                  jmp         WHTNS3            

stpwvypxlscrl3_1  lda         #$eb              ;set character $eb for all pixel rows
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             
                  sta         $4b3c             
                  sta         $4b3d             
                  sta         $4b53             
                  sta         $4b54             
                  sta         $4b55             
                  sta         $4b56             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  sta         $4b62             
                  sta         $4b63             
                  sta         $4b64             
                  sta         $4b65             

                  lda         #$15              ;activate next animation part
                  sta         mnanipt           
                  lda         #$80              ;set up zero page $fd/$fe for animation part $15
                  sta         $fd               
                  lda         #$a5              
                  sta         $fe               

                  jmp         ir02_e            

;============================================================================================================================================================
                                                ;display white noise character 3
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS3            cpx         #$16              ;check current animation part
                  beq         whtns3_1          ;if not $016, skip ahead

                  jmp         FLLMNTR3          

whtns3_1          lda         whtnsdly          ;check delay
                  bne         whtns3_2          ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a8c             
                  sta         $4a91             
                  sta         $4a93             
                  sta         $4ab6             
                  sta         $4abc             
                  sta         $4ac0             
                  sta         $4b05             
                  sta         $4b09             
                  sta         $4b0f             
                  sta         $4b13             
                  sta         $4b30             
                  sta         $4b34             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3d             
                  sta         $4b53             
                  sta         $4b58             
                  sta         $4b5a             
                  sta         $4b7b             
                  sta         $4b85             
                  sta         $4b8a             
                  sta         $4b8b             
                  sta         $4b8c             

                  dec         whtnsndx          ;decrease index for fetching characters codes

whtns3_2          jmp         ir02_e

;============================================================================================================================================================
                                                ;fill the complete monitor with the same char

FLLMNTR3          cpx         #$17              ;check current animation part
                  beq         fllmntr3_1        ;start routine if $17

                  jmp         RSTRT3            

fllmntr3_1        lda         #$f1
                  sta         $4b12             ;monitor row 3           
                  sta         $4b13             
                  sta         $4b14             
                  sta         $4b15  
                  sta         $4b2b             ;monitor row 4
                  sta         $4b2c             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             
                  sta         $4b3c             
                  sta         $4b3d             
                  sta         $4b53             ;monitor row 5
                  sta         $4b54             
                  sta         $4b55             
                  sta         $4b56             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             

                  jmp         ir02_e            

;============================================================================================================================================================
                                                ;restore all variables and other data so monitor animation can restart


RSTRT3            cpx         #$18              ;check current animation part
                  beq         rstrt3_1          ;start routine if $18

                  jmp         ir02_e            

rstrt3_1          lda         durexp2
                  bmi         rstrt3_2          

                  jmp         ir02_e            

rstrt3_2          lda         #$ac
                  sta         sqanindx          
                  lda         #$05              
                  sta         pxlwvndx1         
                  sta         pxlwvndx5         
                  sta         pxlwvsubdly1      
                  sta         pxlwvmvndx2       
                  lda         #$ff              
                  sta         pxlwvmvndx1       
                  lda         #$03              
                  sta         pxlwvndx2         
                  sta         pxlwvndx4         
                  sta         wldsprtndx        
                  lda         #$01              
                  sta         pxlwvndx3         
                  sta         durexp
                  lda         #$28
                  sta         rstrtdly          
                  lda         #$b1              
                  sta         wldsprtx          
                  lda         #$b2              
                  sta         wldsprty          
                  lda         #$20              
                  sta         pxlwvdur 
                  lda         #$02              
                  sta         durexp2
                  lda         #$0b              ;set multicolor color #01
                  sta         $d022             
                  lda         #$0c              ;set multicolor color #02
                  sta         $d023
                  lda         #$70              
                  sta         swtindly
                  lda         #$a0              
                  sta         fltldur
                  lda         #$90              
                  sta         tmngdly
                  lda         #$98              
                  sta         mnanidly9   

                  lda         #$00              ;restart monitor animation
                  sta         mnanipt           

;============================================================================================================================================================

ir02_e            lda         #$44              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir03            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir03            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir03              lda         #<ir03_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir03_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir03 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir03_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir03_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $45
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir03_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$3d              ;(2 cycles)
                  bne         ir03_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$04              ;(2 cycles)
                  bne         ir03_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir03_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$05              ;(2 cycles) load value for delay loop
ir03_3            dey                           ;(19/24 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $46
                                                ;=> 1-2 cycles have passed
                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$3d              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir03_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir03_5            ;(3 cycles) branch is always taken

ir03_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir03_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1
                  jmp         *+3               ;(3 cycles)

                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;merge gridscroll character with flatline character

FLTLNCHAR         ldx         mnanipt
                  cpx         #$03              
                  bcc         fltlnchar_s1      
                  cpx         #$06              ;check current monitor animation part - since SWTIN1 is only used in part $01
                                                ;the animation part id is still in X
                  bcc         fltlnchar_s2      ;if not $03, $04 or $05, skip ahead

fltlnchar_s1      jmp         RECTROTP22

fltlnchar_s2      lda         $60f0             ;since bytes $04 and $05 of the flatline character are always the same, only the other bytes need
                  sta         $6128             ;to be copied over from the gridscroll character
                  sta         $6129             ;three flatline characters are used (because each flatline row ist erased seperately in a later part)
                  sta         $6130             ;since bytes $00&$01, $02&$03 and $06&$07 are identical within and across the charcters, they need to
                  sta         $6131             ;be loaded only once :)
                  sta         $6138             
                  sta         $6139             
                  lda         $60f2             
                  sta         $612a             
                  sta         $612b             
                  sta         $6132             
                  sta         $6133             
                  sta         $613a             
                  sta         $613b             
                  lda         $60f6             
                  sta         $612e             
                  sta         $6136             
                  sta         $613e             
                  sta         $612f             
                  sta         $6137             
                  sta         $613f             
                  cpx         #$05              ;check animation part
                  beq         MONWIPEOUT1       ;if $05, proceed directly with the monitor wipe out part
                  cpx         #$03              ;check animation part
                  beq         fltlnchar_s3      ;if $03, nothing else needs to be done inside ir03
                  lda         durexp            ;load flag for decreasing fltldur only every other frame
                  eor         #$01              ;flip flag (bit 0)              
                  sta         durexp            ;store flag
                  beq         fltlnchar_s3      ;if flag = 0, skip ahead
                  dec         fltldur           ;decrease duration counter for displaying flatline
                  bne         fltlnchar_s3      ;if not $00, nothing else needs to be done inside ir03
                  lda         #$05              ;activate the next animation part
                  sta         mnanipt           

fltlnchar_s3      jmp         ir03_e

;============================================================================================================================================================
                                                ;wipe out the flatline monitor display top to bottom - part 1
                                                ;no check for current animation part because this routine is only called from
                                                ;FLTLNCHAR if the current animation part is $05
                                                ;the routine needs to run in every frame because the characters wiped out are constantly changed
                                                ;NOTE: this part will only function properly if the characters in the monitor are set like they are after the
                                                ;      end of animation part $00
                                                ;the row index rw2prcss works in reverse, i.e. $00 = row 6 of the monitor and $06 = row 0 of the monitor

                                                ;process row 6
MONWIPEOUT1       lda         rw2prcss          ;load index for row processing
                  bne         mwpol00           ;if index is not $00 (= row 6), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row6fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $fc from byte $00 to the currently processed line/byte
                  sta         $67e0,x           
                  dex
                  bpl         *-4               

                  jmp         ir03_e            

row6fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4b7b             
                  sta         $4b7c             
                  sta         $4b7d             
                  sta         $4b7e             
                  sta         $4b7f             
                  sta         $4b80             
                  sta         $4b81             
                  sta         $4b82             
                  sta         $4b83             
                  sta         $4b84             
                  sta         $4b85             
                  sta         $4b86             
                  sta         $4b87             
                  sta         $4b88             
                  sta         $4b89             
                  sta         $4b8a             
                  sta         $4b8b             
                  sta         $4b8c             
                  sta         $4b8d             

                  jmp         ir03_e            

                                                ;process row 0
mwpol00           cmp         #$06              ;check currently processed row
                  bne         mwpol01           ;if index is not $06 (= row 0), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row0fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $ff from byte $00 to the currently processed line/byte
                  sta         $67f8,x           
                  dex
                  bpl         *-4               

                  jmp         ir03_e            

row0fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4a8b             
                  sta         $4a8c             
                  sta         $4a8d             
                  sta         $4a8e             
                  sta         $4a8f             
                  sta         $4a90             
                  sta         $4a91             
                  sta         $4a92             
                  sta         $4a93             
                  sta         $4a94             
                  sta         $4a95             
                  sta         $4a96             
                  sta         $4a97             
                  sta         $4a98             
                  sta         $4a99             
                  sta         $4a9a             
                  sta         $4a9b             
                  sta         $4a9c             
                  sta         $4a9d             

                  jmp         ir03_e            

                                                ;process row 1
mwpol01           cmp         #$05              ;check currently processed row
                  bne         mwpol02           ;if index is not $05 (= row 1), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row1fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $25 from byte $00 to the currently processed line/byte
                  sta         $6128,x           
                  dex
                  bpl         *-4               

                  jmp         ir03_e            

row1fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4ab3             
                  sta         $4ab4             
                  sta         $4ab5             
                  sta         $4ab6             
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ac2             
                  sta         $4ac3             
                  sta         $4ac4             
                  sta         $4ac5             

                  jmp         ir03_e            

                                                ;process row 2
mwpol02           cmp         #$04              ;check currently processed row
                  bne         mnwpo1end         ;if index is not $04 (= row 2), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row2fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $fe from byte $00 to the currently processed line/byte
                  sta         $67f0,x           
                  dex
                  bpl         *-4               

                  jmp         ir03_e            

row2fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4adb             
                  sta         $4adc             
                  sta         $4add             
                  sta         $4ade             
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4aec             
                  sta         $4aed             

mnwpo1end         jmp         ir03_e

;============================================================================================================================================================
                                                ;draw 3d rotating rectangle part 2.2
                                                ;to avoid timing drawing the next horizontal line while drawing the animation frames, the routine is split in two

RECTROTP22        cpx         #$09              ;check animation part
                  beq         rectrotp22_s1     ;if not $09, skip ahead
                  cpx         #$0f              
                  beq         rectrotp22_s1     ;if not $0f, skip ahead

                  jmp         WHTNS4            

rectrotp22_s1     lda         mnanidly5         ;check if delay has reached zero
                  beq         rectrotp22_s2     

                  jmp         ir03_e            ;if not, skip ahead

rectrotp22_s2     lda         #$06              ;reset delay
                  sta         mnanidly5         
                                                ;draw animation frame $06
rectrotp22f6      lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if not $06, skip ahead
                  bne         rectrotp22f5      
                  lda         #$4d              
                  sta         $4b61             
                  lda         #$50              
                  sta         $4adf             
                  sta         $4b07             
                  sta         $4b2f             

                  jmp         ir03_e            

                                                ;draw animation frame $05
rectrotp22f5      cmp         #$05              ;check the current animation frame
                  bne         rectrotp22f4      ;if not $05, skip ahead
                  lda         #$56              
                  sta         $4b62             
                  lda         #$59              
                  sta         $4b2e             
                  sta         $4adf             
                  lda         #$5a              
                  sta         $4b07             

                  jmp         ir03_e            

                                                ;draw animation frame $04 cont'd
rectrotp22f4      cmp         #$04              ;check the current animation frame
                  bne         rectrotp22f3      ;if not $04, skip ahead
                  lda         #$62              
                  sta         $4b3b             
                  lda         #$63              
                  sta         $4b3a             
                  lda         #$66              
                  sta         $4b06             
                  lda         #$67              
                  sta         $4b07             

                  jmp         ir03_e            

                                                ;draw animation frame $03 cont'd
rectrotp22f3      cmp         #$03              ;check the current animation frame
                  bne         rectrotp22f2      ;if not $03, skip ahead
                  lda         #$6c              
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  lda         #$6d              
                  sta         $4b12             
                  lda         #$6e              
                  sta         $4b15             

                  jmp         ir03_e            

                                                ;draw animation frame $02 cont'd
rectrotp22f2      cmp         #$02              ;check the current animation frame
                  bne         rectrotp22f1      ;if not $02, skip ahead
                  lda         #$73              
                  sta         $4b12             
                  lda         #$74              
                  sta         $4b15             

                  jmp         ir03_e            

                                                ;draw animation frame $01 cont'd
rectrotp22f1      cmp         #$01              ;check the current animation frame
                  bne         rectrotp22f0      ;if not $01, skip ahead
                  lda         #$7d              
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  lda         #$7c              
                  sta         $4b38             
                  lda         #$7b              
                  sta         $4b39             

                  jmp         ir03_e            

                                                ;draw animation frame $00 cont'd
rectrotp22f0      lda         #$88
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  lda         #$87              
                  sta         $4b60             

                  jmp         ir03_e            

;============================================================================================================================================================
                                                ;display white noise character 4
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS4            cpx         #$16              ;check current animation part
                  beq         whtns4_1          ;if not $016, skip ahead

                  jmp         FLLMNTR4          

whtns4_1          lda         whtnsdly          ;check delay
                  bne         whtns4_2          ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a94             
                  sta         $4a99             
                  sta         $4a9b             
                  sta         $4ab7             
                  sta         $4abb             
                  sta         $4ac1             
                  sta         $4ac5             
                  sta         $4adc             
                  sta         $4ade             
                  sta         $4ae7             
                  sta         $4ae9             
                  sta         $4b04             
                  sta         $4b0a             
                  sta         $4b0e             
                  sta         $4b14             
                  sta         $4b2b             
                  sta         $4b2e             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b35             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b54             
                  sta         $4b59             
                  sta         $4b7c             
                  sta         $4b8d             

                  dec         whtnsndx          ;decrease index for fetching characters codes

whtns4_2          jmp         ir03_e

;============================================================================================================================================================
                                                ;fill the complete monitor with the same char

FLLMNTR4          cpx         #$17              ;check current animation part
                  beq         fllmntr4_1        ;start routine if $17

                  jmp         ir03_e            

fllmntr4_1        lda         #$f1
                  sta         $4b62             ;monitor row 5             
                  sta         $4b63             
                  sta         $4b64             
                  sta         $4b65  
                  sta         $4b7b             ;monitor row 6
                  sta         $4b7c             
                  sta         $4b7d             
                  sta         $4b7e             
                  sta         $4b7f             
                  sta         $4b80             
                  sta         $4b81             
                  sta         $4b82             
                  sta         $4b83             
                  sta         $4b84             
                  sta         $4b85             
                  sta         $4b86             
                  sta         $4b87             
                  sta         $4b88             
                  sta         $4b89             
                  sta         $4b8a             
                  sta         $4b8b             
                  sta         $4b8c             
                  sta         $4b8d             

;============================================================================================================================================================

ir03_e            lda         #$4c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir04            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir04            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir04              lda         #<ir04_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir04_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir04 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir04_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir04_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $4D
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir04_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$3d              ;(2 cycles)
                  bne         ir04_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir04_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir04_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir04_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $4E
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$3d              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir04_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir04_5            ;(3 cycles) branch is always taken

ir04_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir04_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)
                  
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;wipe out the flatline monitor display top to bottom - part 2

MONWIPEOUT2       lda         mnanipt           ;check for current animation part
                  cmp         #$05              ;if not $05, skip ahead
                  beq         mwpol03           
                  jmp         RECTROTCHRP1      
                                                ;process row 3
mwpol03           lda         rw2prcss
                  cmp         #$03              ;check currently processed row
                  bne         mwpol04           ;if index is not $03 (= row 3), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row3fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $26 from byte $00 to the currently processed line/byte
                  sta         $6130,x           
                  dex
                  bpl         *-4               
                  jmp         mnwpodly          
row3fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4b03             
                  sta         $4b04             
                  sta         $4b05             
                  sta         $4b06             
                  sta         $4b07             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b0c             
                  sta         $4b0d             
                  sta         $4b0e             
                  sta         $4b0f             
                  sta         $4b10             
                  sta         $4b11             
                  sta         $4b12             
                  sta         $4b13             
                  sta         $4b14             
                  sta         $4b15             
                  jmp         mnwpodly          
                                                ;process row 4
mwpol04           cmp         #$02              ;check currently processed row
                  bne         mwpol05           ;if index is not $02 (= row 4), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         row4fin           
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $fd from byte $00 to the currently processed line/byte
                  sta         $67e8,x           
                  dex
                  bpl         *-4               
                  jmp         mnwpodly          
row4fin           lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4b2b             
                  sta         $4b2c             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             
                  sta         $4b3c             
                  sta         $4b3d             
                  jmp         mnwpodly          

                                                ;process row 5
mwpol05           cmp         #$01              ;check currently processed row
                  bne         mnwpodly          ;if index is not $01 (= row 5), skip to next check
                  ldx         ln2prcss          
                  cpx         #$07              ;if the current line is $07 (last line), the dark grey character can be set for the whole row
                  beq         monwipeout2_1     
                  lda         #$55              ;store the dark grey mask in all lines (=bytes) of character $27 from byte $00 to the currently processed line/byte
                  sta         $6138,x           
                  dex
                  bpl         *-4               
                  jmp         mnwpodly          
monwipeout2_1     lda         #$f0              ;set the working character $f0 for the whole row (initially set to dark grey square)
                  sta         $4b53             
                  sta         $4b54             
                  sta         $4b55             
                  sta         $4b56             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  sta         $4b62             
                  sta         $4b63             
                  sta         $4b64             
                  sta         $4b65             

mnwpodly          dec         mnanidly4         ;check delay; if not $00, currently processed row & line are not altered
                  beq         monwipeout2_2     

                  jmp         ir04_e            

monwipeout2_2     lda         #$02              ;reset delay
                  sta         mnanidly4         
                  inc         ln2prcss          ;increase the currently processed line
                  lda         ln2prcss          
                  cmp         #$08              ;check if the currently processed line is $08
                  beq         monwipeout2_3     

                  jmp         ir04_e            

monwipeout2_3     lda         #$00              ;if yes, reset the index for the currently processed line (current monitor row is finished)
                  sta         ln2prcss          
                  dec         rw2prcss          ;set index for next row

                  jmp         ir04_e            



;============================================================================================================================================================
                                                ;merge grid with rectangle animation characters part 1
                                                ;has to be handled differently for each animation frame
                                                ;only the bytes that can hold grid graphicsa are processed
                                                ;bytes $00&$01, $02&$03, $04&$05 and $06&$07 are identical in the grid
                                                ;not needed at all for aniamtion frame $06

RECTROTCHRP1      cmp         #$09              ;check current animation  part
                  beq         rectrotchrp1f5    ;if not $09, skip ahead
                  cmp         #$0f              
                  beq         rectrotchrp1f5    ;if not $0f, skip ahead
                  jmp         PYRPXLOUTP1       
                                                ;merge for animation frame $05
rectrotchrp1f5    lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if animation frame is $06, nothing needs to be done at all
                  bne         rectrotchrp1_s1   

                  jmp         ir04_e            

rectrotchrp1_s1   cmp         #$05              ;if frame is not $05, skip ahead
                  beq         rectrotchrp1_s2   
                  jmp         rectrotchrp1f4    
                                                ;byte $00,$01 of grid
rectrotchrp1_s2   ldx         $60f0             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $6288             ;just take over for characters $51,$52, $53
                  stx         $6289             
                  stx         $6290             
                  stx         $6291             
                  stx         $6298             
                  stx         $6299             
                                                ;merge for character $54
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62a0             ;store in character bytes
                  sta         $62a1             
                                                ;merge for characters $55,$56
                  txa
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $62a8             ;store in character bytes
                  sta         $62a9             
                  sta         $62b0             
                  sta         $62b1             
                                                ;merge for characters $58,$5a
                  txa
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $62c0             ;store in character bytes
                  sta         $62c1             
                  sta         $62d0             
                  sta         $62d1             
                                                ;merge for character $59
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62c8             ;store in character bytes
                  sta         $62c9             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $628a             ;just take over for characters $51,$52, $53
                  stx         $628b             
                  stx         $6292             
                  stx         $6293             
                  stx         $629a             
                  stx         $629b             
                                                ;merge for character $54
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62a2             ;store in character bytes
                  sta         $62a3             
                                                ;merge for characters $55,$56
                  txa
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $62aa             ;store in character bytes
                  sta         $62ab             
                  sta         $62b2             
                  sta         $62b3             
                                                ;merge for characters $58,$5a
                  txa
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $62c2             ;store in character bytes
                  sta         $62c3             
                  sta         $62d2             
                  sta         $62d3             
                                                ;merge for character $59
                  txa
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62ca             ;store in character bytes
                  sta         $62cb             

                  jmp         ir04_e            

                                                ;merge for animation frame $04
rectrotchrp1f4    cmp         #$04              ;check the current animation frame
                  beq         rectrotchrp1_s3   
                  jmp         rectrotchrp1f3    
                                                ;byte $00,$01 of grid
rectrotchrp1_s3   ldx         $60f0             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $62d8             ;just take over for characters $5b-$5f, $61,$62,$65,$66
                  stx         $62d9             
                  stx         $62e0             
                  stx         $62e1             
                  stx         $62e8             
                  stx         $62e9             
                  stx         $62f0             
                  stx         $62f1             
                  stx         $62f8             
                  stx         $62f9             
                  stx         $6308             
                  stx         $6309             
                  stx         $6310             
                  stx         $6311             
                  stx         $6328             
                  stx         $6329             
                  stx         $6330             
                  stx         $6331             
                                                ;merge for character $60
                  txa                           ;fetch grid character data
                  and         #$0f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $6300             ;store in character bytes
                  sta         $6301             
                                                ;merge for character $67
                  txa                           ;fetch grid character data
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $6338             ;store in character bytes
                  sta         $6339             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $62da             ;just take over for characters $5b-$5f,$61,$62,$65,$66
                  stx         $62db             
                  stx         $62fa             
                  stx         $62fb             
                  stx         $630a             
                  stx         $630b             
                  stx         $6332             
                  stx         $6333             
                                                ;merge for characters $5c,$65
                  txa                           ;fetch grid character data
                  ora         #$0f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62e2             ;store in character bytes
                  sta         $62e3             
                  sta         $632a             
                  sta         $632b             
                                                ;merge for character $5e
                  txa                           ;fetch grid character data
                  ora         #$f0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62f2             ;store in character bytes
                  sta         $62f3             

                                                ;merge for character $62
                  txa                           ;fetch grid character data
                  ora         #$f0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6312             ;store in character bytes
                  sta         $6313             

                  jmp         ir04_e            

                                                ;merge for animation frame $03
rectrotchrp1f3    cmp         #$03              ;check the current animation frame
                  bne         rectrotchrp1f2    
                                                ;byte $00,$01 of grid
                  ldx         $60f0             
                  stx         $6340             ;just take over for characters $68-$6b,$6d,$6e
                  stx         $6341             
                  stx         $6348             
                  stx         $6349             
                  stx         $6350             
                  stx         $6351             
                  stx         $6358             
                  stx         $6359             
                  stx         $6368             
                  stx         $6369             
                  stx         $6370             
                  stx         $6371             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $6342             ;just take over for characters $68-$6b,$6d,$6e
                  stx         $6343             
                  stx         $634a             
                  stx         $634b             
                  stx         $6372             
                  stx         $6373             
                                                ;merge for character $6a
                  txa                           ;fetch grid character data
                  ora         #$0f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6352             ;store in character bytes
                  sta         $6353             
                                                ;merge for character $6d
                  txa                           ;fetch grid character data
                  ora         #$f0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $636a             ;store in character bytes
                  sta         $636b             

                  jmp         ir04_e            

                                                ;merge for animation frame $02
rectrotchrp1f2    cmp         #$02              ;check the current animation frame
                  bne         rectrotchrp1f1    
                                                ;byte $00,$01 of grid
                                                ;merge for character $6f
                  lda         $60f0             ;fetch grid character data
                  ora         #$3f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6378             ;store in character bytes
                  sta         $6379             
                                                ;merge for character $74
                  lda         $60f0             ;fetch grid character data
                  ora         #$fc              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63a0             ;store in character bytes
                  sta         $63a1             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             
                  stx         $637a             ;just take over for characters $6f,$74
                  stx         $637b             
                  stx         $63a2             
                  stx         $63a3             

                  jmp         ir04_e            

                                                ;merge for animation frame $01
rectrotchrp1f1    cmp         #$01              ;check the current animation frame
                  bne         rectrotchrp1f0    
                                                ;byte $00,$01 of grid
                                                ;merge for character $79
                  ldx         $60f0             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$7c              ;add rectangle bits
                  sta         $63c8             ;store in character bytes
                  sta         $63c9             
                                                ;merge for character $7b
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63d8             ;store in character bytes
                  sta         $63d9             
                                                ;merge for character $7f
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63f8             ;store in character bytes
                  sta         $63f9             
                                                ;merge for character $81
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$3d              ;add rectangle bits
                  sta         $6408             ;store in character bytes
                  sta         $6409             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             
                  stx         $63da             ;just take over for characters $7b,$7f
                  stx         $63db             
                  stx         $63fa             
                  stx         $63fb             
                                                ;merge for characters $75,$7e
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $63aa             ;store in character bytes
                  sta         $63ab             
                  sta         $63f2             
                  sta         $63f3             
                                                ;merge for characters $78,$7c
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $63c2             ;store in character bytes
                  sta         $63c3             
                  sta         $63e2             
                  sta         $63e3             
                                                ;merge for character $79
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63ca             ;store in character bytes
                  sta         $63cb             
                                                ;merge for character $81
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $640a             ;store in character bytes
                  sta         $640b             

                  jmp         ir04_e            

                                                ;merge for animation frame $00
                                                ;byte $00,$01 of grid
rectrotchrp1f0    ldx         $60f0             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $6410             ;just take over for characters $82-$84
                  stx         $6411             
                  stx         $6418             
                  stx         $6419             
                  stx         $6420             
                  stx         $6421             
                                                ;merge for character $85
                  txa                           ;fetch grid character data
                  and         #$0f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $6428             ;store in character bytes
                  sta         $6429             
                                                ;merge for character $8a
                  txa                           ;fetch grid character data
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $6450             ;store in character bytes
                  sta         $6451             

                                                ;byte $02,$03 of grid
                  ldx         $60f2             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                                                ;merge for character $82
                  txa                           ;fetch grid character data
                  ora         #$3f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6412             ;store in character bytes
                  sta         $6413             
                                                ;merge for character $84
                  txa                           ;fetch grid character data
                  ora         #$fc              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6422             ;store in character bytes
                  sta         $6423             
                                                ;merge for character $85
                  txa                           ;fetch grid character data
                  and         #$0f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $642a             ;store in character bytes
                  sta         $642b             
                                                ;merge for character $8a
                  txa                           ;fetch grid character data
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $6452             ;store in character bytes
                  sta         $6453             

                  jmp         ir04_e            

;============================================================================================================================================================
                                                ;pixel out the pyramid in the rectangle part 1

PYRPXLOUTP1       cmp         #$0e              ;check for current animation part
                  beq         pyrpxloutp1_s1    ;if not $0e, skip ahead
                  jmp         WELDSPRT          
pyrpxloutp1_s1    dec         mnanidly12        ;decrease delay
                  beq         pyrpxloutp1_s2    

                  jmp         ir04_e            ;if not $00, skip ahead

pyrpxloutp1_s2    lda         pyrpxlondx        ;check if animation frame index is >= $00
                  bpl         pyrpxloutp1_1     
                  lda         #$0f              ;if it is < $00, activate next animation part
                  sta         mnanipt           
                  lda         #$20              
                  sta         mnanidly12        

                  jmp         ir04_e            

pyrpxloutp1_1     tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcs         pyrpxloutp1_1_1   
                  jmp         pyrpxloutp1_1_2   
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxloutp1_1_1   lda         $64a0             ;load byte $00 of $94 pyramid character from backup data
                  and         pxlando1,x        ;erase all bits to be pixeled out
                  ora         pxlorao1,x        ;set erased bits to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a0             ;store in byte $00 and $01 of $94 character in actual font data
                  sta         $64a1             
                  lda         $64a4             ;load byte $03 of $94 pyramid character from backup data
                  and         pxlando2,x        ;erase all bits to be pixeled out
                  ora         pxlorao2,x        ;set erased bit to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a4             ;store in byte $04 and $05 of $94 character in actual font data
                  sta         $64a5             
                  lda         $64a8             ;process character $95
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64a8             
                  sta         $64a9             
                  lda         $64ac             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64ac             
                  sta         $64ad             
                  lda         $64b0             ;process character $96
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64b0             
                  sta         $64b1             
                  lda         $64b4             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64b4             
                  sta         $64b5             
                  lda         $64b8             ;process character $97
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64b8             
                  sta         $64b9             
                  lda         $64bc             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64bc             
                  sta         $64bd             

                  jmp         ir04_e            

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxloutp1_1_2   lda         $64a2             ;load byte $02 of $94 pyramid character from backup data
                  and         pxlando1,x        ;erase all bits to be pixeled out
                  ora         pxlorao1,x        ;set erased bits to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a2             ;store in byte $02 and $03 of $94 character in actual font data
                  sta         $64a3             
                  lda         $64a6             ;load byte $06 of $94 pyramid character from backup data
                  and         pxlando2,x        ;erase all bits to be pixeled out
                  ora         pxlorao2,x        ;set erased bits to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a6             ;store in byte $06 and $07 of $94 character in actual font data
                  sta         $64a7             
                  lda         $64aa             ;process character $95
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64aa             
                  sta         $64ab             
                  lda         $64ae             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64ae             
                  sta         $64af             
                  lda         $64b2             ;process character $96
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64b2             
                  sta         $64b3             
                  lda         $64b6             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64b6             
                  sta         $64b7             
                  lda         $64ba             ;process character $97
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64ba             
                  sta         $64bb             
                  lda         $64be             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64be             
                  sta         $64bf             

                  jmp         ir04_e            

;============================================================================================================================================================
                                                ;color, animate and move the welding sprites across the screen

WELDSPRT          cmp         #$10              ;check current animation part
                  beq         weldsprt_s01      ;if not $0c, skip ahead

                  jmp         WHTNS5            

weldsprt_s01      lda         tmngdly           ;check initial delay
                  beq         weldsprt_s01_01   ;if = $00, animation runs
                  dec         tmngdly           ;decrease initial delay         

                  jmp         ir04_e

weldsprt_s01_01   lda         $d027             ;save current color of scroller sprites
                  sta         tmpscrlcol        
                  lda         #$00              ;turn off x/y expansion
                  sta         $d017             
                  sta         $d01d             
                                                ;color the sprites
                  lda         #$01              ;set color for sprite $00 to white
                  sta         $d027             
                  lda         #$07              ;set color for sprite $01 to yellow
                  sta         $d028             
                  lda         #$02              ;set color for sprite $02 to red
                  sta         $d029             
                                                ;change sprite animation frame
                  ldx         wldsprtndx        ;load index for welding sprite animation frame
                  lda         wldsprt,x         ;set pointers for welding sprites
                  sta         $4bf8             
                  lda         wldsprt+4,x       
                  sta         $4bf9             
                  lda         wldsprt+8,x       
                  sta         $4bfa             
                  dec         wldsprtdly        ;decrease delay
                  bpl         weldsprt_s02      ;skip ahead if >= $00
                  lda         #$03              ;restore delay
                  sta         wldsprtdly        
                  dec         wldsprtndx        ;decrease index for welding sprite animation frame
                  bpl         weldsprt_s02      ;if >= $00, skip ahead
                  lda         #$03              ;reset index for welding sprite animation frame
                  sta         wldsprtndx        
                                                ;move the sprites
weldsprt_s02      lda         wldsprtx          ;set x coordinate for sprites $00,$01,$02
                  sta         $d000             
                  sta         $d002             
                  sta         $d004             
                  lda         wldsprty          ;set y coordinate for sprites $00,$01,$02
                  sta         $d001             
                  sta         $d003             
                  sta         $d005             
                  dec         wldmvdly          ;decrease delay for movement
                  bmi         weldsprt_s03      ;skip ahead if delay is >= $00

                  jmp         ir04_e            

weldsprt_s03      lda         #$00              ;reset delay
                  sta         wldmvdly          

                  ldx         wldmvndx          ;load index for fetching movement data
                  lda         wldmv+1,x         ;check if x coordinate (2nd byte) from movement data is $ff
                  cmp         #$ff              ;if yes, no x movement, only y movement; otherwise, no y movement, only x movement
                  beq         weldsprt_s06      
                  lda         wldmv,x           ;check 1st byte of movement data
                  beq         weldsprt_s04      ;if it is $00, x coordinate need to be decreased, otherwise it needs to be increased
                  inc         wldsprtx          ;increase x coordinate
                  jmp         weldsprt_s05      ;skip ahead
weldsprt_s04      dec         wldsprtx          ;decrease x coordinate
weldsprt_s05      lda         wldsprtx          ;check if new x coordinate equals limit set in movement data (2nd byte)
                  cmp         wldmv+1,x         
                  beq         weldsprt_s09      ;if yes, the next section of movement has to be started

                  jmp         ir04_e            

weldsprt_s06      lda         wldmv,x           ;check 1st byte of movement data
                  beq         weldsprt_s07      ;if it is $00, y coordinate need to be decreased, otherwise it needs to be increased
                  inc         wldsprty          ;increase y coordinate
                  jmp         weldsprt_s08      ;skip ahead
weldsprt_s07      dec         wldsprty          ;decrease ycoordinate
weldsprt_s08      lda         wldsprty          ;check if new y coordinate equals limit set in movement data (3rd byte)
                  cmp         wldmv+2,x         

                  bne         weldsprt_s11      ;if not, skip ahead

weldsprt_s09      lda         wldmvndx          ;increase index for fetching movement data by $03
                  clc
                  adc         #$03              
                  cmp         #$2a              ;check if the new index is $2a
                  bne         weldsprt_s10      ;if not, skip ahead
                  lda         #$11              ;activate next animation part
                  sta         mnanipt           
                  lda         #$01              ;set delay for part $17              
                  sta         tmngdly
                  lda         #$00              ;reset index for fetching movement data
weldsprt_s10      sta         wldmvndx          ;store new value of index for fetching movement data

weldsprt_s11      jmp         ir04_e

;============================================================================================================================================================
                                                ;display white noise character 5
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS5            cmp         #$16              ;check current animation part
                  beq         whtns5_1          ;if not $016, skip ahead

                  jmp         MNTRSWTCHFF       

whtns5_1          lda         whtnsdly          ;check delay
                  bne         whtns5_2          ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a92             
                  sta         $4a96             
                  sta         $4a98             
                  sta         $4ab8             
                  sta         $4aba             
                  sta         $4ac2             
                  sta         $4ac4             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae6             
                  sta         $4b03             
                  sta         $4b0b             
                  sta         $4b0d             
                  sta         $4b15             
                  sta         $4b33             
                  sta         $4b3c             
                  sta         $4b56             
                  sta         $4b5b             
                  sta         $4b5d             
                  sta         $4b60             
                  sta         $4b62             
                  sta         $4b63             

                  dec         whtnsndx          ;decrease index for fetching characters codes

whtns5_2          jmp         ir04_e

;============================================================================================================================================================
                                                ;display a fading line in the middle of the monitor

MNTRSWTCHFF       cmp         #$17              ;check current animation part
                  beq         mntrswtchff_1     ;start routine if $17

mntrswtchff_0     jmp         ir04_e            

mntrswtchff_1     dec         tmngdly           ;delay for one frame here otherwise the raster timing is off for ir00
                  bpl         mntrswtchff_0                  
                  lda         #$01              ;set multicolor #2 to white - not needed on every call of this part, just a lazy solution :)
                  sta         $d023             

                  ldx         swtchffndx        ;check the index for the current animation part
                  bmi         mntrswtchff_3     ;if it is < $00, skip the part for drawing the "switch off line"

                  lda         #$38              ;draw a line in the middle of the monitor representing monitor switch off
mcode12           bne         mntrswtchff_2     ;[!!!SELF MODIFYING CODE!!!]
mntrswtchff_2     sta         $4b04
                  sta         $4b14             
                  sta         $4b05             
                  sta         $4b13             
                  sta         $4b06             
                  sta         $4b12             
                  sta         $4b07             
                  sta         $4b11             
                  sta         $4b08             
                  sta         $4b10             
                  sta         $4b09             
                  sta         $4b0f             
                  sta         $4b0a             
                  sta         $4b0e             
                  sta         $4b0b             
                  sta         $4b0d             
                  sta         $4b0c             
                  dec         swtchffndx        ;decrease index for current animation part
                  lda         mcode12+1         ;load target location of BNE statement
                  clc
                  adc         #$06              ;add $06 bytes to the BNE statement (2x STA), i.e. draw to less characters of the "switch off line" next time
                  sta         mcode12+1         ;store new target location of BNE statement
                  jmp         ir04_e            

mntrswtchff_3     lda         #$18              ;activate next animation part
                  sta         mnanipt           
                  lda         #$00              ;restore self-modifying code to initial state
                  sta         mcode12+1         

;============================================================================================================================================================

ir04_e            lda         #$54              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir05            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir05            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir05              lda         #<ir05_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir05_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir05 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir05_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir05_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $55

ir05_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $36
                                                ;=> 1-2 cycles have passed
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT raster line
                  sta         $d020             ;(4 cycles) reset border color


;============================================================================================================================================================
                                                ;wipe out the flatline monitor display top to bottom - part 2

MONWIPEOUT3       lda         mnanipt           ;check for current animation part
                  cmp         #$05              ;if not $05, skip ahead
                  beq         mnwpoend          
                  jmp         RECTROTCHRP2      
                                                ;end monitor wipe out
mnwpoend          lda         rw2prcss          ;load inex for row to process
                  bmi         monwipeout3_1     ;check if the last row (index < $00) has been processed

                  jmp         ir05_e            ;if no, skip ahead

                                                ;set color memory for rotating rectangle animation part
                                                ;only the locations used in that part are changed
monwipeout3_1     lda         #$08              ;set color to black
                  sta         $dab6             ;row 1
                  sta         $dab7             
                  sta         $dab8             
                  sta         $dab9             
                  sta         $daba             
                  sta         $dabb             
                  sta         $dabc             
                  sta         $dabd             
                  sta         $dabe             
                  sta         $dabf             
                  sta         $dac0             
                  sta         $dac1             
                  sta         $dac2             
                  sta         $db03             ;row 3
                  sta         $db04             
                  sta         $db05             
                  sta         $db06             
                  sta         $db07             
                  sta         $db08             
                  sta         $db09             
                  sta         $db0a             
                  sta         $db0b             
                  sta         $db0c             
                  sta         $db0d             
                  sta         $db0e             
                  sta         $db0f             
                  sta         $db10             
                  sta         $db11             
                  sta         $db12             
                  sta         $db13             
                  sta         $db14             
                  sta         $db15             
                  sta         $db56             ;row 5
                  sta         $db57             
                  sta         $db58             
                  sta         $db59             
                  sta         $db5a             
                  sta         $db5b             
                  sta         $db5c             
                  sta         $db5d             
                  sta         $db5e             
                  sta         $db5f             
                  sta         $db60             
                  sta         $db61             
                  sta         $db62             
                  lda         #$06              ;activate next animation part
                  sta         mnanipt           
                  lda         #$02              
                  sta         mnanidly4         

                  jmp         ir05_e            

;============================================================================================================================================================
                                                ;merge grid with rectangle animation characters part 2
                                                ;to avoid timing drawing the next horizontal line while handling the characters, the routine is split in two
RECTROTCHRP2      cmp         #$09              ;check current animation  part
                  beq         rectrotchrp2f5    ;if not $09, skip ahead
                  cmp         #$0f              
                  beq         rectrotchrp2f5    ;if not $0f, skip ahead
                  jmp         PYRPXLOUTP2       

                  jmp         ir05_e            
                                                ;merge for animation frame $05
rectrotchrp2f5    lda         rtrctndx          ;check the current animation frame
                  cmp         #$06              ;if animation frame is $06, nothing needs to be done at all
                  bne         rectrotchrp2_s1   

                  jmp         ir05_e            

rectrotchrp2_s1   cmp         #$05              ;if frame is not $05, skip ahead
                  bne         rectrotchrp2f4    
                                                ;byte $04,$05 of grid
                  ldx         $60f4             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                                                ;merge for character $54
                  txa                           ;fetch grid character data
                  and         #$0f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $62a4             ;store in character bytes
                  sta         $62a5             
                                                ;merge for character $56
                  txa
                  ora         #$fc              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62b4             ;store in character bytes
                  sta         $62b5             
                                                ;merge for character $58
                  txa
                  ora         #$3f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62c4             ;store in character bytes
                  sta         $62c5             
                                                ;merge for character $59
                  txa
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $62cc             ;store in character bytes
                  sta         $62cd             

                                                ;byte $06,$07 of grid
                  ldx         $60f6             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $62b6             ;just take over for characters $56,$57, $58
                  stx         $62b7             
                  stx         $62be             
                  stx         $62bf             
                  stx         $62c6             
                  stx         $62c7             
                                                ;merge for character $54
                  txa                           ;fetch grid character data
                  and         #$3f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $62a6             ;store in character bytes
                  sta         $62a7             
                                                ;merge for character $59
                  txa
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $62ce             ;store in character bytes
                  sta         $62cf             

                  jmp         ir05_e            

                                                ;merge for animation frame $04
rectrotchrp2f4    cmp         #$04              ;check the current animation frame
                  beq         rectrotchrp2_s2   
                  jmp         rectrotchrp2f3    
                                                ;byte $04,$05 of grid
rectrotchrp2_s2   ldx         $60f4             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $62dc             ;just take over for characters $5b-$5f, $61,$62,$65,$66
                  stx         $62dd             
                  stx         $62fc             
                  stx         $62fd             
                                                ;merge for characters $5c,$65
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $62e4             ;store in character bytes
                  sta         $62e5             
                  sta         $632c             
                  sta         $632d             
                                                ;merge for characters $5e,$62
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $62f4             ;store in character bytes
                  sta         $62f5             
                  sta         $6314             
                  sta         $6315             
                                                ;merge for character $61
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $630c             ;store in character bytes
                  sta         $630d             

                                                ;merge for character $66
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6334             ;store in character bytes
                  sta         $6335             

                                                ;byte $06,$07 of grid
                  ldx         $60f6             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                                                ;merge for character $5b
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62de             ;store in character bytes
                  sta         $62df             
                                                ;merge for character $5f
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $62fe             ;store in character bytes
                  sta         $62ff             
                                                ;merge for character $$61
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$7c              ;add rectangle bits
                  sta         $630e             ;store in character bytes
                  sta         $630f             
                                                ;merge for character $$66
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$3d              ;add rectangle bits
                  sta         $6336             ;store in character bytes
                  sta         $6337             

                  jmp         ir05_e            

                                                ;merge for animation frame $03
rectrotchrp2f3    cmp         #$03              ;check the current animation frame
                  bne         rectrotchrp2f2    
                                                ;byte $04,$05 of grid
                  ldx         $60f4             
                  stx         $6344             ;just take over for characters $68,$6e
                  stx         $6345             
                  stx         $6374             
                  stx         $6375             

                                                ;byte $06,$07 of grid
                                                ;merge for character $68
                  lda         $60f6             ;fetch grid character data
                  ora         #$3f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6346             ;store in character bytes
                  sta         $6347             
                                                ;merge for character $6e
                  lda         $60f6             ;fetch grid character data
                  ora         #$fc              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6376             ;store in character bytes
                  sta         $6377             

                  jmp         ir05_e            

                                                ;merge for animation frame $02
rectrotchrp2f2    cmp         #$02              ;check the current animation frame
                  bne         rectrotchrp2f1    
                                                ;byte $04,$05 of grid
                  ldx         $60f4             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $637c             ;just take over for characters $68-$6b,$6d,$6e
                  stx         $637d             
                  stx         $6384             
                  stx         $6385             
                  stx         $63a4             
                  stx         $63a5             

                                                ;merge for character $6a
                  txa                           ;fetch grid character data
                  ora         #$0f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $638c             ;store in character bytes
                  sta         $638d             
                                                ;merge for character $6d
                  txa                           ;fetch grid character data
                  ora         #$f0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $639c             ;store in character bytes
                  sta         $639d             

                                                ;byte $06,$07 of grid
                  ldx         $60f6             
                  stx         $637e             ;just take over for characters $68-$6b,$6d,$6e
                  stx         $637f             
                  stx         $6386             
                  stx         $6387             
                  stx         $638e             
                  stx         $638f             
                  stx         $6396             
                  stx         $6397             
                  stx         $639e             
                  stx         $639f             
                  stx         $63a6             
                  stx         $63a7             

                  jmp         ir05_e            

                                                ;merge for animation frame $01
rectrotchrp2f1    cmp         #$01              ;check the current animation frame
                  beq         rectrotchrp2_s3   
                  jmp         rectrotchrp2f0    
                                                ;byte $04,$05 of grid
rectrotchrp2_s3   ldx         $60f4             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $63cc             ;just take over for characters $79,$7b,$7f,$81
                  stx         $63cd             
                  stx         $63dc             
                  stx         $63dd             
                  stx         $63fc             
                  stx         $63fd             
                  stx         $640c             
                  stx         $640d             
                                                ;merge for character $75,$7e
                  txa                           ;fetch grid character data
                  ora         #$0f              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63ac             ;store in character bytes
                  sta         $63ad             
                  sta         $63f4             
                  sta         $63f5             
                                                ;merge for character $76,$7c
                  txa                           ;fetch grid character data
                  ora         #$f0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $63c4             ;store in character bytes
                  sta         $63c5             
                  sta         $63e4             
                  sta         $63e5             

                                                ;byte $06,$07 of grid
                  ldx         $60f6             ;load in X because value is needed again, TXA takes only two cycles instead of 4 for LDA
                  stx         $63ae             ;just take over for characters $75,$78,$79,$7b-$7f,$81
                  stx         $63af             
                  stx         $63c6             
                  stx         $63c7             
                  stx         $63ce             
                  stx         $63cf             
                  stx         $63de             
                  stx         $63df             
                  stx         $63e6             
                  stx         $63e7             
                  stx         $63ee             
                  stx         $63ef             
                  stx         $63f6             
                  stx         $63f7             
                  stx         $63fe             
                  stx         $63ff             
                  stx         $640e             
                  stx         $640f             
                                                ;merge for character $7a
                  txa                           ;fetch grid character data
                  and         #$0f              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$70              ;add rectangle bits
                  sta         $63d6             ;store in character bytes
                  sta         $63d7             
                                                ;merge for character $80
                  txa                           ;fetch grid character data
                  and         #$f0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$0d              ;add rectangle bits
                  sta         $6406             ;store in character bytes
                  sta         $6407             

                  jmp         ir05_e            

                                                ;merge for animation frame $00
                                                ;byte $04,$05 of grid
rectrotchrp2f0    ldx         $60f4
                  stx         $643c             ;just take over for characters $87-89
                  stx         $643d             
                  stx         $6444             
                  stx         $6445             
                  stx         $644c             
                  stx         $644d             
                                                ;merge for characters $82,$8b
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $6414             ;store in character bytes
                  sta         $6415             
                  sta         $645c             
                  sta         $645d             
                                                ;merge for characters $84,$86
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $6424             ;store in character bytes
                  sta         $6425             
                  sta         $6434             
                  sta         $6435             
                                                ;merge for character $85
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $642c             ;store in character bytes
                  sta         $642d             
                                                ;merge for character $8a
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6454             ;store in character bytes
                  sta         $6455             

                                                ;byte $06,$07 of grid
                  ldx         $60f6             
                  stx         $643e             ;just take over for characters $87-89
                  stx         $643f             
                  stx         $6446             
                  stx         $6447             
                  stx         $644e             
                  stx         $644f             
                                                ;merge for characters $82,$8b
                  txa                           ;fetch grid character data
                  and         #$c0              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$35              ;add rectangle bits
                  sta         $6416             ;store in character bytes
                  sta         $6417             
                  sta         $645e             
                  sta         $645f             
                                                ;merge for characters $84,$86
                  txa                           ;fetch grid character data
                  and         #$03              ;mask out rectangle bits (because of multicolor, bits are 0 in the rectangle, there for simple ORA not sufficient)
                  ora         #$5c              ;add rectangle bits
                  sta         $6426             ;store in character bytes
                  sta         $6427             
                  sta         $6436             
                  sta         $6437             
                                                ;merge for character $85
                  txa                           ;fetch grid character data
                  ora         #$c0              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $642e             ;store in character bytes
                  sta         $642f             
                                                ;merge for character $8a
                  txa                           ;fetch grid character data
                  ora         #$03              ;add rectangle bits - no masking needed since the frame only uses the 11 bit pattern here
                  sta         $6456             ;store in character bytes
                  sta         $6457             

                  jmp         ir05_e            

;============================================================================================================================================================
                                                ;pixel out the pyramid in the rectangle part 2

PYRPXLOUTP2       lda         mnanipt
                  cmp         #$0e              ;check for current animation part
                  beq         pyrpxloutp2_s1    ;if not $0e, skip ahead
                  jmp         WLDLN             
pyrpxloutp2_s1    lda         mnanidly12        ;check if delay is $00
                  beq         pyrpxloutp2_1     

                  jmp         ir05_e            ;if not $00, skip ahead

pyrpxloutp2_1     lda         pyrpxlondx        ;load animation frame index
                  tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcs         pyrpxloutp2_1_1   
                  jmp         pyrpxloutp2_1_2   
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxloutp2_1_1   lda         $64c0             ;process character $98
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64c0             
                  sta         $64c1             
                  lda         $64c4             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64c4             
                  sta         $64c5             
                  lda         $64c8             ;process character $99
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64c8             
                  sta         $64c9             
                  lda         $64cc             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64cc             
                  sta         $64cd             
                  lda         $64d0             ;process character $9a
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64d0             
                  sta         $64d1             
                  lda         $64d4             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64d4             
                  sta         $64d5             

                  jmp         ir05_e            

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxloutp2_1_2   lda         $64c2             ;process character $98
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64c2             
                  sta         $64c3             
                  lda         $64c6             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64c6             
                  sta         $64c7             
                  lda         $64ca             ;process character $99
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64ca             
                  sta         $64cb             
                  lda         $64ce             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64ce             
                  sta         $64cf             
                  lda         $64d2             ;process character $9a
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64d2             
                  sta         $64d3             
                  lda         $64d6             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64d6             
                  sta         $64d7             

                  jmp         ir05_e            

;============================================================================================================================================================
                                                ;draw welding lines & where needed turn off color flashing for 'welded out'sections of the rectangle
                                                ;of the horizontal/ vertical lines in the comments and labels
                                                ;draw vertical welding line center / erase welded out left half of rectangle

WLDLN             cmp         #$10              ;check animation part
                  beq         wldln_s01         ;if not = $10, skip ahead

                  jmp         WHTNS6            

wldln_s01         lda         wldmvndx          ;check index for welding sprite movement data
                  beq         wldlns01          
                  jmp         wldlns02          ;if not = $00 (i.e. 1st vertical weld), skip ahead
wldlns01          lda         $d001             ;check if the y coordinate of sprite $00 is even by shifting bit 0 into carry
                  lsr
                  bcc         wldlns01_s1       

                  jmp         ir05_e            ;if y coordinate is not even, skip ahead (i.e. delay for 1 frame)

wldlns01_s1       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln1,x          ;always write the 5 characters needed for this welding line and increase the index in the process
                  sta         $4abc             
                  inx
                  lda         wldln1,x          
                  sta         $4ae4             
                  inx
                  lda         wldln1,x          
                  sta         $4b0c             
                  inx
                  lda         wldln1,x          
                  sta         $4b34             
                  inx
                  lda         wldln1,x          
                  sta         $4b5c             
                  inx                           ;increase index again to get to start of next character data
                  stx         wldlnndx          ;store new index
                  cpx         #$5f              ;check if all characters have been displayed / welding line has been fully drawn
                  beq         wldlns01_s2       ;if not, skip ahead

                  jmp         ir05_e            

wldlns01_s2       lda         #$1e              ;draw characters for section of rectangle that has been 'welded out' / stops flashing
                  sta         $4ab7             
                  sta         $4ab8             
                  sta         $4ab9             
                  sta         $4aba             
                  sta         $4abb             
                  sta         $4adf             
                  sta         $4b07             
                  sta         $4b2f             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4b08             
                  sta         $4b09             
                  sta         $4b0a             
                  sta         $4b0b             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b57             
                  sta         $4b58             
                  sta         $4b59             
                  sta         $4b5a             
                  sta         $4b5b             
                  lda         #$00              ;reset index for drawing welding line characters
                  sta         wldlnndx          

                  jmp         ir05_e            
                                                ;draw horizontal welding line from right edge to middle of right half
wldlns02          cmp         #$09              ;if index for welding sprite movement data is not = $09 (i.e. 2nd vertical weld), skip ahead
                  beq         wldlns02_s1       
                  jmp         wldlns03          
wldlns02_s1       lda         $d000             ;check if the x coordinate of sprite $00 is even by shifting bit 0 into carry
                  lsr
                  bcs         wldlns02_s2       ;if x coordinate is not even, skip ahead (i.e. delay for 1 frame)

                  jmp         ir05_e            

wldlns02_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln2,x          
                  sta         $4b0e             
                  inx
                  lda         wldln2,x          
                  sta         $4b0f             
                  inx
                  lda         wldln2,x          
                  sta         $4b10             
                  inx
                  lda         wldln2,x          
                  sta         $4b11             
                  inx
                  stx         wldlnndx          
                  cpx         #$34              
                  beq         wldlns02_s3       

                  jmp         ir05_e            

wldlns02_s3       lda         #$00
                  sta         wldlnndx          

                  jmp         ir05_e            
                                                ;draw vertical welding line from right center to top edge
wldlns03          cmp         #$0c
                  beq         wldlns03_s1       
                  jmp         wldlns04          
wldlns03_s1       lda         $d001             ;check if the y coordinate of sprite $00 is even by shifting bit 0 into carry
                  lsr
                  bcc         wldlns03_s2       ;if y coordinate is not even, skip ahead (i.e. delay for 1 frame)

                  jmp         ir05_e            

wldlns03_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln3,x          
                  sta         $4abe             
                  inx
                  lda         wldln3,x          
                  sta         $4ae6             
                  inx
                  lda         wldln3,x          
                  sta         $4b0e             
                  inx
                  stx         wldlnndx          
                  cpx         #$24              
                  beq         wldlns03_s3       

                  jmp         ir05_e            

wldlns03_s3       lda         #$00
                  sta         wldlnndx          

                  jmp         ir05_e            

                                                ;erase welded out upper right square
wldlns04          cmp         #$12
                  beq         wldlns04_s1       
                  jmp         wldlns05          
wldlns04_s1       lda         wldsprty
                  cmp         #$c7              
                  beq         wldlns04_s2       

                  jmp         ir05_e            

wldlns04_s2       lda         #$1e
                  sta         $4abf             
                  sta         $4ac0             
                  sta         $4ac1             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             

                  jmp         ir05_e            

                                                ;draw horizontal welding line from right edge to left edge / erase welded out section lower right rectangle
wldlns05          cmp         #$15
                  beq         wldlns05_s1       
                  jmp         wldlns06          
wldlns05_s1       lda         $60f0             ;merge the current grid character $1e with the temporary character $ea
                  sta         $6750             ;needed because this part of the weld line is on the bottom of the character, and the top part of this segment has
                  sta         $6751             ;already bee welded out in wldlns031
                  lda         $60f2             
                  sta         $6752             
                  sta         $6753             
                  lda         $60f4             
                  sta         $6754             
                  sta         $6755             
                  lda         $d000             
                  lsr
                  bcs         wldlns05_s2       

                  jmp         ir05_e            

wldlns05_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln4,x          
                  sta         $4b0c             
                  inx
                  lda         wldln4,x          
                  sta         $4b0d             
                  inx
                  lda         wldln4,x          
                  sta         $4b0e             
                  inx
                  lda         wldln4,x          
                  sta         $4b0f             
                  inx
                  lda         wldln4,x          
                  sta         $4b10             
                  inx
                  lda         wldln4,x          
                  sta         $4b11             
                  inx
                  stx         wldlnndx          
                  cpx         #$90              
                  beq         wldlns05_s3       

                  jmp         ir05_e            

wldlns05_s3       lda         #$1e
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b5c             
                  sta         $4b5d             
                  sta         $4b5e             
                  sta         $4b5f             
                  sta         $4b60             
                  sta         $4b61             
                  sta         $4b0f             ;these are the 3 characters on the top right of the rectangle welded which had to be merged with the grid before
                  sta         $4b10             
                  sta         $4b11             
                  lda         #$00              
                  sta         wldlnndx          

                  jmp         ir05_e            

                                                ;draw horizontal welding line from left edge to middle
wldlns06          cmp         #$1b
                  beq         wldlns06_s1       
                  jmp         wldlns07          
wldlns06_s1       lda         $d000
                  lsr
                  bcs         wldlns06_s2       

                  jmp         ir05_e            

wldlns06_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln5,x          
                  sta         $4ae4             
                  inx
                  lda         wldln5,x          
                  sta         $4ae5             
                  inx
                  stx         wldlnndx          
                  cpx         #$10              
                  beq         wldlns06_s3       

                  jmp         ir05_e            

wldlns06_s3       lda         #$00
                  sta         wldlnndx          

                  jmp         ir05_e            

                                                ;draw vertical welding line from middle to bottom edge / erase welded out big L piece
wldlns07          cmp         #$1e
                  beq         wldlns07_s1       
                  jmp         wldlns08          
wldlns07_s1       lda         $d001
                  lsr
                  bcc         wldlns07_s2       

                  jmp         ir05_e            

wldlns07_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln6,x          
                  sta         $4ae5             
                  inx
                  lda         wldln6,x          
                  sta         $4b0d             
                  inx
                  stx         wldlnndx          
                  cpx         #$10              
                  beq         wldlns07_s3       

                  jmp         ir05_e            

wldlns07_s3       lda         #$1e
                  sta         $4abc             
                  sta         $4abd             
                  sta         $4abe             
                  sta         $4ae6             
                  sta         $4b0e             
                  lda         #$00              
                  sta         wldlnndx          

                  jmp         ir05_e            

                                                ;draw vertical welding line from bottom edge to middle
wldlns08          cmp         #$24
                  beq         wldlns08_s1       
                  jmp         wldlns09          
wldlns08_s1       lda         $d001
                  lsr
                  bcc         wldlns08_s2       

                  jmp         ir05_e            

wldlns08_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln7,x          
                  sta         $4b0c             
                  inx
                  stx         wldlnndx          
                  cpx         #$04              
                  beq         wldlns08_s3       

                  jmp         ir05_e            

wldlns08_s3       lda         #$00
                  sta         wldlnndx          

                  jmp         ir05_e            

                                                ;draw horizontal welding line from middle to left edge / erase welded out small L piece
wldlns09          cmp         #$27
                  beq         wldlns09_s1       

                  jmp         ir05_e            

wldlns09_s1       lda         $d000
                  lsr
                  bcs         wldlns09_s2       

                  jmp         ir05_e            

wldlns09_s2       ldx         wldlnndx          ;load index for fetching character data
                  lda         wldln8,x          
                  sta         $4b0c             
                  inx
                  stx         wldlnndx          
                  cpx         #$04              
                  beq         wldlns09_s3       

                  jmp         ir05_e            

wldlns09_s3       lda         #$1e
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4b0d             
                  lda         #$00              
                  sta         wldlnndx          

                  jmp         ir05_e            

;============================================================================================================================================================
                                                ;display white noise character 6
                                                ;the character code is picked from the pseudo-random number array whtnscc

WHTNS6            cmp         #$16              ;check current animation part
                  beq         whtns6_1          ;if not $016, skip ahead

                  jmp         ir05_e            

whtns6_1          lda         whtnsdly          ;check delay
                  bne         ir05_e            ;if > $00, skip ahead
                  ldx         whtnsndx          ;load index for fetching characters codes
                  lda         whtnscc,x         ;load characters codes
                  sta         $4a8d             
                  sta         $4a8e             
                  sta         $4a97             
                  sta         $4a9a             
                  sta         $4a9c             
                  sta         $4ab9             
                  sta         $4ac3             
                  sta         $4add             
                  sta         $4ae3             
                  sta         $4ae5             
                  sta         $4aed             
                  sta         $4b0c             
                  sta         $4b36             
                  sta         $4b5e             
                  sta         $4b64             
                  sta         $4b7e             
                  sta         $4b82             
                  sta         $4b89             

                  dec         whtnsndx          ;decrease index for fetching characters codes
                  bpl         ir05_e            ;if > = $00, skip ahead
                  lda         #$7d              ;reset index
                  sta         whtnsndx          

;============================================================================================================================================================

ir05_e            lda         #$5c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir06            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir06            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir06              lda         #<ir06_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir06_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir06 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir06_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir06_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $5D

ir06_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 60-61 cycles have passed
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $36
                                                ;=> 1-2 cycles have passed
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT raster line
                  sta         $d020             ;(4 cycles) reset border color

;============================================================================================================================================================
                                                ;color the sawtooth/flatline rows of the monitor part 1

CLRSAW1           lda         mnanipt           ;check current monitor animation part
                  beq         clrsaw1_1         ;execute on $01-$05
                  cmp         #$06              
                  bcc         clrsaw1_2         

clrsaw1_1         jmp         PYRPXLSET

clrsaw1_2         ldx         swtclrndx         ;load index for color information
                  lda         swtclr1_5,x       ;load color information for monitor rows 1 & 5
                  sta         $dab3             ;store color information for monitor row 1
                  sta         $dab7             
                  sta         $dabb             
                  sta         $dabf             
                  sta         $dac3             
                  sta         $dab4             
                  sta         $dab8             
                  sta         $dabc             
                  sta         $dac0             
                  sta         $dac4             
                  sta         $dab5             
                  sta         $dab9             
                  sta         $dabd             
                  sta         $dac1             
                  sta         $dac5             
                  sta         $dab6             
                  sta         $daba             
                  sta         $dabe             
                  sta         $dac2             
                  sta         $db53             ;store color information for monitor row 5
                  sta         $db57             
                  sta         $db5b             
                  sta         $db5f             
                  sta         $db63             
                  sta         $db54             
                  sta         $db58             
                  sta         $db5c             
                  sta         $db60             
                  sta         $db64             
                  sta         $db55             
                  sta         $db59             
                  sta         $db5d             
                  sta         $db61             
                  sta         $db65             
                  sta         $db56             
                  sta         $db5a             
                  sta         $db5e             
                  sta         $db62             

                  jmp         ir06_e            

;============================================================================================================================================================
                                                ;set up characters for pixeling in pyramid

PYRPXLSET         cmp         #$0a              ;storing the character codes for the pyramid is only needed in the $0a part of the animation
                  bne         pyrpxlset_s1      
                  lda         pyrpxlndx         ;it is only also needed once in the first animation frame - therefore check the animation part and
                  cmp         #$07              ;also the delay so it is executed only once
                  bne         pyrpxlset_s1      
                  lda         mnanidly10        
                  cmp         #$04              
                  beq         pyrpxlset_s2      ;if the new animation part is not $0a, skip ahead
pyrpxlset_s1      jmp         PYRPXLOUTP3
pyrpxlset_s2      ldx         #$0e              ;fetch the character codes for the pyramid (currently not containing the pyramid)
                  lda         pyrdt,x           ;to prepare for pixelating in the pyramid
                  sta         $4b37             ;the animation frame index from the pyramid animation (aniamtion part $0b) is used to fetch the proper character codes
                  dex
                  lda         pyrdt,x           
                  sta         $4b36             
                  dex
                  lda         pyrdt,x           
                  sta         $4b35             
                  dex
                  lda         pyrdt,x           
                  sta         $4b34             
                  dex
                  lda         pyrdt,x           
                  sta         $4b33             
                  dex
                  lda         pyrdt,x           
                  sta         $4b32             
                  dex
                  lda         pyrdt,x           
                  sta         $4b31             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0e             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0d             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0c             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0b             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0a             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae5             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae4             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae3             

                  jmp         ir06_e            

;============================================================================================================================================================
                                                ;pixel out the pyramid in the rectangle part 3

PYRPXLOUTP3       cmp         #$0e              ;check for current animation part
                  beq         pyrpxloutp3_s1    ;if not $0a, skip ahead

                  jmp         PXLWVCHRS1        

pyrpxloutp3_s1    lda         mnanidly12        ;check if delay is $00
                  beq         pyrpxloutp3_1     

                  jmp         ir06_e            ;if not $00, skip ahead

pyrpxloutp3_1     lda         #$04              ;restore delay
                  sta         mnanidly12        
                  lda         pyrpxlondx        ;load animation index
                  tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcs         pyrpxloutp3_1_1   
                  jmp         pyrpxloutp3_1_2   
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxloutp3_1_1   lda         $64d8             ;process character $9b
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64d8             
                  sta         $64d9             
                  lda         $64dc             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64dc             
                  sta         $64dd             
                  lda         $64e0             ;process character $9c
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64e0             
                  sta         $64e1             
                  lda         $64e4             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64e4             
                  sta         $64e5             
                  lda         $64e8             ;process character $9d
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64e8             
                  sta         $64e9             
                  lda         $64ec             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64ec             
                  sta         $64ed             
                  jmp         pyrpxloutp3_s2    

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxloutp3_1_2   lda         $64da             ;process character $9b
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64da             
                  sta         $64db             
                  lda         $64de             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64de             
                  sta         $64df             
                  lda         $64e2             ;process character $9c
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64e2             
                  sta         $64e3             
                  lda         $64e6             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64e6             
                  sta         $64e7             
                  lda         $64ea             ;process character $9d
                  and         pxlando1,x        
                  ora         pxlorao1,x        
                  sta         $64ea             
                  sta         $64eb             
                  lda         $64ee             
                  and         pxlando2,x        
                  ora         pxlorao2,x        
                  sta         $64ee             
                  sta         $64ef             
pyrpxloutp3_s2    dec         pyrpxlondx        ;decrease aniamtion frame index

                  jmp         ir06_e            

;============================================================================================================================================================
                                                ;create the four different characters needed for the pixel wave by merging them with the grid
                                                ;the pixels are actually 2x2 pixels

PXLWVCHRS1        cmp         #$12              ;check for current animation part
                  bcc         pxlwvchrs1_1      ;if not $12 or $13, skip ahead
                  cmp         #$14              
                  bcc         pxlwvchrs1_2      

pxlwvchrs1_1      jmp         PXLWVCHRS2

pxlwvchrs1_2      lda         #$01              ;in theory only needed once when part $12 starts - however, adding this to the end $11 would have meant
                  sta         $d022             ;restructuring the code due to raster timing, therefore the lazy solution was chosen here :)
                  lda         $67e0             ;add pixel in bytes $00 and $01 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e0             
                  sta         $67e1             

                  lda         $67ea             ;add pixel in bytes $02 and $03 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ea             
                  sta         $67eb             

                  lda         $67f4             ;add pixel in bytes $04 and $05 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f4             
                  sta         $67f5             

                  lda         $67fe             ;add pixel in bytes $06 and $07 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fe             
                  sta         $67ff             

                  jmp         ir06_e            

;============================================================================================================================================================
                                                ;create the four different characters needed for the pixel wave by merging them with the grid,
                                                ;but here, the pixel moves up and down in every char

PXLWVCHRS2        cmp         #$14              ;check for current animation part
                  beq         pxlwvchrs2_1      ;if not $14 or $15, skip ahead
                  cmp         #$15              
                  beq         pxlwvchrs2_1      
                  jmp         WHTNSBR           

pxlwvchrs2_1      ldx         pxlwvchrsndx      ;check animation frame index and branch accordingly
                  bne         pxlwvchrs2_2      

                  jmp         pxlwvchrs2f0      

pxlwvchrs2_2      cpx         #$01
                  bne         pxlwvchrs2_3      

                  jmp         pxlwvchrs2f1      

pxlwvchrs2_3      cpx         #$02
                  bne         pxlwvchrs2_4      

                  jmp         pxlwvchrs2f2      

pxlwvchrs2_4      cpx         #$03
                  bne         pxlwvchrs2_5      

                  jmp         pxlwvchrs2f3      

pxlwvchrs2_5      cpx         #$04
                  bne         pxlwvchrs2f5      

                  jmp         pxlwvchrs2f4      

                                                ;animation frame $05
pxlwvchrs2f5      lda         $67e0             ;add pixel in bytes $00 and $01 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e0             
                  sta         $67e1             

                  lda         $67ea             ;add pixel in bytes $02 and $03 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ea             
                  sta         $67eb             

                  lda         $67f4             ;add pixel in bytes $04 and $05 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f4             
                  sta         $67f5             

                  lda         $67fe             ;add pixel in bytes $06 and $07 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fe             
                  sta         $67ff             

                  jmp         pxlwvchrs2_6      

                                                ;animation frame $04
pxlwvchrs2f4      lda         $67e2             ;add pixel in bytes $02 and $03 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e2             
                  sta         $67e3             

                  lda         $67e8             ;add pixel in bytes $00 and $01 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67e8             
                  sta         $67e9             

                  lda         $67f2             ;add pixel in bytes $02 and $03 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f2             
                  sta         $67f3             

                  lda         $67fc             ;add pixel in bytes $04 and $05 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fc             
                  sta         $67fd             

                  jmp         pxlwvchrs2_6      

                                                ;animation frame $03
pxlwvchrs2f3      lda         $67e4             ;add pixel in bytes $04 and $05 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e4             
                  sta         $67e5             

                  lda         $67ea             ;add pixel in bytes $02 and $03 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ea             
                  sta         $67eb             

                  lda         $67f0             ;add pixel in bytes $00 and $01 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f0             
                  sta         $67f1             

                  lda         $67fa             ;add pixel in bytes $02 and $03 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fa             
                  sta         $67fb             

                  jmp         pxlwvchrs2_6      

                                                ;animation frame $02
pxlwvchrs2f2      lda         $67e6             ;add pixel in bytes $06 and $07 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e6             
                  sta         $67e7             

                  lda         $67ec             ;add pixel in bytes $04 and $05 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ec             
                  sta         $67ed             

                  lda         $67f2             ;add pixel in bytes $02 and $03 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f2             
                  sta         $67f3             

                  lda         $67f8             ;add pixel in bytes $00 and $01 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67f8             
                  sta         $67f9             

                  jmp         pxlwvchrs2_6      

                                                ;animation frame $01
pxlwvchrs2f1      lda         $67e4             ;add pixel in bytes $04 and $05 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e4             
                  sta         $67e5             

                  lda         $67ee             ;add pixel in bytes $06 and $07 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ee             
                  sta         $67ef             

                  lda         $67f4             ;add pixel in bytes $04 and $05 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f4             
                  sta         $67f5             

                  lda         $67fa             ;add pixel in bytes $02 and $03 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fa             
                  sta         $67fb             

                  jmp         pxlwvchrs2_6      

                                                ;animation frame $00
pxlwvchrs2f0      lda         $67e2             ;add pixel in bytes $02 and $03 of character $fc
                  and         #$cf              
                  ora         #$10              
                  sta         $67e2             
                  sta         $67e3             

                  lda         $67ec             ;add pixel in bytes $04 and $05 of character $fd
                  and         #$cf              
                  ora         #$10              
                  sta         $67ec             
                  sta         $67ed             

                  lda         $67f6             ;add pixel in bytes $06 and $07 of character $fe
                  and         #$cf              
                  ora         #$10              
                  sta         $67f6             
                  sta         $67f7             

                  lda         $67fc             ;add pixel in bytes $04 and $05 of character $ff
                  and         #$cf              
                  ora         #$10              
                  sta         $67fc             
                  sta         $67fd             

                                                ;create character $eb with static pixel for the start of the scroller
pxlwvchrs2_6      lda         $60f0
                  sta         $6758             
                  sta         $6759             
                  lda         $60f2             
                  sta         $675a             
                  sta         $675b             
                  lda         $60f4             
                  and         #$cf              
                  ora         #$10              
                  sta         $675c             
                  sta         $675d             
                  lda         $60f6             
                  sta         $675e             
                  sta         $675f             

                  dec         pxlwvchrsdly      ;decrease delay
                  beq         pxlwvchrs2_7      ;if not $00, skip ahead

                  jmp         ir06_e            

pxlwvchrs2_7      lda         #$06              ;restore delay
                  sta         pxlwvchrsdly      
                  dex                           ;decrease animation frame index
                  bpl         pxlwvchrs2_8      ;if it drops below $00, restore start value
                  ldx         #$05              
pxlwvchrs2_8      stx         pxlwvchrsndx


                  jmp         ir06_e            

;============================================================================================================================================================
                                                ;white noise bar
                                                ;consists of 4 x-stretched sprites displayed behind the characters

WHTNSBR           cmp         #$16
                  beq         whtnsbr_1         

                  jmp         ir06_e            

whtnsbr_1         lda         #$07              ;display sprites $00-02 behind the graphics
                  sta         $d01b             
                  lda         #$00              ;turn off y stretch
                  sta         $d017             
                  ldx         #$77              ;set pointers for sprites $00-02 to empty sprite (the proper pointer is set once the top raster line of the monitor is reached
                  stx         $4bf8             ;so the bar can come in one line at a time into the monitor)
                  stx         $4bf9             
                  stx         $4bfa             
                  lda         #$70              ;set x coordinates for sprites $00-03
                  sta         $d000             
                  lda         #$a4              
                  sta         $d002             
                  lda         #$d8              
                  sta         $d004             
                  lda         #$01              ;set color for sprites $00-02
                  sta         $d027             
                  sta         $d028             
                  sta         $d029             

                  lda         whtnsdly          ;check delay
                  bne         whtnsbr_3         ;if > $00, skip ahead
                  lda         #$03              ;reset delay
                  sta         whtnsdly          
                  ldx         whtnsbry          ;increase y coordinate for bar
                  inx
                  cpx         #$dd              ;check if maximum has been reached
                  bne         whtnsbr_2         
                  ldx         #$9e              ;reset y coordinate
                  dec         whtnsdur          ;decrease duration counter
                  bne         whtnsbr_2         ;if not $00, skip ahead
                  lda         #$17              ;activate next animation part
                  sta         mnanipt           

whtnsbr_2         stx         whtnsbry

whtnsbr_3         lda         whtnsbry          ;set y coordinates for sprites $00-02
                  sta         $d001             
                  sta         $d003             
                  sta         $d005             

;============================================================================================================================================================

ir06_e            lda         #$64              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir07            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir07            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir07              lda         #<ir07_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir07_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir07 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir07_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir07_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $65
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir07_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$60              ;(2 cycles)
                  bne         ir07_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir07_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir07_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir07_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $66
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$60              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir07_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir07_5            ;(3 cycles) branch is always taken

ir07_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir07_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)
                  
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;display sawtooth part 4

DISPSAW4          ldx         mnanipt           ;check current monitor animation part
                  beq         dispsaw4_1        ;if not $01, $02 or $03 skip
                  cpx         #$04              
                  bcc         dispsaw4_2        
dispsaw4_1        jmp         PYRPXLP1
dispsaw4_2        lda         swtindly          ;check delay for animation
                  beq         dispsaw4_3        ;skip ahead if not $00

                  jmp         ir07_e            

dispsaw4_3        cpx         #$01              ;in animation part $01, the delay reset must take place in SWTIN5, because
                  beq         dispsaw4_4        ;SWTIN1,3,5 use the same delay
                  lda         #$06              ;reset delay
                  sta         swtindly          
                  cpx         #$02              ;in animation part $02, the duration for remaining in the part is counted down
                  bne         dispsaw4_4        
                  dec         swtdur            
                  bne         dispsaw4_4        
                  lda         #$03              ;activate next animation part
                  sta         mnanipt           
                  lda         #$4e              ;restore variable for finished animation part
                  sta         swtdur            

                                                ;draw sawtooth for monitor rows 1, 3 & 5
                                                ;6 differenct characters are used in each row
dispsaw4_4        ldx         swtanindx         ;load offset for fetching sawtooth characters
                  lda         swtrwd1+3,x       ;row 3
                  sta         $4b04             
                  sta         $4b0a             
                  sta         $4b10             
                  lda         swtrwd1,x         
                  sta         $4ab4             ;row 1
                  sta         $4aba             
                  sta         $4ac0             
                  sta         $4b54             ;row 5
                  sta         $4b5a             
                  sta         $4b60             
                  dex
                  lda         swtrwd1+3,x       ;row 3
                  sta         $4b03             
                  sta         $4b09             
                  sta         $4b0f             
                  sta         $4b15             
                  lda         swtrwd1,x         
                  sta         $4ab3             ;row 1
                  sta         $4ab9             
                  sta         $4abf             
                  sta         $4ac5             
                  sta         $4b53             ;row 5
                  sta         $4b59             
                  sta         $4b5f             
                  sta         $4b65             

                  dec         swtanindx         

                  jmp         ir07_e            

;============================================================================================================================================================
                                                ;pixel in the pyramid in the rectangle part 1

PYRPXLP1          cpx         #$0a              ;check for current animation part
                  beq         pyrpxlp1_s1       ;if not $0a, skip ahead

                  jmp         PXLSCRLLR1        

pyrpxlp1_s1       dec         mnanidly10        ;decrease delay
                  beq         pyrpxlp1_s2       

                  jmp         ir07_e            ;if not $00, skip ahead

pyrpxlp1_s2       lda         pyrpxlndx         ;check if animation frame index is >= $00
                  bpl         pyrpxlp1_1        
                  lda         #$0b              ;if it is < $00, activate next animation part
                  sta         mnanipt           
                  lda         #$50              
                  sta         mnanidly10        

                  jmp         ir07_e            

pyrpxlp1_1        tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcc         pyrpxlp1_1_2      
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxlp1_1_1      lda         $b298             ;load byte $00 of $94 pyramid character from backup data
                  and         pxland1,x         ;erase all bits that are not pixeled in
                  ora         pxlora1,x         ;set erased bit to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a0             ;store in byte $00 and $01 of $94 character in actual font data
                  sta         $64a1             
                  lda         $b29c             ;load byte $03 of $94 pyramid character from backup data
                  and         pxland2,x         ;erase all bits that are not pixeled in
                  ora         pxlora2,x         ;set erased bit to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a4             ;store in byte $04 and $05 of $94 character in actual font data
                  sta         $64a5             
                  lda         $b2a0             ;process character $95
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64a8             
                  sta         $64a9             
                  lda         $b2a4             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64ac             
                  sta         $64ad             
                  lda         $b2a8             ;process character $96
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64b0             
                  sta         $64b1             
                  lda         $b2ac             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64b4             
                  sta         $64b5             
                  lda         $b2b0             ;process character $97
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64b8             
                  sta         $64b9             
                  lda         $b2b4             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64bc             
                  sta         $64bd             

                  jmp         ir07_e            

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxlp1_1_2      lda         $b29a             ;load byte $02 of $94 pyramid character from backup data
                  and         pxland1,x         ;erase all bits that are not pixeled in yet
                  ora         pxlora1,x         ;set erased bits to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a2             ;store in byte $02 and $03 of $94 character in actual font data
                  sta         $64a3             
                  lda         $b29e             ;load byte $06 of $94 pyramid character from backup data
                  and         pxland2,x         ;erase all bits that are not pixeled in yet
                  ora         pxlora2,x         ;set erased bits to %01 combination (i.e. multicolor $d022/ flashing rectangle color)
                  sta         $64a6             ;store in byte $06 and $07 of $94 character in actual font data
                  sta         $64a7             
                  lda         $b2a2             ;process character $95
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64aa             
                  sta         $64ab             
                  lda         $b2a6             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64ae             
                  sta         $64af             
                  lda         $b2aa             ;process character $96
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64b2             
                  sta         $64b3             
                  lda         $b2ae             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64b6             
                  sta         $64b7             
                  lda         $b2b2             ;process character $97
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64ba             
                  sta         $64bb             
                  lda         $b2b6             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64be             
                  sta         $64bf             

                  jmp         ir07_e            

;============================================================================================================================================================
                                                ;display pixel scroll in row 1 of monitor ;display pixel scroll in row 1 of monitor (animation part $12)
                                                ;not enough cycles for the whole row, so is continued in PXLSCRLLR2

PXLSCRLLR1        cpx         #$12              ;check for current animation part
                  beq         pxlscrllr1_1      ;if not $12, skip ahead

                  jmp         PXLWV1            

pxlscrllr1_1      dec         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir07_e            

                  ldy         #$12              
                  lda         ($fd),y           
                  sta         $4ac5             
                  dey
                  lda         ($fd),y           
                  sta         $4ac4             
                  dey
                  lda         ($fd),y           
                  sta         $4ac3             
                  dey
                  lda         ($fd),y           
                  sta         $4ac2             
                  dey
                  lda         ($fd),y           
                  sta         $4ac1             
                  dey
                  lda         ($fd),y           
                  sta         $4ac0             
                  dey
                  lda         ($fd),y           
                  sta         $4abf             
                  dey
                  lda         ($fd),y           
                  sta         $4abe             
                  dey
                  lda         ($fd),y           
                  sta         $4abd             
                  dey
                  lda         ($fd),y           
                  sta         $4abc             
                  dey
                  lda         ($fd),y           
                  sta         $4abb             
                  dey
                  lda         ($fd),y           
                  sta         $4aba             
                  dey
                  lda         ($fd),y           
                  sta         $4ab9             
                  dey
                  lda         ($fd),y           
                  sta         $4ab8             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir07_e            

;============================================================================================================================================================
                                                ;display waves in the pixel field in monitor row 1

PXLWV1            cpx         #$13              ;check for current animation part
                  bne         pxlwv1_0          ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check if animation subpart is < $0c
                  cpy         #$0c              
                  bcc         pxlwv1_1          

pxlwv1_0          jmp         PXLSCRLRL1

pxlwv1_1          dec         pxlwvdly1         ;decrease delay
                  beq         pxlwv1_2          ;if delay is > $0, skip ahead
                  jmp         ir07_e            
pxlwv1_2          lda         #$06              ;restore delay
                  sta         pxlwvdly1         
                  ldx         pxlwvndx1         ;set index for fetching character data
                  lda         pxlwvd1,x         ;fetch character code
                  sta         $4abc             ;store in required screen memory locations

                  ldy         pxlwvsubpt        ;check animation sub part
                  cpy         #$05              ;if it is < $05, no more characters in screen memory need to be altered
                  bcc         pxlwv1_8          

                  sta         $4ab6             
                  sta         $4ac2             
                  dex                           ;decrease index to fetch code for next character
                  bpl         pxlwv1_3          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv1_3          lda         pxlwvd1,x
                  sta         $4ab5             
                  sta         $4abb             
                  sta         $4ac1             
                  dex
                  bpl         pxlwv1_4          
                  ldx         #$05              
pxlwv1_4          lda         pxlwvd1,x
                  sta         $4ab4             
                  sta         $4aba             
                  sta         $4ac0             
                  dex
                  bpl         pxlwv1_5          
                  ldx         #$05              
pxlwv1_5          lda         pxlwvd1,x
                  sta         $4ab3             
                  sta         $4ab9             
                  sta         $4abf             
                  sta         $4ac5             
                  dex
                  bpl         pxlwv1_6          
                  ldx         #$05              
pxlwv1_6          lda         pxlwvd1,x
                  sta         $4ab8             
                  sta         $4abe             
                  sta         $4ac4             
                  dex
                  bpl         pxlwv1_7          
                  ldx         #$05              
pxlwv1_7          lda         pxlwvd1,x
                  sta         $4ab7             
                  sta         $4abd             
                  sta         $4ac3             

pxlwv1_8          ldx         pxlwvndx1         ;fetch current index
                  dex                           ;decrease by one for next animation frame
                  bpl         pxlwv1_9          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv1_9          stx         pxlwvndx1

                  lda         pxlwvsubpt        
                  cmp         #$03              
                  bcs         ir07_e            
                  dec         pxlwvsubdly1      
                  bne         ir07_e            
                  inc         pxlwvsubpt        
                  lda         #$05              
                  sta         pxlwvsubdly1      

                  jmp         ir07_e            

;============================================================================================================================================================
                                                ;display pixel scroll in row 1 of monitor (animation part $15)
                                                ;not enough cycles for the whole row, so is continued in PXLSCRLLR2

PXLSCRLRL1        cpx         #$15              ;check for current animation part
                  beq         pxlscrlrl1_1      ;if not $15, skip ahead

                  jmp         ir07_e            

pxlscrlrl1_1      dec         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir07_e            

                  ldy         #$00              
                  lda         ($fd),y           
                  sta         $4ab3             
                  iny
                  lda         ($fd),y           
                  sta         $4ab4             
                  iny
                  lda         ($fd),y           
                  sta         $4ab5             
                  iny
                  lda         ($fd),y           
                  sta         $4ab6             
                  iny
                  lda         ($fd),y           
                  sta         $4ab7             
                  iny
                  lda         ($fd),y           
                  sta         $4ab8             
                  iny
                  lda         ($fd),y           
                  sta         $4ab9             
                  iny
                  lda         ($fd),y           
                  sta         $4aba             
                  iny
                  lda         ($fd),y           
                  sta         $4abb             
                  iny
                  lda         ($fd),y           
                  sta         $4abc             
                  iny
                  lda         ($fd),y           
                  sta         $4abd             
                  iny
                  lda         ($fd),y           
                  sta         $4abe             
                  iny
                  lda         ($fd),y           
                  sta         $4abf             
                  iny
                  lda         ($fd),y           
                  sta         $4ac0             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir07_e            lda         #$6c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir08            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir08            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir08              lda         #<ir08_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir08_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir08 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir08_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir08_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $6C
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir08_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$60              ;(2 cycles)
                  bne         ir08_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir08_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir08_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir08_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $6D
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$60              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir08_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir08_5            ;(3 cycles) branch is always taken

ir08_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir08_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)
                  
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;part 1 of masking out the characters to the left on row 1 of the monitor
                                                ;so it seems the sawtooth is coming in from the right
                                                ;on each iteration, one character less is masked out

SWTIN1            ldx         mnanipt           ;check current monitor animation part
                  cpx         #$01              
                  beq         swtin1_s1         ;if not $01, skip
                  jmp         FLTLIN1           
swtin1_s1         lda         swtindly          ;check delay for animation
                  beq         swtin1_s2         ;skip ahead if not $00

                  jmp         ir08_e            

swtin1_s2         ldx         swtrw1            ;load masking index for row 1
                  bne         swtin1_s3         ;if = $00, this part can be skipped

                  jmp         ir08_e            

swtin1_s3         lda         #$ff
                  sta         $4ab3,x           
                  dex
                  bpl         *-4               
                  dec         swtrw1            

                  jmp         ir08_e            

;============================================================================================================================================================
                                                ;bring in flatline in monitor row $01
                                                ;overwrites the sawtooth chars written to the screen before
                                                ;optimization possible: draw only the sawtooth chars still needed to avoid writing ot the same screen location 2x

FLTLIN1           cpx         #$03
                  bne         PYRPXLP2          
                  lda         #$25              ;load character code for flatline in monitor row $01
mcode1            bne         fltlin1_s1        ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip drawing those characters that the flatline has not yet reached
                  sta         $4ab3             ;draw flatline characters in monitor row $01
                  sta         $4ab3+1           
                  sta         $4ab3+2           
                  sta         $4ab3+3           
                  sta         $4ab3+4           
                  sta         $4ab3+5           
                  sta         $4ab3+6           
                  sta         $4ab3+7           
                  sta         $4ab3+8           
                  sta         $4ab3+9           
                  sta         $4ab3+10          
                  sta         $4ab3+11          
                  sta         $4ab3+12          
                  sta         $4ab3+13          
                  sta         $4ab3+14          
                  sta         $4ab3+15          
                  sta         $4ab3+16          
                  sta         $4ab3+17          
fltlin1_s1        sta         $4ab3+18
                  dec         mnanidly3         ;decrease delay
                  bne         fltlin1_s2        ;if it is $00, the next frame of this animation part has been reached; note: delay is reset in FLTLIN5
                  lda         fltlnrw1          ;if the index for this flatline row is $00, no more code modification is needed
                  beq         fltlin1_s2        
                  lda         mcode1+1          ;modify the code to the drawing of 1 less character is skipped above (i.e. the flatline has progressed one character)
                  sec
                  sbc         #$03              
                  sta         mcode1+1          
                  dec         fltlnrw1          ;decrease the index for this flatline row

fltlin1_s2        jmp         ir08_e

;============================================================================================================================================================
                                                ;pixel in the pyramid in the rectangle part 2

PYRPXLP2          cpx         #$0a              ;check for current animation part
                  beq         pyrpxlp2_s1       ;if not $0a, skip ahead

                  jmp         PXLSCRLLR2        

pyrpxlp2_s1       lda         mnanidly10        ;check if delay is $00
                  beq         pyrpxlp2_1        

                  jmp         ir08_e            ;if not $00, skip ahead

pyrpxlp2_1        lda         pyrpxlndx         ;load animation frame index
                  tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcc         pyrpxlp2_1_2      
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxlp2_1_1      lda         $b2b8             ;process character $98
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64c0             
                  sta         $64c1             
                  lda         $b2bc             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64c4             
                  sta         $64c5             
                  lda         $b2c0             ;process character $99
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64c8             
                  sta         $64c9             
                  lda         $b2c4             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64cc             
                  sta         $64cd             
                  lda         $b2c8             ;process character $9a
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64d0             
                  sta         $64d1             
                  lda         $b2cc             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64d4             
                  sta         $64d5             

                  jmp         ir08_e            

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxlp2_1_2      lda         $b2ba             ;process character $98
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64c2             
                  sta         $64c3             
                  lda         $b2be             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64c6             
                  sta         $64c7             
                  lda         $b2c2             ;process character $99
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64ca             
                  sta         $64cb             
                  lda         $b2c6             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64ce             
                  sta         $64cf             
                  lda         $b2ca             ;process character $9a
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64d2             
                  sta         $64d3             
                  lda         $b2ce             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64d6             
                  sta         $64d7             

                  jmp         ir08_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 1 of monitor and start with row 2 of monitor (animation part $12)

PXLSCRLLR2        cpx         #$12              ;check for current animation part
                  beq         pxlscrllr2_1      ;if not $12, skip ahead

                  jmp         PXLWV2            

pxlscrllr2_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir08_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4ab7             
                  dey
                  lda         ($fd),y           
                  sta         $4ab6             
                  dey
                  lda         ($fd),y           
                  sta         $4ab5             
                  dey
                  lda         ($fd),y           
                  sta         $4ab4             
                  dey
                  lda         ($fd),y           
                  sta         $4ab3             

                  ldy         #$12              
                  inc         $fe               ;set address for reading data for monitor row 2 (+$100)

                  lda         ($fd),y           
                  sta         $4aed             
                  dey
                  lda         ($fd),y           
                  sta         $4aec             
                  dey
                  lda         ($fd),y           
                  sta         $4aeb             
                  dey
                  lda         ($fd),y           
                  sta         $4aea             
                  dey
                  lda         ($fd),y           
                  sta         $4ae9             
                  dey
                  lda         ($fd),y           
                  sta         $4ae8             
                  dey
                  lda         ($fd),y           
                  sta         $4ae7             
                  dey
                  lda         ($fd),y           
                  sta         $4ae6             
                  dey
                  lda         ($fd),y           
                  sta         $4ae5             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir08_e            

;============================================================================================================================================================
                                                ;display waves in the pixel field in monitor row 2

PXLWV2            cpx         #$13              ;check for current animation part
                  bne         pxlwv2_0          ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check if animation subpart is < $0b
                  cpy         #$0b              
                  bcc         pxlwv2_1          

pxlwv2_0          jmp         PXLSCRLRL2

pxlwv2_1          dec         pxlwvdly2         ;decrease delay
                  beq         pxlwv2_2          ;if delay is > $0, skip ahead
                  jmp         ir08_e            
pxlwv2_2          lda         #$06              ;restore delay
                  sta         pxlwvdly2         

                  ldy         pxlwvsubpt        ;check animation sub part
                  beq         pxlwv2_8          ;if it is $00, nothing needs to be done

                  ldx         pxlwvndx2         ;set index for fetching character data
                  lda         pxlwvd1,x         ;fetch character code
                  sta         $4ae4             ;store in all required screen memory locations

                  cpy         #$04              ;if animation sub part is < $04, no more characters need to be changed
                  bcc         pxlwv2_8          

                  sta         $4ade             
                  sta         $4aea             
                  dex                           ;decrease index to fetch code for next character
                  bpl         pxlwv2_3          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv2_3          lda         pxlwvd1,x
                  sta         $4add             
                  sta         $4ae3             
                  sta         $4ae9             
                  dex
                  bpl         pxlwv2_4          
                  ldx         #$05              
pxlwv2_4          lda         pxlwvd1,x
                  sta         $4adc             
                  sta         $4ae2             
                  sta         $4ae8             
                  dex
                  bpl         pxlwv2_5          
                  ldx         #$05              
pxlwv2_5          lda         pxlwvd1,x
                  sta         $4adb             
                  sta         $4ae1             
                  sta         $4ae7             
                  sta         $4aed             
                  dex
                  bpl         pxlwv2_6          
                  ldx         #$05              
pxlwv2_6          lda         pxlwvd1,x
                  sta         $4ae0             
                  sta         $4ae6             
                  sta         $4aec             
                  dex
                  bpl         pxlwv2_7          
                  ldx         #$05              
pxlwv2_7          lda         pxlwvd1,x
                  sta         $4adf             
                  sta         $4ae5             
                  sta         $4aeb             

pxlwv2_8          ldx         pxlwvndx2         ;fetch current index
                  dex                           ;decrease by one for next animation frame
                  bpl         pxlwv2_9          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv2_9          stx         pxlwvndx2

                  jmp         ir08_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 1 of monitor and start with row 2 of monitor (animation part $15)

PXLSCRLRL2        cpx         #$15              ;check for current animation part
                  beq         pxlscrlrl2_1      ;if not $15, skip ahead

                  jmp         ir08_e            

pxlscrlrl2_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir08_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4ac1             
                  iny
                  lda         ($fd),y           
                  sta         $4ac2             
                  iny
                  lda         ($fd),y           
                  sta         $4ac3             
                  iny
                  lda         ($fd),y           
                  sta         $4ac4             
                  iny
                  lda         ($fd),y           
                  sta         $4ac5             

                  ldy         #$00              
                  inc         $fe               ;set address for reading data for monitor row 2 (+$100)

                  lda         ($fd),y           
                  sta         $4adb             
                  iny
                  lda         ($fd),y           
                  sta         $4adc             
                  iny
                  lda         ($fd),y           
                  sta         $4add             
                  iny
                  lda         ($fd),y           
                  sta         $4ade             
                  iny
                  lda         ($fd),y           
                  sta         $4adf             
                  iny
                  lda         ($fd),y           
                  sta         $4ae0             
                  iny
                  lda         ($fd),y           
                  sta         $4ae1             
                  iny
                  lda         ($fd),y           
                  sta         $4ae2             
                  iny
                  lda         ($fd),y           
                  sta         $4ae3             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir08_e            lda         #$74              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir09            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir09            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir09              lda         #<ir09_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir09_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir09 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir09_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir09_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $75
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir09_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$60              ;(2 cycles)
                  bne         ir09_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir09_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir09_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir09_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $76
                                                ;=> 1-2 cycles have passed
                  nop                           ;(2 cycles)
                  ldy         #$09              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT raster line
                  sta         $d020             ;(4 cycles) reset border color

;============================================================================================================================================================
                                                ;mask out the characters to the left on row $03 of the monitor
                                                ;so it seems the sawtooth is coming in from the right
                                                ;on each iteration, one character less is masked out

SWTIN3            ldx         mnanipt           ;check current monitor animation part
                  cpx         #$01              
                  beq         swtin3_s1         ;if not $01, skip
                  jmp         FLTLIN3           
swtin3_s1         lda         swtindly          ;check delay for animation
                  beq         swtin3_s2         ;skip ahead if not $00

                  jmp         ir09_e            

swtin3_s2         ldx         swtrw3            ;load masking index for row 3
                  bne         swtin3_s3         ;if = $00, no more masking is needed

                  jmp         ir09_e            

swtin3_s3         cpx         #$12
                  bcc         swtin3_s4         
                  ldx         #$12              ;if >= $12, the whole row needs to be masked (i.e. bringing in the row has not started yet)
swtin3_s4         lda         #$ff
                  sta         $4b03,x           
                  dex
                  bpl         *-4               
                  dec         swtrw3            ;decrease masking index for row 5

                  jmp         ir09_e            

;============================================================================================================================================================
                                                ;bring in flatline in monitor row $03
                                                ;overwrites the sawtooth chars written to the screen before
                                                ;optimization possible: draw only the sawtooth chars still needed to avoid writing ot the same screen location 2x

FLTLIN3           cpx         #$03              ;check current monitor animation part
                  beq         fltlin3_s1        ;if not $03, skip ahead
                  jmp         PYRPXLP3          
fltlin3_s1        lda         fltlnrw3          ;if index for flatline row $03 is >= $13, nothing need to be drawn in this row (this flatline comes
                  cmp         #$13              ;in later than the row $01 one)
                  bcs         fltlin3_s2        
                  lda         #$26              ;load character code for flatline in monitor row $03
mcode2            bne         fltlin3_s3        ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip drawing those characters that the flatline has not yet reached
                  sta         $4b03             ;draw flatline characters in monitor row $03
                  sta         $4b03+1           
                  sta         $4b03+2           
                  sta         $4b03+3           
                  sta         $4b03+4           
                  sta         $4b03+5           
                  sta         $4b03+6           
                  sta         $4b03+7           
                  sta         $4b03+8           
                  sta         $4b03+9           
                  sta         $4b03+10          
                  sta         $4b03+11          
                  sta         $4b03+12          
                  sta         $4b03+13          
                  sta         $4b03+14          
                  sta         $4b03+15          
                  sta         $4b03+16          
                  sta         $4b03+17          
fltlin3_s3        sta         $4b03+18
fltlin3_s2        lda         mnanidly3         ;check delay - if > $00, nothing needs to be done
                  bne         fltlin3_s4        
                  lda         fltlnrw3          ;if the index for this flatline row is $00, no more code modification is needed
                  beq         fltlin3_s4        
                  lda         fltlnrw3          ;if index for flatline row $03 is >= $13, no code changes are needed yet
                  cmp         #$13              
                  bcs         fltlin3_s5        
                  lda         mcode2+1          ;modify the code to the drawing of 1 less character is skipped above (i.e. the flatline has progressed one character)
                  sec
                  sbc         #$03              
                  sta         mcode2+1          
fltlin3_s5        dec         fltlnrw3          ;decrease the index for this flatline row

fltlin3_s4        jmp         ir09_e


;============================================================================================================================================================

                                                ;pixel in the pyramid in the rectangle part 3

PYRPXLP3          cpx         #$0a              ;check for current animation part
                  beq         pyrpxlp3_s1       ;if not $0a, skip ahead

                  jmp         PXLSCRLLR3        

pyrpxlp3_s1       lda         mnanidly10        ;check if delay is $00
                  beq         pyrpxlp3_1        

                  jmp         ir09_e            ;if not $00, skip ahead

pyrpxlp3_1        lda         #$04              ;restore delay
                  sta         mnanidly10        
                  lda         pyrpxlndx         ;load animation index
                  tax                           ;index is needed in X to fetch pixelate data
                  lsr                           ;check if the frame index is odd or even an jump to the corresponding animation part
                  bcc         pyrpxlp3_1_2      
                                                ;frames $07,$05,$03,$01 of animation
                                                ;this part of the animation oinly changes bytes $00,$01,$04,$05
pyrpxlp3_1_1      lda         $b2d0             ;process character $9b
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64d8             
                  sta         $64d9             
                  lda         $b2d4             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64dc             
                  sta         $64dd             
                  lda         $b2d8             ;process character $9c
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64e0             
                  sta         $64e1             
                  lda         $b2dc             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64e4             
                  sta         $64e5             
                  lda         $b2e0             ;process character $9d
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64e8             
                  sta         $64e9             
                  lda         $b2e4             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64ec             
                  sta         $64ed             
                  jmp         pyrpxlp3_s2       

                                                ;frames $06,$04,$02,$00 of animation
                                                ;this part of the animation only changes bytes $02,$03,$06,$07
pyrpxlp3_1_2      lda         $b2d2             ;process character $9b
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64da             
                  sta         $64db             
                  lda         $b2d6             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64de             
                  sta         $64df             
                  lda         $b2da             ;process character $9c
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64e2             
                  sta         $64e3             
                  lda         $b2de             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64e6             
                  sta         $64e7             
                  lda         $b2e2             ;process character $9d
                  and         pxland1,x         
                  ora         pxlora1,x         
                  sta         $64ea             
                  sta         $64eb             
                  lda         $b2e6             
                  and         pxland2,x         
                  ora         pxlora2,x         
                  sta         $64ee             
                  sta         $64ef             
pyrpxlp3_s2       dec         pyrpxlndx         ;decrease animation frame index

                  jmp         ir09_e            

;============================================================================================================================================================

                                                ;complete display of pixel wave in row 2 of monitor and start with row 3 of monitor (animation part $12)

PXLSCRLLR3        cpx         #$12              ;check for current animation part
                  beq         pxlscrllr3_1      ;if not $12, skip ahead

                  jmp         PXLWV3            

pxlscrllr3_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir09_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4ae4             
                  dey
                  lda         ($fd),y           
                  sta         $4ae3             
                  dey
                  lda         ($fd),y           
                  sta         $4ae2             
                  dey
                  lda         ($fd),y           
                  sta         $4ae1             
                  dey
                  lda         ($fd),y           
                  sta         $4ae0             
                  dey
                  lda         ($fd),y           
                  sta         $4adf             
                  dey
                  lda         ($fd),y           
                  sta         $4ade             
                  dey
                  lda         ($fd),y           
                  sta         $4add             
                  dey
                  lda         ($fd),y           
                  sta         $4adc             
                  dey
                  lda         ($fd),y           
                  sta         $4adb             

                  ldy         #$12              
                  inc         $fe               ;set address for reading data for monitor row 3 (+$100)

                  lda         ($fd),y           
                  sta         $4b15             
                  dey
                  lda         ($fd),y           
                  sta         $4b14             
                  dey
                  lda         ($fd),y           
                  sta         $4b13             
                  dey
                  lda         ($fd),y           
                  sta         $4b12             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir09_e            

;============================================================================================================================================================

_CODE_7000

*=$7000

                                                ;display waves in the pixel field in monitor row 3

PXLWV3            cpx         #$13              ;check for current animation part
                  bne         pxlwv3_0          ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check if animation subpart is < $0a
                  cpy         #$0a              
                  bcc         pxlwv3_1          

pxlwv3_0          jmp         PXLSCRLRL3

pxlwv3_1          dec         pxlwvdly3         ;decrease delay
                  beq         pxlwv3_2          ;if delay is > $0, skip ahead
                  jmp         ir09_e            
pxlwv3_2          lda         #$06              ;restore delay
                  sta         pxlwvdly3         

                  ldy         pxlwvsubpt        ;check animation sub part
                  cpy         #$02              
                  bcc         pxlwv3_8          ;if it is < $02, nothing needs to be done

                  ldx         pxlwvndx3         ;set index for fetching character data
                  lda         pxlwvd1,x         ;fetch character code
                  sta         $4b0c             ;store in all required screen memory locations

                  cpy         #$03              ;if animation sub part is < $03, no more characters need to be changed
                  bcc         pxlwv3_8          

                  sta         $4b06             
                  sta         $4b12             
                  dex                           ;decrease index to fetch code for next character
                  bpl         pxlwv3_3          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv3_3          lda         pxlwvd1,x
                  sta         $4b05             
                  sta         $4b0b             
                  sta         $4b11             
                  dex
                  bpl         pxlwv3_4          
                  ldx         #$05              
pxlwv3_4          lda         pxlwvd1,x
                  sta         $4b04             
                  sta         $4b0a             
                  sta         $4b10             
                  dex
                  bpl         pxlwv3_5          
                  ldx         #$05              
pxlwv3_5          lda         pxlwvd1,x
                  sta         $4b03             
                  sta         $4b09             
                  sta         $4b0f             
                  sta         $4b15             
                  dex
                  bpl         pxlwv3_6          
                  ldx         #$05              
pxlwv3_6          lda         pxlwvd1,x
                  sta         $4b08             
                  sta         $4b0e             
                  sta         $4b14             
                  dex
                  bpl         pxlwv3_7          
                  ldx         #$05              
pxlwv3_7          lda         pxlwvd1,x
                  sta         $4b07             
                  sta         $4b0d             
                  sta         $4b13             

pxlwv3_8          ldx         pxlwvndx3         ;fetch current index
                  dex                           ;decrease by one for next animation frame
                  bpl         pxlwv3_9          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv3_9          stx         pxlwvndx3

                  jmp         ir09_e            


;============================================================================================================================================================
                                                ;complete display of pixel wave in row 2 of monitor and start with row 3 of monitor (animation part $15)

PXLSCRLRL3        cpx         #$15              ;check for current animation part
                  beq         pxlscrlrl3_1      ;if not $15, skip ahead

                  jmp         ir09_e            

pxlscrlrl3_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir09_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4ae4             
                  iny
                  lda         ($fd),y           
                  sta         $4ae5             
                  iny
                  lda         ($fd),y           
                  sta         $4ae6             
                  iny
                  lda         ($fd),y           
                  sta         $4ae7             
                  iny
                  lda         ($fd),y           
                  sta         $4ae8             
                  iny
                  lda         ($fd),y           
                  sta         $4ae9             
                  iny
                  lda         ($fd),y           
                  sta         $4aea             
                  iny
                  lda         ($fd),y           
                  sta         $4aeb             
                  iny
                  lda         ($fd),y           
                  sta         $4aec             
                  iny
                  lda         ($fd),y           
                  sta         $4aed             

                  ldy         #$00              
                  inc         $fe               ;set address for reading data for monitor row 3 (+$100)

                  lda         ($fd),y           
                  sta         $4b03             
                  iny
                  lda         ($fd),y           
                  sta         $4b04             
                  iny
                  lda         ($fd),y           
                  sta         $4b05             
                  iny
                  lda         ($fd),y           
                  sta         $4b06             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir09_e            lda         #$7c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir10            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir10            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir10              lda         #<ir10_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir10_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir10 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir10_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir10_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $7D
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir10_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$7a              ;(2 cycles)
                  bne         ir10_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir10_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir10_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir10_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $7E
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$7a              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir10_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir10_5            ;(3 cycles) branch is always taken

ir10_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir10_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)
                  
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;mask out the characters to the left on row 5 of the monitor
                                                ;so it seems the sawtooth is coming in from the right
                                                ;on each iteration, one character less is masked out

SWTIN5            ldx         mnanipt
                  cpx         #$01              ;check current monitor animation part
                  beq         swtin5_s1         ;if not $01, skip ahead
                  jmp         FLTLIN5           
swtin5_s1         lda         swtindly          ;check delay for animation
                  beq         swtin5_s2         ;skip ahead if not $00

                  jmp         ir10_e            

swtin5_s2         lda         #$06              ;if delay has passed, reset delay
                  sta         swtindly          
                  ldx         swtrw5            ;load masking index for row 5
                  bne         swtin5_s3         ;if = $00, no more masking is needed
                  inc         mnanipt           ;move to next monitor animation part when all rows have been moved in completely

                  jmp         ir10_e            

swtin5_s3         cpx         #$12
                  bcc         swtin5_s4         
                  ldx         #$12              ;if >= $12, the whole row needs to be masked (i.e. bringing in the row has not started yet)
swtin5_s4         lda         #$ff
                  sta         $4b53,x           
                  dex
                  bpl         *-4               
                  dec         swtrw5            ;decrease masking index for row 5

                  jmp         ir10_e            

;============================================================================================================================================================
                                                ;bring in flatline in monitor row $05
                                                ;overwrites the sawtooth chars written to the screen before
                                                ;optimization possible: draw only the sawtooth chars still needed to avoid writing ot the same screen location 2x

FLTLIN5           cpx         #$03              ;check animation part;
                  beq         fltlin5_s1        

                  jmp         PXLSCRLLR4        ;if not $03, skip ahead

fltlin5_s1        lda         fltlnrw5          ;if index for flatline row $05 is >= $13, nothing needs to be drawn in this row (this flatline comes
                  cmp         #$13              ;in later than in rows $01 and $03)
                  bcs         fltlin5_s2        
                  lda         #$27              ;load character code for flatline in monitor row $05
mcode3            bne         fltlin5_s3        ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip drawing those characters that the flatline has not yet reached
                  sta         $4b53             ;draw flatline characters in monitor row $03
                  sta         $4b53+1           
                  sta         $4b53+2           
                  sta         $4b53+3           
                  sta         $4b53+4           
                  sta         $4b53+5           
                  sta         $4b53+6           
                  sta         $4b53+7           
                  sta         $4b53+8           
                  sta         $4b53+9           
                  sta         $4b53+10          
                  sta         $4b53+11          
                  sta         $4b53+12          
                  sta         $4b53+13          
                  sta         $4b53+14          
                  sta         $4b53+15          
                  sta         $4b53+16          
                  sta         $4b53+17          
fltlin5_s3        sta         $4b53+18
fltlin5_s2        lda         mnanidly3         ;check delay - if > $00, nothing needs to be done
                  beq         fltlin5_s6        

                  jmp         ir10_e            

fltlin5_s6        lda         fltlnrw5          ;if the index for this flatline row is $00, no more code modification is needed
                  bne         fltlin5_s4        
                  lda         #$04              ;activate next animation part
                  sta         mnanipt           
                  lda         #$12              ;restore variables for finished animation part
                  sta         fltlnrw1          
                  lda         #$40              
                  sta         fltlnrw3          
                  lda         #$70              
                  sta         fltlnrw5          
                  lda         #$06              
                  sta         mnanidly3         
                  lda         #$36              ;restore the selfmodifying code in FLTLIN1,3,5
                  sta         mcode1+1          
                  sta         mcode2+1          
                  sta         mcode3+1          
                  lda         #$0b              ;restore variables for finished animation part $01
                  sta         swtanindx         ;this is done here because part of $01 keeps running while $02 and $03 are active
                  lda         #$11              
                  sta         swtrw1            
                  lda         #$30              
                  sta         swtrw3            
                  lda         #$50              
                  sta         swtrw5            
                  lda         #$06              
                  sta         swtindly          

                  jmp         ir10_e            

fltlin5_s4        lda         fltlnrw5          ;if index for flatline row $05 is >= $13, no code changes are needed yet
                  cmp         #$13              
                  bcs         fltlin5_s5        
                  lda         mcode3+1          ;modify the code to the drawing of 1 less character is skipped above (i.e. the flatline has progressed one character)
                  sec
                  sbc         #$03              
                  sta         mcode3+1          
fltlin5_s5        dec         fltlnrw5
                  lda         #$04              ;reset delay
                  sta         mnanidly3         

                  jmp         ir10_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 3 of monitor (animation part $12)

PXLSCRLLR4        cpx         #$12              ;check for current animation part
                  beq         pxlscrllr4_1      ;if not $12, skip ahead

                  jmp         PXLWV4            

pxlscrllr4_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir10_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b11             
                  dey
                  lda         ($fd),y           
                  sta         $4b10             
                  dey
                  lda         ($fd),y           
                  sta         $4b0f             
                  dey
                  lda         ($fd),y           
                  sta         $4b0e             
                  dey
                  lda         ($fd),y           
                  sta         $4b0d             
                  dey
                  lda         ($fd),y           
                  sta         $4b0c             
                  dey
                  lda         ($fd),y           
                  sta         $4b0b             
                  dey
                  lda         ($fd),y           
                  sta         $4b0a             
                  dey
                  lda         ($fd),y           
                  sta         $4b09             
                  dey
                  lda         ($fd),y           
                  sta         $4b08             
                  dey
                  lda         ($fd),y           
                  sta         $4b07             
                  dey
                  lda         ($fd),y           
                  sta         $4b06             
                  dey
                  lda         ($fd),y           
                  sta         $4b05             
                  dey
                  lda         ($fd),y           
                  sta         $4b04             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir10_e            

;============================================================================================================================================================
                                                ;display waves in the pixel field in monitor row 4

PXLWV4            cpx         #$13              ;check for current animation part
                  bne         pxlwv4_0          ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check if animation subpart is < $09
                  cpy         #$09              
                  bcc         pxlwv4_1          

pxlwv4_0          jmp         PXLSCRLRL4

pxlwv4_1          dec         pxlwvdly4         ;decrease delay
                  beq         pxlwv4_2          ;if delay is > $0, skip ahead
                  jmp         ir10_e            
pxlwv4_2          lda         #$06              ;restore delay
                  sta         pxlwvdly4         

                  ldy         pxlwvsubpt        ;check animation sub part
                  beq         pxlwv4_8          ;if it is $00, nothing needs to be done

                  ldx         pxlwvndx2         ;set index for fetching character data
                  lda         pxlwvd1,x         ;fetch character code
                  sta         $4b34             ;store in all required screen memory locations

                  cpy         #$04              ;if animation sub part is < $05, no more characters need to be changed
                  bcc         pxlwv4_8          

                  sta         $4b2e             
                  sta         $4b3a             
                  dex                           ;decrease index to fetch code for next character
                  bpl         pxlwv4_3          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv4_3          lda         pxlwvd1,x
                  sta         $4b2d             
                  sta         $4b33             
                  sta         $4b39             
                  dex
                  bpl         pxlwv4_4          
                  ldx         #$05              
pxlwv4_4          lda         pxlwvd1,x
                  sta         $4b2c             
                  sta         $4b32             
                  sta         $4b38             
                  dex
                  bpl         pxlwv4_5          
                  ldx         #$05              
pxlwv4_5          lda         pxlwvd1,x
                  sta         $4b2b             
                  sta         $4b31             
                  sta         $4b37             
                  sta         $4b3d             
                  dex
                  bpl         pxlwv4_6          
                  ldx         #$05              
pxlwv4_6          lda         pxlwvd1,x
                  sta         $4b30             
                  sta         $4b36             
                  sta         $4b3c             
                  dex
                  bpl         pxlwv4_7          
                  ldx         #$05              
pxlwv4_7          lda         pxlwvd1,x
                  sta         $4b2f             
                  sta         $4b35             
                  sta         $4b3b             

pxlwv4_8          ldx         pxlwvndx4         ;fetch current index
                  dex                           ;decrease by one for next animation frame
                  bpl         pxlwv4_9          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv4_9          stx         pxlwvndx4

                  jmp         ir10_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 3 of monitor (animation part $15)

PXLSCRLRL4        cpx         #$15              ;check for current animation part
                  beq         pxlscrlrl4_1      ;if not $15, skip ahead

                  jmp         ir10_e            

pxlscrlrl4_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir10_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b07             
                  iny
                  lda         ($fd),y           
                  sta         $4b08             
                  iny
                  lda         ($fd),y           
                  sta         $4b09             
                  iny
                  lda         ($fd),y           
                  sta         $4b0a             
                  iny
                  lda         ($fd),y           
                  sta         $4b0b             
                  iny
                  lda         ($fd),y           
                  sta         $4b0c             
                  iny
                  lda         ($fd),y           
                  sta         $4b0d             
                  iny
                  lda         ($fd),y           
                  sta         $4b0e             
                  iny
                  lda         ($fd),y           
                  sta         $4b0f             
                  iny
                  lda         ($fd),y           
                  sta         $4b10             
                  iny
                  lda         ($fd),y           
                  sta         $4b11             
                  iny
                  lda         ($fd),y           
                  sta         $4b12             
                  iny
                  lda         ($fd),y           
                  sta         $4b13             
                  iny
                  lda         ($fd),y           
                  sta         $4b14             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir10_e            lda         #$84              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir11            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir11            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir11              lda         #<ir11_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir11_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir11 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir11_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir11_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $85
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir11_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$7a              ;(2 cycles)
                  bne         ir11_2            ;(4 cycles - page boundary crossed) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$04              ;(2 cycles)
                  nop                           ;(2 cycles)
                  bne         ir11_3            ;(4 cycles - page boundary crossed) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir11_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$05              ;(2 cycles) load value for delay loop
ir11_3            dey                           ;(23/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(2 cycles)
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 54-55 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $86
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$7a              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir11_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir11_5            ;(3 cycles) branch is always taken

ir11_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir11_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 56-57 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 61-62 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;animate the squares
                                                ;left square: outline = sprite 1 - filler = sprite 5
                                                ;center square: outline = sprite 0 - filler = sprite 4
                                                ;right square: outline = sprite 2 - filler = sprite 3

SQANI1            lda         mnanipt
                  cmp         #$11              ;check for animation part
                  beq         sqani1_01         ;if not $11, skip ahead

                  jmp         CLRSAW2           

sqani1_01         lda         indly             ;check initial delay
                  cmp         #$ff              ;if = $ff, intial delay has passed
                  beq         sqani1_03         
                  dec         indly             ;decrease initial delay
                  bmi         sqani1_02         ;while positive, skip ahead

                  jmp         ir11_e            

sqani1_02         lda         #$1e              ;replace small square character with scrolling grid character
                  sta         $4b0c             
                  lda         $d027             ;save current color of scroller sprites
sqani1_03         sta         tmpscrlcol
                  lda         sqsprty           ;set y coordinates for square sprites
                  sta         $d001             
                  sta         $d003             
                  sta         $d005             
                  sta         $d007             
                  sta         $d009             
                  sta         $d00b             
                  lda         sqsprtx1          ;set x coordinates for square sprites
                  sta         $d002             
                  sta         $d008             
                  lda         #$a4              
                  sta         $d000             
                  sta         $d006             
                  lda         sqsprtx2          
                  sta         $d004             
                  sta         $d00a             
                  lda         $d010             ;turn off x > $ff for sprites $00-$06, but keep current state for sprite $07 (electric arc sprite)
                  and         #$80              
                  sta         $d010             
                  lda         #$00              ;set colors for sprites $00-$02 (the colors for the filler sprites ($03-$05) are set by the RECTFLASH routine)
                  sta         $d027             
                  sta         $d028             
                  sta         $d029             

                  lda         sqsubpt           ;check which subpart of the animation is active and branch accordingly
                  beq         mvsq              ;move out small squares from center (sqsubpt = $00)
                  cmp         #$01              
                  bne         sqani1_04         
                  jmp         expsq             ;expand small squares to big squares(sqsubpt = $01)
sqani1_04         cmp         #$02
                  bne         sqani1_05         
                  jmp         rotsq             ;rotate squares (sqsubpt = $02)
sqani1_05         jmp         rssq              ;rotate squares and rise them out of the monitor ((sqsubpt = $03)

                                                ;update coordinates to move small square sprites (animation sub part $00)
mvsq              dec         dlymvmt           ;decrease delay for movement
                  lda         dlymvmt           ;check if delay for movement has passed
                  bpl         sqani1_06         ;if not, skip ahead because the coordinates need not be updated
                  lda         #$01              ;restore delay for movement
                  sta         dlymvmt           
                  dec         sqsprtx1          ;decrease x coordinate for sprites $$00 and $03
                  inc         sqsprtx2          ;decrease x coordinate for sprites $$00 and $03
                  lda         sqsprtx2          ;if the x coordinate is $d4, the final positions have been reached
                  cmp         #$d4              
                  bne         sqani1_06         
                  inc         sqsubpt           ;activate next subpart of animation
sqani1_06         lda         #$ac              ;set pointers for square sprites while moving
                  sta         $4bf8             
                  lda         #$ac              
                  sta         $4bf9             
                  lda         #$ac              
                  sta         $4bfa             
                  lda         #$b5              
                  sta         $4bfb             
                  lda         #$b5              
                  sta         $4bfc             
                  lda         #$b5              
                  sta         $4bfd             

                  jmp         ir11_e            

                                                ;expand small squares to big squares (animation sub part $01)
expsq             dec         dlyrt             ;decrease delay for expansion / rotation
                  lda         dlyrt             ;check if delay for expansion / rotation has passed
                  bpl         sqani1_07         ;if not, skip ahead because the index for the pointers need not be updated
                  lda         #$02              ;restore delay for expansion / rotation
                  sta         dlyrt             
                  inc         sqanindx          ;increase index/ sprite pointer
                  lda         sqanindx          ;check if index/ sprite pointer has reached the past sprite for the animation (i.e. the big square)
                  cmp         #$b0              
                  bne         sqani1_07         ;if no, skip ahead
                  inc         sqsubpt           ;if yes, activate next animation sub part
sqani1_07         lda         sqanindx          ;set index as pointer for square frame sprites
                  sta         $4bf8             
                  sta         $4bf9             
                  sta         $4bfa             
                  clc                           ;add 7 to the index to set pointers for square filler sprites
                  adc         #$09              
                  sta         $4bfb             
                  sta         $4bfc             
                  sta         $4bfd             

                  jmp         ir11_e            

                                                ;rotate squares (animation sub part $02)
rotsq             dec         dlyrt             ;decrease delay for expansion / rotation
                  lda         dlyrt             ;check if delay for expansion / rotation has passed
                  bpl         sqani1_08         ;if not, skip ahead because the next animation frame need not be set yet
                  lda         #$04              ;restore delay for expansion / rotation
                  sta         dlyrt             
                  inc         sqanindx          ;set index for next rotation animation frame
                  lda         sqanindx          
                  cmp         #$b5              ;check if index for animation frame is < $b5
                  bcc         sqani1_08         ;if yes, skip ahead
                  lda         #$b0              ;if not, reset index for animation frame
                  sta         sqanindx          
                  dec         sqrtdur           ;decrease duration counter
                  bpl         sqani1_08         ;if duration counter is >= $00, skip ahead
                  inc         sqsubpt           ;if not, activate next animation sub part
sqani1_08         lda         sqanindx          ;set index as pointer for square frame sprites
                  sta         $4bf8             
                  sta         $4bf9             
                  sta         $4bfa             
                  clc                           ;add $09 to the index to set pointers for square filler sprites
                  adc         #$09              
                  sta         $4bfb             
                  sta         $4bfc             
                  sta         $4bfd             

                  jmp         ir11_e            

                                                ;rotate squares and rise them out of the monitor (animation sub part $03)
rssq              dec         dlyrt             ;decrease delay for expansion / rotation
                  lda         dlyrt             ;check if delay for expansion / rotation has passed
                  bpl         sqani1_09         ;if not, skip ahead because the index for the pointers need not be updated
                  lda         #$04              ;restore delay for expansion / rotation
                  sta         dlyrt             
                  inc         sqanindx          ;set index for next rotation animation frame
                  lda         sqanindx          
                  cmp         #$b5              ;check if index for animation frame is < $b5
                  bcc         sqani1_09         ;if yes, skip ahead
                  lda         #$b0              ;if not, reset index for animation frame
                  sta         sqanindx          
sqani1_09         dec         dlymvmt           ;decrease delay for movement
                  lda         dlymvmt           ;check if delay for movement has passed
                  bpl         sqani1_10         ;if not, skip ahead
                  lda         #$01              ;restore delay for movement
                  sta         dlymvmt           

                  dec         sqsprty           
                  lda         sqsprty           
                  cmp         #$8e              ;check if square sprites y is low enough so they have disappeared outside the upper border of the monitor
                  bne         sqani1_10         ;if not, skip ahead
                  lda         #$12              ;activate next animation part
                  sta         mnanipt           

sqani1_10         jmp         ir11_e

;============================================================================================================================================================
                                                ;color the sawtooth/flatline rows of the monitor part 2

CLRSAW2           beq         clrsaw2_1         ;execute on $01-$05
                  cmp         #$06              
                  bcc         clrsaw2_2         

clrsaw2_1         jmp         PXLSCRLLR5

clrsaw2_2         ldx         swtclrndx         ;load index for color information
                  lda         swtclr3,x         ;load and store color information for monitor row 3
                  sta         $db03             
                  sta         $db07             
                  sta         $db0b             
                  sta         $db0f             
                  sta         $db13             
                  sta         $db04             
                  sta         $db08             
                  sta         $db0c             
                  sta         $db10             
                  sta         $db14             
                  sta         $db05             
                  sta         $db09             
                  sta         $db0d             
                  sta         $db11             
                  sta         $db15             
                  sta         $db06             
                  sta         $db0a             
                  sta         $db0e             
                  sta         $db12             

                  txa                           ;transfer index for color information into A
                  eor         #$01              ;switch value from $00 to $01 or vice versa (only two values needed)
                  sta         swtclrndx         ;store new index value

                  jmp         ir11_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 3 of monitor and start with row 4 of monitor (animation part $12)

PXLSCRLLR5        cmp         #$12              ;check for current animation part
                  beq         pxlscrllr5_1      ;if not $12, skip ahead

                  jmp         PXLWV5            

pxlscrllr5_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir11_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b03             

                  ldy         #$12              
                  inc         $fe               ;set address for reading data for monitor row 4 (+$100)

                  lda         ($fd),y           
                  sta         $4b3d             
                  dey
                  lda         ($fd),y           
                  sta         $4b3c             
                  dey
                  lda         ($fd),y           
                  sta         $4b3b             
                  dey
                  lda         ($fd),y           
                  sta         $4b3a             
                  dey
                  lda         ($fd),y           
                  sta         $4b39             
                  dey
                  lda         ($fd),y           
                  sta         $4b38             
                  dey
                  lda         ($fd),y           
                  sta         $4b37             
                  dey
                  lda         ($fd),y           
                  sta         $4b36             
                  dey
                  lda         ($fd),y           
                  sta         $4b35             
                  dey
                  lda         ($fd),y           
                  sta         $4b34             
                  dey
                  lda         ($fd),y           
                  sta         $4b33             
                  dey
                  lda         ($fd),y           
                  sta         $4b32             
                  dey
                  lda         ($fd),y           
                  sta         $4b31             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir11_e            

;============================================================================================================================================================
                                                ;display waves in the pixel field in monitor row 5

PXLWV5            cmp         #$13              ;check for current animation part
                  bne         pxlwv5_0          ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check if animation subpart is < $08
                  cpy         #$08              
                  bcc         pxlwv5_1          

pxlwv5_0          jmp         PXLSCRLRL5

pxlwv5_1          dec         pxlwvdly5         ;decrease delay
                  beq         pxlwv5_2          ;if delay is > $0, skip ahead
                  jmp         ir11_e            
pxlwv5_2          lda         #$06              ;restore delay
                  sta         pxlwvdly5         

                  ldx         pxlwvndx5         ;set index for fetching character data
                  lda         pxlwvd1,x         ;fetch character code
                  sta         $4b5c             ;store in all required screen memory locations

                  ldy         pxlwvsubpt        ;check animation sub part
                  cpy         #$05              ;if it is < $05, no more characters in screen memory need to be altered
                  bcc         pxlwv5_8          

                  sta         $4b56             
                  sta         $4b62             
                  dex                           ;decrease index to fetch code for next character
                  bpl         pxlwv5_3          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv5_3          lda         pxlwvd1,x
                  sta         $4b55             
                  sta         $4b5b             
                  sta         $4b61             
                  dex
                  bpl         pxlwv5_4          
                  ldx         #$05              
pxlwv5_4          lda         pxlwvd1,x
                  sta         $4b54             
                  sta         $4b5a             
                  sta         $4b60             
                  dex
                  bpl         pxlwv5_5          
                  ldx         #$05              
pxlwv5_5          lda         pxlwvd1,x
                  sta         $4b53             
                  sta         $4b59             
                  sta         $4b5f             
                  sta         $4b65             
                  dex
                  bpl         pxlwv5_6          
                  ldx         #$05              
pxlwv5_6          lda         pxlwvd1,x
                  sta         $4b58             
                  sta         $4b5e             
                  sta         $4b64             
                  dex
                  bpl         pxlwv5_7          
                  ldx         #$05              
pxlwv5_7          lda         pxlwvd1,x
                  sta         $4b57             
                  sta         $4b5d             
                  sta         $4b63             

pxlwv5_8          ldx         pxlwvndx5         ;fetch current index
                  dex                           ;decrease by one for next animation frame
                  bpl         pxlwv5_9          ;if the index drops below $00, restore to $05 (wraparound)
                  ldx         #$05              
pxlwv5_9          stx         pxlwvndx5

                  jmp         ir11_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 3 of monitor and start with row 4 of monitor (animation part $12)

PXLSCRLRL5        cmp         #$15              ;check for current animation part
                  beq         pxlscrlrl5_1      ;if not $12, skip ahead

                  jmp         ir11_e            

pxlscrlrl5_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir11_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b15             

                  ldy         #$00              
                  inc         $fe               ;set address for reading data for monitor row 4 (+$100)


                  lda         ($fd),y           
                  sta         $4b2b             
                  iny
                  lda         ($fd),y           
                  sta         $4b2c             
                  iny
                  lda         ($fd),y           
                  sta         $4b2d             
                  iny
                  lda         ($fd),y           
                  sta         $4b2e             
                  iny
                  lda         ($fd),y           
                  sta         $4b2f             
                  iny
                  lda         ($fd),y           
                  sta         $4b30             
                  iny
                  lda         ($fd),y           
                  sta         $4b31             
                  iny
                  lda         ($fd),y           
                  sta         $4b32             
                  iny
                  lda         ($fd),y           
                  sta         $4b33             
                  iny
                  lda         ($fd),y           
                  sta         $4b34             
                  iny
                  lda         ($fd),y           
                  sta         $4b35             
                  iny
                  lda         ($fd),y           
                  sta         $4b36             
                  iny
                  lda         ($fd),y           
                  sta         $4b37             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir11_e            lda         #$8c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir12            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir12            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir12              lda         #<ir12_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir12_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir12 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir12_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir12_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $8D
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

ir12_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00f             ;(4 cycles) check y location of sprite 7 (electric arc) to see if it is displayed on the current raster line
                  cpx         #$7a              ;(2 cycles)
                  bne         ir12_2            ;(3 cycles) sprite 7 not displayed, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  ldy         #$05              ;(2 cycles)
                  bne         ir12_3            ;(3 cycles) branch is always taken
                                                ;=> 29-30 cycles have passed

                                                ;=> 25-26 cycles have passed
ir12_2            nop                           ;(2 cycles) wait n cycles
                  ldy         #$06              ;(2 cycles) load value for delay loop
ir12_3            dey                           ;(24/29 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black


                                                ;RASTER LINE $8E
                                                ;=> 1-2 cycles have passed

                  nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  cpx         #$7a              ;(2 cycles) check if sprite 7 is displayed on the NEXT line
                  bne         ir12_4            ;(3 cycles) sprite 7 NOT displayed, skip ahead
                                                ;(2 cycles) sprite 7 is displayed, 5 extra cycles will be consumed by fetching the data at the end of THIS line
                  ldy         #$07              ;(2 cycles) load value for delay loop
                  bne         ir12_5            ;(3 cycles) branch is always taken

ir12_4            nop                           ;(2 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir12_5            dey                           ;(39/44 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles)
                  
                  lda         bgcol             ;(4 cycles) load color code for background

                                                ;=> 55-56 cycles have passed if sprite 7 is displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if Sprite 7 is NOT displayed on the NEXT line
                  sta         $d020             ;reset border color

;============================================================================================================================================================
                                                ;set all square sprites to empty sprite data so they are cut off at the top when reaching the top border
                                                ;of the monitor - the proper square sprites are switched on @ ir16a

SQANI2            lda         sqsubpt           ;check if subpart $03 of the square animation (animation part $11) is active
                  cmp         #$03              
                  bne         PXLWV24IN         ;subpart $03 not active, skip ahead
                  lda         indly             ;check initial delay
                  cmp         #$ff              ;if = $ff, intial delay has passed
                  bne         sqani2_01                  
                  lda         #$77              ;set pointers of sprites 0-5 to empty sprite
                  sta         $4bf8             
                  sta         $4bf9             
                  sta         $4bfa             
                  sta         $4bfb             
                  sta         $4bfc             
                  sta         $4bfd             

                  lda         mnanipt           ;when animation part $12 has been activated, the sprites still need to be set to empty one last time on the current frame,
                  cmp         #$12              ;but then the animation sub part needs to be reset
                  bne         sqani2_01         
                  lda         #$00              ;reset sub animation part to $00 - also needed because the masking of the square sprites @ ir17 checks if this
                  sta         sqsubpt           ;subpart is active

sqani2_01         jmp         ir12_e

;============================================================================================================================================================
                                                ;unveil the pixelwave drawn @ PXLWV2 & 4 by overwriting less and less characters to the left and right of the center of the wave

PXLWV24IN         lda         mnanipt           ;check for current animation part
                  cmp         #$13              
                  bne         pxlwv24in_1       ;if not $13, skip ahead
                  ldx         pxlwvsubpt        ;check for current animation sub part - done with X because the A value needs to be preserved for other animation parts on ir12
                  cpx         #$04              ;if not $04, skip ahead
                  beq         pxlwv24in_2       

pxlwv24in_1       jmp         PXLWV15IN


pxlwv24in_2       lda         #$fe
mcode5            bne         pxlwv24in_3       ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwviondx (index for how many characters should be unveiled left and right) * 12 (= 4 x STA) bytes
pxlwv24in_3       sta         $4adb             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b2b             
                  sta         $4aed             
                  sta         $4b3d             
                  sta         $4adc             
                  sta         $4b2c             
                  sta         $4aec             
                  sta         $4b3c             
                  sta         $4add             
                  sta         $4b2d             
                  sta         $4aeb             
                  sta         $4b3b             
                  sta         $4ade             
                  sta         $4b2e             
                  sta         $4aea             
                  sta         $4b3a             
                  sta         $4adf             
                  sta         $4b2f             
                  sta         $4ae9             
                  sta         $4b39             
                  sta         $4ae0             
                  sta         $4b30             
                  sta         $4ae8             
                  sta         $4b38             
                  sta         $4ae1             
                  sta         $4b31             
                  sta         $4ae7             
                  sta         $4b37             
                  sta         $4ae2             
                  sta         $4b32             
                  sta         $4ae6             
                  sta         $4b36             
                  sta         $4ae3             
                  sta         $4b33             
                  sta         $4ae5             
                  sta         $4b35             

                  lda         $4ae4             ;check the character code displayed in the center - serves as a timer when to unveil the next pixels of the wave
                  cmp         #$fe              ;increase unveil after 6 animation frames
                  bne         pxlwv24in_5       
                  lda         pxlwvdly2         ;since the character in the center is displayed for $06 animation frames, the unveil should only be increased
                  cmp         #$06              ;if the delay counter = $06
                  bne         pxlwv24in_5       
                  inc         pxlwviondx        ;increase the index for how many characters to unveil
                  lda         pxlwviondx        ;if the index reaches $0a, the whole pixel wave is displayed
                  cmp         #$0a              
                  bcc         pxlwv24in_4       ;if it has not yet reached $0a, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$00              
                  sta         pxlwviondx        ;restore the index for unveiling
                  sta         mcode5+1          ;restore the modified code

                  jmp         ir12_e            

pxlwv24in_4       asl                           ;multiplying the index for how many characters to unveil by 4
                  asl
                  sta         apstore           ;store the value
                  asl                           ;multiplying the index for how many characters to unveil by 2 (= x 8)
                  clc
                  adc         apstore           ;add the stored value so the end result is the index value x 12 (i.e. the bytes 4 STA commands need)
                  sta         mcode5+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwv24in_5       jmp         ir12_e

;============================================================================================================================================================
                                                ;unveil the pixelwave drawn @ PXLWV1 & 5 by overwriting less and less characters to the left and right of the center of the wave

PXLWV15IN         cmp         #$13              ;check for current animation part
                  bne         pxlwv15in_1       ;if not $13, skip ahead
                  ldx         pxlwvsubpt        ;check for current animation sub part - done with X because the A value needs to be preserved for other animation parts on ir12
                  cpx         #$05              ;if not $05, skip ahead
                  beq         pxlwv15in_2       

pxlwv15in_1       jmp         PYRROT

pxlwv15in_2       lda         #$fe
mcode6            bne         pxlwv15in_3       ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwviondx (index for how many characters should be unveiled left and right) * 12 (= 4 x STA) bytes
pxlwv15in_3       sta         $4abb             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b5b             
                  sta         $4abd             
                  sta         $4b5d             
                  sta         $4aba             
                  sta         $4b5a             
                  sta         $4abe             
                  sta         $4b5e             
                  sta         $4ab9             
                  sta         $4b59             
                  sta         $4abf             
                  sta         $4b5f             
                  sta         $4ab8             
                  sta         $4b58             
                  sta         $4ac0             
                  sta         $4b60             
                  sta         $4ab7             
                  sta         $4b57             
                  sta         $4ac1             
                  sta         $4b61             
                  sta         $4ab6             
                  sta         $4b56             
                  sta         $4ac2             
                  sta         $4b62             
                  sta         $4ab5             
                  sta         $4b55             
                  sta         $4ac3             
                  sta         $4b63             
                  sta         $4ab4             
                  sta         $4b54             
                  sta         $4ac4             
                  sta         $4b64             
                  sta         $4ab3             
                  sta         $4b53             
                  sta         $4ac5             
                  sta         $4b65             

                  lda         $4abc             ;check the character code displayed in the center - serves as a timer when to unveil the next pixels of the wave
                  cmp         #$fe              ;increase unveil after 6 animation frames
                  bne         pxlwv15in_5       
                  lda         pxlwvdly1         ;since the character in the center is displayed for $06 animation frames, the unveil should only be increased
                  cmp         #$06              ;if the delay counter = $06
                  bne         pxlwv15in_5       
                  inc         pxlwviondx        ;increase the index for how many characters to unveil
                  lda         pxlwviondx        ;if the index reaches $0a, the whole pixel wave is displayed
                  cmp         #$0a              
                  bcc         pxlwv15in_4       ;if it has not yet reached $0a, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$12              
                  sta         pxlwviondx        ;set the index for hiding the pixels (see PXLWVOUT, animation sub parts $07-$0b)
                  lda         #$00              
                  sta         mcode6+1          ;restore the modified code

                  jmp         ir12_e            

pxlwv15in_4       asl                           ;multiplying the index for how many characters to unveil by 4
                  asl
                  sta         apstore           ;store the value
                  asl                           ;multiplying the index for how many characters to unveil by 2 (= x 8)
                  clc
                  adc         apstore           ;add the stored value so the end result is the index value x 12 (i.e. the bytes 4 STA commands need)
                  sta         mcode6+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwv15in_5       jmp         ir12_e

;============================================================================================================================================================
                                                ;rotate pyramid in the rectangle

PYRROT            cmp         #$0b              ;check for current animation part
                  beq         pyrrot_s1         ;if not $0b or $0d, skip ahead
                  cmp         #$0d              
                  beq         pyrrot_s1         

                  jmp         PXLWV3IN          

pyrrot_s1         dec         mnanidly9         ;decrease delay
                  beq         pyrrot_s2         ;if not $00, skip ahead

                  jmp         ir12_e            

pyrrot_s2         lda         #$06              ;restore delay
                  sta         mnanidly9         
                  ldx         pyrndx            ;load animation frame index, which also serves as a pointer to the character data (left bottom character of pyramid)
                  lda         pyrdt,x           ;load character code, store in screen memory, decrease index/pointer (repeat until all pyramid characters have been drawn)
                  sta         $4b37             
                  dex
                  lda         pyrdt,x           
                  sta         $4b36             
                  dex
                  lda         pyrdt,x           
                  sta         $4b35             
                  dex
                  lda         pyrdt,x           
                  sta         $4b34             
                  dex
                  lda         pyrdt,x           
                  sta         $4b33             
                  dex
                  lda         pyrdt,x           
                  sta         $4b32             
                  dex
                  lda         pyrdt,x           
                  sta         $4b31             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0e             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0d             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0c             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0b             
                  dex
                  lda         pyrdt,x           
                  sta         $4b0a             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae5             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae4             
                  dex
                  lda         pyrdt,x           
                  sta         $4ae3             
                  lda         pyrndx            ;check if the animation frame index has reached $0e (i.e. last fram has been drawn)
                  cmp         #$0e              
                  beq         pyrrot_s3         
                  sec                           ;if not, decrease animation frame index/pointer by $0f to get the next animation frame/
                  sbc         #$0f              ;starting point for the characters for the next frame
                  sta         pyrndx            

                  jmp         ir12_e            

pyrrot_s3         dec         pyrdur            ;decrease animation duration by one since a full animation cycle has been executed
                  bpl         pyrrot_s6         ;if the duration is >=$00 skip ahead
                  lda         mnanipt           ;if the duration is < $00, activate next animation frame
                  cmp         #$0b              ;since this part is used twice, check the currently active animation part
                  bne         pyrrot_s4         ;and set the next one accordingly
                  lda         #$0c              
                  jmp         pyrrot_s5         
pyrrot_s4         lda         #$0e
pyrrot_s5         sta         mnanipt
                  lda         #$b3              ;reset variables for animation part
                  sta         pyrndx            
                  lda         #$06              
                  sta         mnanidly9         
                  lda         #07               
                  sta         pyrdur            

                  jmp         ir12_e            

pyrrot_s6         lda         #$b3              ;reset animation frame index/pointer
                  sta         pyrndx            

                  jmp         ir12_e            

;============================================================================================================================================================
                                                ;unveil the pixelwave drawn @ PXLWV3 by overwriting less and less characters to the left and right of the center of the wave

PXLWV3IN          cmp         #$13              ;check for current animation part
                  bne         pxlwv3in_1        ;if not $13, skip ahead
                  ldx         pxlwvsubpt        ;check for current animation sub part - done with X because the A value needs to be preserved for other animation parts on ir12
                  cpx         #$03              ;if not $03, skip ahead
                  beq         pxlwv3in_2        

pxlwv3in_1        jmp         PXLSCRLLR6

pxlwv3in_2        lda         #$fe
mcode4            bne         pxlwv3in_3        ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwviondx (index for how many characters should be unveiled left and right) * 6 (= 2 x STA) bytes
pxlwv3in_3        sta         $4b0b             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b0d             
                  sta         $4b0a             
                  sta         $4b0e             
                  sta         $4b09             
                  sta         $4b0f             
                  sta         $4b08             
                  sta         $4b10             
                  sta         $4b07             
                  sta         $4b11             
                  sta         $4b06             
                  sta         $4b12             
                  sta         $4b05             
                  sta         $4b13             
                  sta         $4b04             
                  sta         $4b14             
                  sta         $4b03             
                  sta         $4b15             

                  lda         $4b0c             ;check the character code displayed in the center - serves as a timer when to unveil the next pixels of the wave
                  cmp         #$fe              ;increase unveil after 6 animation frames
                  bne         pxlwv3in_5        
                  lda         pxlwvdly3         ;since the character in the center is displayed for $06 animation frames, the unveil should only be increased
                  cmp         #$06              ;if the delay counter = $06
                  bne         pxlwv3in_5        
                  inc         pxlwviondx        ;increase the index for how many characters to unveil
                  lda         pxlwviondx        ;if the index reaches $0a, the whole pixel wave is displayed
                  cmp         #$0a              
                  bcc         pxlwv3in_4        ;if it has not yet reached $0a, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$00              
                  sta         pxlwviondx        ;restore the index for unveiling
                  sta         mcode4+1          ;restore the modified code

                  jmp         ir12_e            

pxlwv3in_4        asl                           ;multiplying the index for how many characters to unveil by 2
                  sta         apstore           ;store the value
                  asl                           ;multiplying the index for how many characters to unveil by 2 again (= x 4)
                  clc
                  adc         apstore           ;add the stored value so the end result is the index value x 6 (i.e. the bytes 2 STA commands need)
                  sta         mcode4+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwv3in_5        jmp         ir12_e

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 4 of monitor and start with row 5 of monitor (animation part $12)

PXLSCRLLR6        cmp         #$12              ;check for current animation part
                  beq         pxlscrllr6_1      ;if not $12, skip ahead

                  jmp         PXLWVOUT          

pxlscrllr6_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00
                  jmp         ir12_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b30             
                  dey
                  lda         ($fd),y           
                  sta         $4b2f             
                  dey
                  lda         ($fd),y           
                  sta         $4b2e             
                  dey
                  lda         ($fd),y           
                  sta         $4b2d             
                  dey
                  lda         ($fd),y           
                  sta         $4b2c             
                  dey
                  lda         ($fd),y           
                  sta         $4b2b             

                  ldy         #$12              
                  inc         $fe               ;set address for reading data for monitor row 5 (+$100)

                  lda         ($fd),y           
                  sta         $4b65             
                  dey
                  lda         ($fd),y           
                  sta         $4b64             
                  dey
                  lda         ($fd),y           
                  sta         $4b63             
                  dey
                  lda         ($fd),y           
                  sta         $4b62             
                  dey
                  lda         ($fd),y           
                  sta         $4b61             
                  dey
                  lda         ($fd),y           
                  sta         $4b60             
                  dey
                  lda         ($fd),y           
                  sta         $4b5f             
                  dey
                  lda         ($fd),y           
                  sta         $4b5e             
                  dey
                  sty         pxlscrllrndx      

                  jmp         ir12_e            

;============================================================================================================================================================
                                                ;display all 5 pixelwaves for set duration
                                                ;then hide pixelwaves row by row (5 > 1)

PXLWVOUT          cmp         #$13              ;check for current animation part
                  bne         pxlwvout_1        ;if not $13, skip ahead
                  ldx         pxlwvsubpt        ;check for current animation sub part
                  cpx         #$06              ;if not $06, skip ahead
                  bne         pxlwvout_2        
                  dec         pxlwvdur          ;decrease duration counter lo byte
                  bne         pxlwvout_1        
                  dec         durexp2           ;decrease duration counter hi byte
                  bpl         pxlwvout_1         
                  inc         pxlwvsubpt        ;activate next animation sub part

pxlwvout_1        jmp         PXLSCRLRL6

                                                ;hide the pixel wave in monitor row 5
pxlwvout_2        cpx         #$07              ;check for current animation sub part
                  bne         pxlwvout_3        ;if not $07, skip ahead
                  lda         #$fe              
mcode7            bne         pxlwvout_2_1      ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwvinndx (index for how many characters should be unveiled left and right) * 3 (= 1 x STA) bytes
                  sta         $4b65             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b64             
                  sta         $4b63             
                  sta         $4b62             
                  sta         $4b61             
                  sta         $4b60             
                  sta         $4b5f             
                  sta         $4b5e             
                  sta         $4b5d             
                  sta         $4b5c             
                  sta         $4b5b             
                  sta         $4b5a             
                  sta         $4b59             
                  sta         $4b58             
                  sta         $4b57             
                  sta         $4b56             
                  sta         $4b55             
                  sta         $4b54             
pxlwvout_2_1      sta         $4b53

                  lda         pxlwvdly5         ;check the delay for creating the wave in row 5 - serves as a timer when to hide the next pixel of the wave
                  cmp         #$06              
                  bne         pxlwvout_2_3      
                  dec         pxlwviondx        ;decrease the index for how many characters to unveil
                  bpl         pxlwvout_2_2      ;if it is <= $00, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$12              
                  sta         pxlwviondx        ;set the index to $12 (needed in animation sub part $08)
                  lda         #$38              
                  sta         mcode7+1          ;restore the modified code

pxlwvout_2_2      lda         pxlwviondx
                  asl                           ;multiply the index for how many characters to unveil by 2
                  clc
                  adc         pxlwviondx        ;add the index once so the end result is the index value x 3 (i.e. the bytes 1 STA command needs)
                  sta         mcode7+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwvout_2_3      jmp         ir12_e

                                                ;hide the pixel wave in monitor row 4
pxlwvout_3        cpx         #$08              ;check for current animation sub part
                  bne         pxlwvout_4        ;if not $08, skip ahead
                  lda         #$fe              
mcode8            bne         pxlwvout_3_1      ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwvinndx (index for how many characters should be unveiled left and right) * 3 (= 1 x STA) bytes
                  sta         $4b2b             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b2c             
                  sta         $4b2d             
                  sta         $4b2e             
                  sta         $4b2f             
                  sta         $4b30             
                  sta         $4b31             
                  sta         $4b32             
                  sta         $4b33             
                  sta         $4b34             
                  sta         $4b35             
                  sta         $4b36             
                  sta         $4b37             
                  sta         $4b38             
                  sta         $4b39             
                  sta         $4b3a             
                  sta         $4b3b             
                  sta         $4b3c             
pxlwvout_3_1      sta         $4b3d

                  lda         pxlwvdly4         ;check the delay for creating the wave in row 4 - serves as a timer when to hide the next pixel of the wave
                  cmp         #$06              
                  bne         pxlwvout_3_3      
                  dec         pxlwviondx        ;decrease the index for how many characters to unveil
                  bpl         pxlwvout_3_2      ;if it is <= $00, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$12              
                  sta         pxlwviondx        ;set the index to $12 (needed in animation sub part $09)
                  lda         #$38              
                  sta         mcode8+1          ;restore the modified code

pxlwvout_3_2      lda         pxlwviondx
                  asl                           ;multiply the index for how many characters to unveil by 2
                  clc
                  adc         pxlwviondx        ;add the index once so the end result is the index value x 3 (i.e. the bytes 1 STA command needs)
                  sta         mcode8+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwvout_3_3      jmp         ir12_e

                                                ;hide the pixel wave in monitor row 3
pxlwvout_4        cpx         #$09              ;check for current animation sub part
                  bne         pxlwvout_5        ;if not $09, skip ahead
                  lda         #$fe              
mcode9            bne         pxlwvout_4_1      ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwvinndx (index for how many characters should be unveiled left and right) * 3 (= 1 x STA) bytes
                  sta         $4b15             ;overwrite the characters of the wave not unveiled yet
                  sta         $4b14             
                  sta         $4b13             
                  sta         $4b12             
                  sta         $4b11             
                  sta         $4b10             
                  sta         $4b0f             
                  sta         $4b0e             
                  sta         $4b0d             
                  sta         $4b0c             
                  sta         $4b0b             
                  sta         $4b0a             
                  sta         $4b09             
                  sta         $4b08             
                  sta         $4b07             
                  sta         $4b06             
                  sta         $4b05             
                  sta         $4b04             
pxlwvout_4_1      sta         $4b03

                  lda         pxlwvdly3         ;check the delay for creating the wave in row 3 - serves as a timer when to hide the next pixel of the wave
                  cmp         #$06              
                  bne         pxlwvout_4_3      
                  dec         pxlwviondx        ;decrease the index for how many characters to unveil
                  bpl         pxlwvout_4_2      ;if it is <= $00, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$12              
                  sta         pxlwviondx        ;set the index to $12 (needed in animation sub part $0a)
                  lda         #$38              
                  sta         mcode9+1          ;restore the modified code

pxlwvout_4_2      lda         pxlwviondx
                  asl                           ;multiply the index for how many characters to unveil by 2
                  clc
                  adc         pxlwviondx        ;add the index once so the end result is the index value x 3 (i.e. the bytes 1 STA command needs)
                  sta         mcode9+1          ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwvout_4_3      jmp         ir12_e

                                                ;hide the pixel wave in monitor row 2
pxlwvout_5        cpx         #$0a              ;check for current animation sub part
                  bne         pxlwvout_6        ;if not $0a, skip ahead
                  lda         #$fe              
mcode10           bne         pxlwvout_5_1      ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwvinndx (index for how many characters should be unveiled left and right) * 3 (= 1 x STA) bytes
                  sta         $4adb             ;overwrite the characters of the wave not unveiled yet
                  sta         $4adc             
                  sta         $4add             
                  sta         $4ade             
                  sta         $4adf             
                  sta         $4ae0             
                  sta         $4ae1             
                  sta         $4ae2             
                  sta         $4ae3             
                  sta         $4ae4             
                  sta         $4ae5             
                  sta         $4ae6             
                  sta         $4ae7             
                  sta         $4ae8             
                  sta         $4ae9             
                  sta         $4aea             
                  sta         $4aeb             
                  sta         $4aec             
pxlwvout_5_1      sta         $4aed

                  lda         pxlwvdly2         ;check the delay for creating the wave in row 2 - serves as a timer when to hide the next pixel of the wave
                  cmp         #$06              
                  bne         pxlwvout_5_3      
                  dec         pxlwviondx        ;decrease the index for how many characters to unveil
                  bpl         pxlwvout_5_2      ;if it is <= $00, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$12              
                  sta         pxlwviondx        ;set the index to $12 (needed in animation sub part $0b)
                  lda         #$38              
                  sta         mcode10+1         ;restore the modified code

pxlwvout_5_2      lda         pxlwviondx
                  asl                           ;multiply the index for how many characters to unveil by 2
                  clc
                  adc         pxlwviondx        ;add the index once so the end result is the index value x 3 (i.e. the bytes 1 STA command needs)
                  sta         mcode10+1         ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwvout_5_3      jmp         ir12_e

                                                ;hide the pixel wave in monitor row 1
pxlwvout_6        cpx         #$0b              ;check for current animation sub part
                  bne         pxlwvout_6_3      ;if not $0b, skip ahead
                  lda         #$fe              
mcode11           bne         pxlwvout_6_1      ;[!!!SELF MODIFYING CODE!!!]
                                                ;skip ahead pxlwvinndx (index for how many characters should be unveiled left and right) * 3 (= 1 x STA) bytes
                  sta         $4ac5             ;overwrite the characters of the wave not unveiled yet
                  sta         $4ac4             
                  sta         $4ac3             
                  sta         $4ac2             
                  sta         $4ac1             
                  sta         $4ac0             
                  sta         $4abf             
                  sta         $4abe             
                  sta         $4abd             
                  sta         $4abc             
                  sta         $4abb             
                  sta         $4aba             
                  sta         $4ab9             
                  sta         $4ab8             
                  sta         $4ab7             
                  sta         $4ab6             
                  sta         $4ab5             
                  sta         $4ab4             
pxlwvout_6_1      sta         $4ab3

                  lda         pxlwvdly1         ;check the delay for creating the wave in row 1 - serves as a timer when to hide the next pixel of the wave
                  cmp         #$06              
                  bne         pxlwvout_6_3      
                  dec         pxlwviondx        ;decrease the index for how many characters to unveil
                  bpl         pxlwvout_6_2      ;if it is <= $00, skip to the code modification part
                  inc         pxlwvsubpt        ;activate next animation sub part
                  lda         #$00              
                  sta         pxlwviondx        ;reset the index to initial value
                  lda         #$38              
                  sta         mcode11+1         ;restore the modified code

                  jmp         ir12_e            

pxlwvout_6_2      lda         pxlwviondx
                  asl                           ;multiply the index for how many characters to unveil by 2
                  clc
                  adc         pxlwviondx        ;add the index once so the end result is the index value x 3 (i.e. the bytes 1 STA command needs)
                  sta         mcode11+1         ;modify the code so it skips across the veiling of the characters that are already unveiled

pxlwvout_6_3      jmp         ir12_e

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 4 of monitor and start with row 5 of monitor (animation part $15)

PXLSCRLRL6        cmp         #$15              ;check for current animation part
                  beq         pxlscrlrl6_1      ;if not $15, skip ahead

                  jmp         ir12_e            

pxlscrlrl6_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir12_e            

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b38             
                  iny
                  lda         ($fd),y           
                  sta         $4b39             
                  iny
                  lda         ($fd),y           
                  sta         $4b3a             
                  iny
                  lda         ($fd),y           
                  sta         $4b3b             
                  iny
                  lda         ($fd),y           
                  sta         $4b3c             
                  iny
                  lda         ($fd),y           
                  sta         $4b3d             

                  ldy         #$00              
                  inc         $fe               ;set address for reading data for monitor row 5 (+$100)

                  lda         ($fd),y           
                  sta         $4b53             
                  iny
                  lda         ($fd),y           
                  sta         $4b54             
                  iny
                  lda         ($fd),y           
                  sta         $4b55             
                  iny
                  lda         ($fd),y           
                  sta         $4b56             
                  iny
                  lda         ($fd),y           
                  sta         $4b57             
                  iny
                  lda         ($fd),y           
                  sta         $4b58             
                  iny
                  lda         ($fd),y           
                  sta         $4b59             
                  iny
                  lda         ($fd),y           
                  sta         $4b5a             
                  iny
                  sty         pxlscrllrndx      

;============================================================================================================================================================

ir12_e            lda         #$94              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir13            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir13            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir13              lda         #<ir13_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir13_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir13 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir13_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $95
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir13_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir13_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$6b              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir13_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$95              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir13_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$6b              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir13_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir13_2            jmp         ir13_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir13_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir13_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$81              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir13_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$96              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir13_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir13_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir13_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir13_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir13_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir13_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles)

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $96 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$6c              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir13_9            ;(3 cycles) y <, sprites 3-5 NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$97              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir13_10           ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$96              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir13_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$6c              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir13_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir13_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir13_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 27-28 cycles have passed
ir13_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir13_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 8-9 cycles have passed
ir13_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 12-13 cycles have passed
ir13_10           cpy         #$82              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir13_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$97              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir13_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir13_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir13_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir13_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir13_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================
                                                ;flash the color inside the rectangle and the animated squares on every frame

RECTFLASH         lda         mnanipt
                  cmp         #$07              ;check if animation part is >= $07
                  bcc         rectflash_s1      
                  cmp         #$12              ;check if animation part is < $12
                  bcc         rectflash_s2      

rectflash_s1      jmp         PXLSCRLLR7        ;if not skip ahead

rectflash_s2      tax                           ;save A in X for later checks on animation part
                  ldy         rectclrndx        ;load index for rectangle color
                  lda         rectclr,y         ;load color code
                  sta         $d022             ;store in character multicolor #01 (needed for animation parts $07-10)
                  sta         $d02a             ;store in color for sprites $03-$05 (needed for animation part $11)
                  sta         $d02b             
                  sta         $d02c             
                  dey                           ;decrease color index
                  bpl         rectflash_s3      ;if < $00, reset
                  ldy         #$03              
rectflash_s3      sty         rectclrndx        ;store new color index
                  txa                           ;restore animation part index

                  jmp         ir13_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 5 of monitor (animation part $12)

PXLSCRLLR7        cmp         #$12              ;check for current animation part
                  beq         pxlscrllr7_1      ;if not $12, skip ahead

                  jmp         PXLWVMV           

pxlscrllr7_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir13_e            

                  lda         #$06              ;reset delay
                  sta         pxscrldly1        

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b5d             
                  dey
                  lda         ($fd),y           
                  sta         $4b5c             
                  dey
                  lda         ($fd),y           
                  sta         $4b5b             
                  dey
                  lda         ($fd),y           
                  sta         $4b5a             
                  dey
                  lda         ($fd),y           
                  sta         $4b59             
                  dey
                  lda         ($fd),y           
                  sta         $4b58             
                  dey
                  lda         ($fd),y           
                  sta         $4b57             
                  dey
                  lda         ($fd),y           
                  sta         $4b56             
                  dey
                  lda         ($fd),y           
                  sta         $4b55             
                  dey
                  lda         ($fd),y           
                  sta         $4b54             
                  dey
                  lda         ($fd),y           
                  sta         $4b53             

                  lda         #$a5              ;reset start address for row 1 data
                  sta         $fe               
                  dec         $fd               ;also subtract 1 more to get the start address for the next animation
                  lda         $fd               
                  cmp         #$ff              ;if the lo byte of the start address is $ff, the animation has completed
                  beq         pxlscrllr7_2      
                  jmp         ir13_e            

pxlscrllr7_2      lda         #$13              ;activate next animation part
                  sta         mnanipt
                  lda         #$60              ;set this delay so there is a delay before the $15 pixel scroller actually starts                
                  sta         pxscrldly1

                  jmp         ir13_e            

;============================================================================================================================================================
                                                ;move single pixel in wave across row 3 of monitor

PXLWVMV           cmp         #$13              ;check for current animation part
                  bne         pxlwvmv_0         ;if not $13, skip ahead
                  ldy         pxlwvsubpt        ;check animation sub part
                  cpy         #$0c              
                  beq         pxlwvmv_1         ;if not $0c, move ahead

pxlwvmv_0         jmp         PXLSCRLRL7

pxlwvmv_1         dec         pxlwvmvdly        ;decrease delay
                  beq         pxlwvmv_2         ;if > $00, skip ahead

                  jmp         ir13_e            

pxlwvmv_2         lda         #$06              ;restore delay
                  sta         pxlwvmvdly        
                  ldx         pxlwvmvndx1       ;load index for position
                  bmi         pxlwvmv_3         ;skip erasing the pixel wave character from the last animation frame if index is negative (=start value $ff)
                  lda         #$fe              ;overwrite wave character from last animation frame
                  sta         $4b03,x           
pxlwvmv_3         inx                           ;increase position index
                  stx         pxlwvmvndx1       ;store new position index
                  cpx         #$12              ;check if position index is < $12
                  bcs         pxlwvmv_6         ;if not, all pixel wave characters have been drawn, but the last pixel wave character drawn still needs to be overwritten
                  ldy         pxlwvmvndx2       ;load index for pixel wave character code
                  lda         pxlwvd1,y         ;load character code
                  sta         $4b03,x           ;store in screen memory
                  dey                           ;decrease index for character code
                  bpl         pxlwvmv_4         
                  ldy         #$05              ;reset the index if new new value is negative (wraparound)
pxlwvmv_4         sty         pxlwvmvndx2       ;store new character code index

pxlwvmv_5         jmp         ir13_e

pxlwvmv_6         cpx         #$13              ;when the position index is $13, the animation ends
                  bcc         pxlwvmv_5         
                  lda         #$14              ;activate next animation part
                  sta         mnanipt           
                  lda         #$02              ;set extended delay for animation restart              
                  sta         durexp2         

                  jmp         ir13_e            

;============================================================================================================================================================
                                                ;complete display of pixel wave in row 5 of monitor (animation part $15)

PXLSCRLRL7        cmp         #$15              ;check for current animation part
                  beq         pxlscrlrl7_1      ;if not $15, skip ahead

                  jmp         ir13_e            

pxlscrlrl7_1      lda         pxscrldly1        ;check delay for animation
                  beq         *+5               ;skip ahead if not $00

                  jmp         ir13_e            

                  lda         #$06              ;reset delay
                  sta         pxscrldly1        

                  ldy         pxlscrllrndx      
                  lda         ($fd),y           
                  sta         $4b5b             
                  iny
                  lda         ($fd),y           
                  sta         $4b5c             
                  iny
                  lda         ($fd),y           
                  sta         $4b5d             
                  iny
                  lda         ($fd),y           
                  sta         $4b5e             
                  iny
                  lda         ($fd),y           
                  sta         $4b5f             
                  iny
                  lda         ($fd),y           
                  sta         $4b60             
                  iny
                  lda         ($fd),y           
                  sta         $4b61             
                  iny
                  lda         ($fd),y           
                  sta         $4b62             
                  iny
                  lda         ($fd),y           
                  sta         $4b63             
                  iny
                  lda         ($fd),y           
                  sta         $4b64             
                  iny
                  lda         ($fd),y           
                  sta         $4b65             

                  lda         #$a5              ;reset start address for row 1 data
                  sta         $fe               
                  inc         $fd               ;also add 1 to get the start address for the next animation
                  lda         $fd               
                  cmp         #$e7              ;if the lo byte of the start address is $67, the animation has completed
                  bcs         pxlscrlrl7_2      

                  jmp         ir13_e            

pxlscrlrl7_2      lda         #$16              ;activate next animation part
                  sta         mnanipt           
                  lda         #$61              ;set $fd/$fe so it can be used by $12 animation part again
                  sta         $fd               
                  lda         #$a5              
                  sta         $fe               
                  lda         #$0b              ;set multicolor 01 for part $16
                  sta         $d022             

;============================================================================================================================================================

ir13_e            lda         #$9c              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir14            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir14            
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;continuous raster routines not tied to a specific animation part only from here on
;############################################################################################################################################################

_CODE_8000

*=$8000
                                                ;second char set activated here

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir14              lda         #<ir14_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir14_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir14 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir14_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $9C
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir14_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir14_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$73              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir14_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$9d              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir14_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$73              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir14_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir14_2            jmp         ir14_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir14_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir14_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$89              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir14_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$9e              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir14_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir14_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir14_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir14_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir14_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir14_6_2          jmp         ir14_6_2_1        ;(3 cycles)
                  
                  dcb         $02,$00           ;skip 02 bytes of memory - not needed any more, originally used to keep the $7fff location clear of code
                  
ir14_6_2_1        jmp         ir14_7            ;(3 cycles)

ir14_7            lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $9D (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$74              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir14_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$9f              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir14_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$9e              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir14_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$74              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir14_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir14_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir14_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  
                                                ;=> 27-28 cycles have passed
ir14_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir14_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir14_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir14_10           cpy         #$8a              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir14_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$9f              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir14_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir14_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir14_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir14_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir14_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

                  lda         #$28              ;load pointer gfx char set 2
                  sta         $d018             ;activate gfx char set 2

;============================================================================================================================================================

txtscrllsp1       lda         scrldly           ;check scroll delay
                  bne         ir14_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$19a       ;line by line, starting with the leftmost byte (byte $02 of sprite $06)
                  rol         scrspr+$182       ;line 1
                  rol         scrspr+$180       
                  rol         scrspr+$142       
                  rol         scrspr+$141       
                  rol         scrspr+$140       
                  rol         scrspr+$102       
                  rol         scrspr+$101       
                  rol         scrspr+$100       
                  rol         scrspr+$0c2       
                  rol         scrspr+$0c1       
                  rol         scrspr+$0c0       
                  rol         scrspr+$082       
                  rol         scrspr+$081       
                  rol         scrspr+$080       
                  rol         scrspr+$042       
                  rol         scrspr+$041       
                  rol         scrspr+$040       
                  rol         scrspr+$002       
                  rol         scrspr+$001       
                  rol         scrspr+$000       
                  lda         $a120             ;add character mask for "fading" in characters on the right
                  and         scrspr+$182       ;AND to only keep characters that are both in the sprite and character data
                  sta         scrspr+$181       

;============================================================================================================================================================

ir14_e            lda         #$a4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir15            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir15            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir15              lda         #<ir15_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir15_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir15 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir15_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $A5
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir15_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir15_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$7b              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir15_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$a5              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir15_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$7b              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir15_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir15_2            jmp         ir15_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir15_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir15_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$91              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir15_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$a6              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir15_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir15_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir15_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir15_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir15_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir15_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles)

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $A6 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$7c              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir15_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$a7              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir15_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$a6              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir15_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$7c              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir15_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir15_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir15_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir15_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir15_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir15_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir15_10           cpy         #$92              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir15_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$a7              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir15_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir15_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir15_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir15_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir15_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp2       lda         scrldly           ;check scroll delay
                  bne         ir15_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$19d       ;line by line, starting with the leftmost byte (byte $05 of sprite $06)
                  rol         scrspr+$185       ;line 2
                  rol         scrspr+$183       
                  rol         scrspr+$145       
                  rol         scrspr+$144       
                  rol         scrspr+$143       
                  rol         scrspr+$105       
                  rol         scrspr+$104       
                  rol         scrspr+$103       
                  rol         scrspr+$0c5       
                  rol         scrspr+$0c4       
                  rol         scrspr+$0c3       
                  rol         scrspr+$085       
                  rol         scrspr+$084       
                  rol         scrspr+$083       
                  rol         scrspr+$045       
                  rol         scrspr+$044       
                  rol         scrspr+$043       
                  rol         scrspr+$005       
                  rol         scrspr+$004       
                  rol         scrspr+$003       
                  lda         $a121             
                  and         scrspr+$185       
                  sta         scrspr+$184       

;============================================================================================================================================================

ir15_e            lda         #$ac              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir16            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir16            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir16              lda         #<ir16_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir16_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir16 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir16_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $AD
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir16_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir16_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$83              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir16_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$ad              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir16_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$83              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir16_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir16_2            jmp         ir16_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir16_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir16_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$99              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir16_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$ae              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir16_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir16_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir16_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir16_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir16_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir16_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $AE (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$84              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir16_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$af              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir16_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$ae              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir16_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$84              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir16_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir16_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir16_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir16_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir16_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir16_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir16_10           cpy         #$9a              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir16_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$af              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir16_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir16_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir16_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir16_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir16_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

ir16_e            lda         #$b0              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir16a           ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir16a           
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir16a             lda         #<ir16a_1         ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir16a_1         ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir16a came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir16a_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir16a_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $B2
                                                ;IMPORTANT FOR ALL FOLLOWING CHECKS: Y COORDINATE SPRITE = RASTER LINE - 1

                                                ;set pointers for rotating square / white noise bar sprites (instead of empty sprite) so they appear below
                                                ;the top border of the monitor
ir16a_1           lda         #$7f              ;(2 cycles) set sprites 0-6 behind graphics - the sprites should become visible on the first line of the monitor area, which is a bad line
                                                ;this seems to make it impossible to time the appearance of sprites 0-5 properly by just by switching from the empty sprite
                                                ;to the actual sprite; be hiding the "appearance" behind the graphics, it just has to be made sure that the priority is
                                                ;switched back to in front of the graphics before the first line of the monitor is displayed, but also after the sprites
                                                ;have been displayed in the previous line
                  sta         $d01b             ;(4 cycles)
                  lda         $d00b             ;(4 cycles) load y coordinate of sprite 5
                  cmp         #$ff              ;(2 cycles) check if = $ff (= y coordinate for scroller sprites, i.e. square animation not running)
                  beq         ir16a_2           ;(3 cycles) y = $ff, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  lda         sqanindx          ;(4 cycles) load current index for rotating square sprite data (outline)
                  sta         $4bf8             ;(4 cycles) set pointers for sprites 0-2 (square outline)
                  sta         $4bf9             ;(4 cycles)
                  sta         $4bfa             ;(4 cycles)
                  clc                           ;(2 cycles) clear carry for correct addition
                  adc         #$09              ;(2 cycles) add 9 to index to get index for rotating square sprite data (filler)
                  sta         $4bfb             ;(4 cycles) set pointers for sprites 3-5 (square filler)
                  sta         $4bfc             ;(4 cycles)
                  sta         $4bfd             ;(4 cycles)
                                                ;=> 54-55 cycles have passed
                                                ;sprites 0-2 are fetched for the next raster line => 9 cycles (3 for taking over the bus and 3 x 2 for fetching the data)

                                                ;RASTER LINE $B3
                                                ;sprites 3-5 are fetched for the next raster line => 9 cycles (3 for taking over the bus and 3 x 2 for fetching the data)
                                                ;=> 10-11 cycles have passed

                  ldy         #$03              ;(2 cycles)
                  jmp         ir16a_3           ;(3 cycles)

                                                ;set pointers for white noise bar sprites (instead of empty sprite) so they appear below the top border of the monitor
                                                ;=> 23-24 cycles have passed
ir16a_2           lda         mnanipt           ;(4 cycles) check if current animation part = $16
                  cmp         #$16              ;(2 cycles)
                  bne         ir16a_4           ;(3 cycles) animation part <> $016, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  lda         #$78              ;(2 cycles) load pointer for white noise bar
                  sta         $4bf8             ;(4 cycles) set pointers for sprites 0-2
                  sta         $4bf9             ;(4 cycles)
                  sta         $4bfa             ;(4 cycles)
                  ldy         #$06              ;(2 cycles)
                  jmp         ir16a_5           ;(3 cycles)
                                                ;=> 50-51 cycles have passed

                  ldy         #$02              ;(2 cycles)
ir16a_3           dey                           ;(9/14 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
ir16a_4           lda         #$00              ;(2 cycles) set all sprites inf front of graphics
                  sta         $d01b             ;(4 cycles)
ir16a_5           lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

;============================================================================================================================================================

ir16a_e           lda         #$b4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir17            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir17            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir17              lda         #<ir17_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir17_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir17 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir17_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $B5
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir17_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir17_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$8b              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir17_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$b5              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir17_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$8b              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir17_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 43-44 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir17_2            jmp         ir17_6_1          ;(3 cycles)

                                                ;=> 26-27 cycles have passed
ir17_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 30-31 cycles have passed
ir17_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$a1              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir17_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$b6              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir17_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 42-43 cycles have passed

                  jmp         ir17_6_2          ;(3 cycles)

                                                ;=> 39-40 cycles have passed
ir17_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 43-44 cycles have passed
ir17_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir17_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir17_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 57-58 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $B6 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$8c              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir17_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$b7              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir17_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$b6              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir17_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$8c              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir17_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir17_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir17_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir17_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir17_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir17_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir17_10           cpy         #$a2              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir17_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$b7              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir17_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir17_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir17_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir17_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir17_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp3       lda         scrldly           ;check scroll delay
                  bne         ir17_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1a0       ;line by line, starting with the leftmost byte (byte $08 of sprite $06)
                  rol         scrspr+$188       ;line 3
                  rol         scrspr+$186       
                  rol         scrspr+$148       
                  rol         scrspr+$147       
                  rol         scrspr+$146       
                  rol         scrspr+$108       
                  rol         scrspr+$107       
                  rol         scrspr+$106       
                  rol         scrspr+$0c8       
                  rol         scrspr+$0c7       
                  rol         scrspr+$0c6       
                  rol         scrspr+$088       
                  rol         scrspr+$087       
                  rol         scrspr+$086       
                  rol         scrspr+$048       
                  rol         scrspr+$047       
                  rol         scrspr+$046       
                  rol         scrspr+$008       
                  rol         scrspr+$007       
                  rol         scrspr+$006       
                  lda         $a122             
                  and         scrspr+$188       
                  sta         scrspr+$187       

;============================================================================================================================================================

ir17_e            lda         #$bc              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir18            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir18            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir18              lda         #<ir18_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir18_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir18 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir18_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $BD
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir18_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir18_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$93              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir18_3            ;(4 cycles  - page boundary crossed) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$bd              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir18_4            ;(4 cycles  - page boundary crossed) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$93              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir18_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir18_2            jmp         ir18_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir18_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir18_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$a9              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir18_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$be              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir18_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir18_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir18_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir18_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir18_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir18_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $BE (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$94              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir18_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$bf              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir18_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$be              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir18_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$94              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir18_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir18_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir18_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir18_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir18_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir18_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir18_10           cpy         #$aa              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir18_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$bf              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir18_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir18_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir18_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir18_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir18_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

                  jmp         txtscrllsp4

;============================================================================================================================================================

_CODE_ADE0

*=$ade0

txtscrllsp4       lda         scrldly           ;check scroll delay
                  bne         ir18_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1a3       ;line by line, starting with the leftmost byte (byte $0b of sprite $06)
                  rol         scrspr+$18b       ;line 4
                  rol         scrspr+$189       
                  rol         scrspr+$14b       
                  rol         scrspr+$14a       
                  rol         scrspr+$149       
                  rol         scrspr+$10b       
                  rol         scrspr+$10a       
                  rol         scrspr+$109       
                  rol         scrspr+$0cb       
                  rol         scrspr+$0ca       
                  rol         scrspr+$0c9       
                  rol         scrspr+$08b       
                  rol         scrspr+$08a       
                  rol         scrspr+$089       
                  rol         scrspr+$04b       
                  rol         scrspr+$04a       
                  rol         scrspr+$049       
                  rol         scrspr+$00b       
                  rol         scrspr+$00a       
                  rol         scrspr+$009       
                  lda         $a123             
                  and         scrspr+$18b       
                  sta         scrspr+$18a       

;============================================================================================================================================================

ir18_e            lda         #$c4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir19            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir19            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir19              lda         #<ir19_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir19_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir19 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir19_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $C5
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir19_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir19_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$9b              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir19_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$c5              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir19_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$9b              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir19_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir19_2            jmp         ir19_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir19_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir19_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$b1              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir19_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$c6              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir19_6            ;(4 cycles  - page boundary crossed) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir19_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir19_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir19_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir19_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir19_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $C6 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$9c              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir19_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$c7              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir19_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$c6              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir19_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$9c              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir19_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir19_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir19_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir19_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir19_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir19_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir19_10           cpy         #$b2              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir19_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$c7              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir19_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir19_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir19_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir19_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir19_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp5       lda         scrldly           ;check scroll delay
                  bne         ir19_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1a6       ;line by line, starting with the leftmost byte (byte $0e of sprite $06)
                  rol         scrspr+$18e       ;line 5
                  rol         scrspr+$18c       
                  rol         scrspr+$14e       
                  rol         scrspr+$14d       
                  rol         scrspr+$14c       
                  rol         scrspr+$10e       
                  rol         scrspr+$10d       
                  rol         scrspr+$10c       
                  rol         scrspr+$0ce       
                  rol         scrspr+$0cd       
                  rol         scrspr+$0cc       
                  rol         scrspr+$08e       
                  rol         scrspr+$08d       
                  rol         scrspr+$08c       
                  rol         scrspr+$04e       
                  rol         scrspr+$04d       
                  rol         scrspr+$04c       
                  rol         scrspr+$00e       
                  rol         scrspr+$00d       
                  rol         scrspr+$00c       
                  lda         $a124             
                  and         scrspr+$18e       
                  sta         scrspr+$18d       

;============================================================================================================================================================

ir19_e            lda         #$cc              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir20            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir20            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir20              lda         #<ir20_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir20_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir20 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir20_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $CD
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir20_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir20_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$a3              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir20_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$cd              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir20_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$a3              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir20_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir20_2            jmp         ir20_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir20_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir20_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$b9              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir20_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$ce              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir20_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir20_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir20_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir20_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir20_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir20_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $CE (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$a4              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir20_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$cf              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir20_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$ce              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir20_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$a4              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir20_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir20_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir20_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir20_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir20_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir20_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir20_10           cpy         #$ba              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir20_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$cf              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir20_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir20_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir20_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir20_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir20_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code
                  
                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp6       lda         scrldly           ;check scroll delay
                  bne         ir20_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1a9       ;line by line, starting with the leftmost byte (byte $11 of sprite $06)
                  rol         scrspr+$191       ;line 6
                  rol         scrspr+$18f       
                  rol         scrspr+$151       
                  rol         scrspr+$150       
                  rol         scrspr+$14f       
                  rol         scrspr+$111       
                  rol         scrspr+$110       
                  rol         scrspr+$10f       
                  rol         scrspr+$0d1       
                  rol         scrspr+$0d0       
                  rol         scrspr+$0cf       
                  rol         scrspr+$091       
                  rol         scrspr+$090       
                  rol         scrspr+$08f       
                  rol         scrspr+$051       
                  rol         scrspr+$050       
                  rol         scrspr+$04f       
                  rol         scrspr+$011       
                  rol         scrspr+$010       
                  rol         scrspr+$00f       
                  lda         $a125             
                  and         scrspr+$191       
                  sta         scrspr+$190       

;============================================================================================================================================================

ir20_e            lda         #$d4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir21            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir21            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir21              lda         #<ir21_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir21_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir21 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir21_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $D5
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir21_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir21_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$ab              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir21_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$d5              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir21_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$ab              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir21_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir21_2            jmp         ir21_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir21_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir21_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$c1              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir21_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$d6              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir21_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir21_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir21_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir21_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir21_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir21_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $D6 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$ac              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir21_9            ;(3 cycles) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$d7              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir21_10           ;(3 cycles) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$d6              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir21_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$ac              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir21_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir21_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir21_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir21_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir21_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir21_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir21_10           cpy         #$c2              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir21_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$d7              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir21_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir21_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir21_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir21_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir21_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp7       lda         scrldly           ;check scroll delay
                  bne         ir21_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1ac       ;line by line, starting with the leftmost byte (byte $14 of sprite $06)
                  rol         scrspr+$194       ;line 7
                  rol         scrspr+$192       
                  rol         scrspr+$154       
                  rol         scrspr+$153       
                  rol         scrspr+$152       
                  rol         scrspr+$114       
                  rol         scrspr+$113       
                  rol         scrspr+$112       
                  rol         scrspr+$0d4       
                  rol         scrspr+$0d3       
                  rol         scrspr+$0d2       
                  rol         scrspr+$094       
                  rol         scrspr+$093       
                  rol         scrspr+$092       
                  rol         scrspr+$054       
                  rol         scrspr+$053       
                  rol         scrspr+$052       
                  rol         scrspr+$014       
                  rol         scrspr+$013       
                  rol         scrspr+$012       
                  lda         $a126             
                  and         scrspr+$194       
                  sta         scrspr+$193       

;============================================================================================================================================================

ir21_e            lda         #$dc              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir22            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir22            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir22              lda         #<ir22_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir22_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir22 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir22_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $DD
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir22_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir22_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$b3              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir22_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$dd              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir22_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$b3              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir22_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir22_2            jmp         ir22_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir22_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir22_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$c9              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir22_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$de              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir22_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir22_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir22_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir22_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir22_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir22_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $DE (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$b4              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir22_9            ;(4 cycles  - page boundary crossed) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$df              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir22_10           ;(4 cycles  - page boundary crossed) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$de              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir22_8_1          ;(3 cycles) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$b4              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir22_8_2          ;(3 cycles) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir22_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir22_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir22_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir22_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir22_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir22_10           cpy         #$ca              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir22_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$df              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir22_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir22_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir22_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir22_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir22_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

txtscrllsp8       lda         scrldly           ;check scroll delay
                  bne         ir22_e            ;if = $00, scroll

                  clc                           ;shift sprite data to the left
                  rol         scrspr+$1af       ;line by line, starting with the leftmost byte (byte $14 of sprite $06)
                  rol         scrspr+$197       ;line 8
                  rol         scrspr+$195       
                  rol         scrspr+$157       
                  rol         scrspr+$156       
                  rol         scrspr+$155       
                  rol         scrspr+$117       
                  rol         scrspr+$116       
                  rol         scrspr+$115       
                  rol         scrspr+$0d7       
                  rol         scrspr+$0d6       
                  rol         scrspr+$0d5       
                  rol         scrspr+$097       
                  rol         scrspr+$096       
                  rol         scrspr+$095       
                  rol         scrspr+$057       
                  rol         scrspr+$056       
                  rol         scrspr+$055       
                  rol         scrspr+$017       
                  rol         scrspr+$016       
                  rol         scrspr+$015       
                  lda         $a127             
                  and         scrspr+$197       
                  sta         scrspr+$196       

;============================================================================================================================================================

ir22_e            lda         #$e4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir23            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir23            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

_CODE_B6C0

*=$b6c0

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register, 9 for fetching the data for sprites 3-5 (only if displayed))
ir23              lda         #<ir23_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir23_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir23 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir23_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $E5
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir23_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir23_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldx         $d00b             ;(4 cycles) load y coordinate of sprite 5 to check if sprites 3-5 (same y position) are displayed on the CURRENT line
                                                ;if they are displayed, their data has already been fetched and has consumed cycles
                  cpx         #$bb              ;(2 cycles) check if y < CURRENT line - 1 - $29 (sprites 3-5 are y expanded in the monitor area)
                  bcc         ir23_3            ;(3 cycles) y <, sprites 3-5 are NOT displayed on CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$e5              ;(2 cycles) check if y > highest y for which sprites 3-5 ARE displayed on CURRENT line
                  bcs         ir23_4            ;(3 cycles) y >=, sprites 3-5 are NOT displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 37-38 cycles have passed

                  cpx         #$bb              ;(2 cycles) if sprites 3-5 are displayed on the CURRENT line, sprites 0-2 are also displayed (y expanded) on the CURRENT line
                                                ;and have the same y position as sprites 3-5; if they are displayed on the NEXT line, the timing has to take into account the
                                                ;9 cycles (3 for taking over the bus and 3 x 2 for fetching the data) for fetching the sprite data at the end of the CURRENT line
                  bne         ir23_2            ;(3 cycles) y <>, sprites 0-2 ARE displayed on the next line, skip ahead
                                                ;(2 cycles) carry on with thee next instruction
                  jmp         *+3               ;(3 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 54-55 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
ir23_2            jmp         ir23_6_1          ;(3 cycles)

                                                ;=> 25-26 cycles have passed
ir23_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                                                ;=> 29-30 cycles have passed

ir23_4            ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$d1              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir23_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$e6              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir23_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 41-42 cycles have passed

                  jmp         ir23_6_2          ;(3 cycles)

                                                ;=> 38-39 cycles have passed
ir23_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 42-43 cycles have passed
ir23_6            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir23_6_1          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir23_6_2          nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  lda         #$00              ;(2 cycles)

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $E6 (where the black line is actually displayed)
                                                ;=> 2-3 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 3-4 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> 10-11 cycles have passed if sprites 3-5 ARE also displayed on the CURRENT line
                                                ;=> X = y coordinate of sprite 5
                                                ;=> Y = y coordinate of sprite 2

                  cpx         #$bc              ;(2 cycles) check if y < current raster line - $29 for sprite 5
                  bcc         ir23_9            ;(4 cycles  - page boundary crossed) y <, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y >=, sprites 3-5 are POTENTIALLY displayed on THIS line
                  cpx         #$e7              ;(2 cycles) check if y > highest y for which sprites 3-5 are displayed on the CURRENT or the NEXT line
                                                ;the NEXT line has to be taken into account because if sprites 3-5 are displayed there, sprites 0-2 will also be displayed
                                                ;there, which means extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  bcs         ir23_10           ;(4 cycles  - page boundary crossed) y >=, sprites 3-5 not displayed on the CURRENT line, skip ahead
                                                ;(2 cycles) y <, sprites 3-5 ARE displayed on the CURRENT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) have been consumed
                                                ;=> 18-19 cycles have passed

                  cpx         #$e6              ;(2 cycles) check if sprites 3-5 are displayed on the NEXT line, but NOT the CURRENT line; if they are, sprites 0-2 are also
                                                ;displayed and extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  beq         ir23_8_1          ;(4 cycles  - page boundary crossed) y =, sprites 0-2 ARE displayed on the NEXT line (but not THIS line), skip ahead
                                                ;(2 cycles) y <>, sprites 0-2 ARE displayed on the CURRENT line and the NEXT line
                  cpx         #$bc              ;(2 cycles) check if sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line
                  bne         ir23_8_2          ;(4 cycles  - page boundary crossed) y <>, sprites 3-5 (and sprites 0-2) ARE displayed on the next line, skip ahead
                                                ;(2 cycles) y=, sprites 3-5 (and sprites 0-2) are NOT displayed on the NEXT line

                                                ;=> 26-27 cycles have passed
                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir23_13           ;(3 cycles)

                                                ;sprites 0-2 ARE displayed on the NEXT line, but NO sprites are displayed on the CURRENT line
                                                ;=> 15-16 cycles have passed
ir23_8_1          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 27-28 cycles have passed
ir23_8_2          nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  ldy         #$03              ;(2 cycles) load value for delay loop
                  jmp         ir23_13           ;(3 cycles)

                                                ;sprites 3-5 NOT displayed on the CURRENT line
                                                ;=> 7-8 cycles have passed
ir23_9            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir23_10           cpy         #$d2              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir23_11           ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$e7              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir23_12           ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 19-20 cycles have passed

                  ldy         #$05              ;(2 cycles) load value for delay loop
                  jmp         ir23_13           ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 16-17 cycles have passed
ir23_11           nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 20-21 cycles have passed
ir23_12           ldy         #$07              ;(2 cycles) load value for delay loop
ir23_13           dey                           ;(24/14/24/34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 52-53 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020

;============================================================================================================================================================

txtscrllsp9       lda         scrldly           ;check scroll delay
                  bne         ir23_e            ;if = $00, scroll
                  lda         #$02              
                  sta         scrldly           


                  lda         $a0e0             ;line 1
                  and         scrspr            ;add mask (character $1c @ $a0e0) for "fading" sprites out on the left side of the scroll
                  sta         scrspr            ;AND to only keep characters that are both in the sprite and character data

                  lda         $a0e1             ;line 2
                  and         scrspr+$03        
                  sta         scrspr+$03        

                  lda         $a0e2             ;line 3
                  and         scrspr+$06        
                  sta         scrspr+$06        

                  lda         $a0e3             ;line 4
                  and         scrspr+$09        
                  sta         scrspr+$09        

                  lda         $a0e4             ;line 5
                  and         scrspr+$0c        
                  sta         scrspr+$0c        

                  lda         $a0e5             ;line 6
                  and         scrspr+$0f        
                  sta         scrspr+$0f        

                  lda         $a0e6             ;line 7
                  and         scrspr+$12        
                  sta         scrspr+$12        

                  lda         $a0e7             ;line 8
                  and         scrspr+$15        
                  sta         scrspr+$15        

;============================================================================================================================================================

ir23_e            lda         #$ec              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir24            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir24            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-25 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir24              lda         #<ir24_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir24_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir24 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles)
                                                ;=> 37-53 cycles have passed

                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir24_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                                                ;=> 65 cycles have passed in the "best" case (no sprites, current command took 2 cycles to finish)

                                                ;RASTER LINE $ED
                                                ;IMPORTANT NOTE: Y COORDINATE SPRITE = RASTER LINE - 1
                                                ;before the ir24_1 part actually starts, 8-9 cycles have passed (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

ir24_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  ldy         $d005             ;(4 cycles) load y coordinate of sprite 2 to check if sprites 0-2 (same y position) are displayed on the NEXT line
                                                ;if they are displayed, extra cycles will be consumed for fetching the sprite data at the end of the CURRENT line
                  cpy         #$d9              ;(2 cycles) check if y < CURRENT line - 1 - $14 (sprites 0-2 are NOT y expanded in this case)
                  bcc         ir24_2            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$ee              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir24_3            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y <, sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 28-29 cycles have passed

                  jmp         ir24_4            ;(3 cycles)

                                                ;=> 27-28 cycles have passed
ir24_2            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 31-32 cycles have passed
ir24_3            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
ir24_4            ldx         #$04              ;(2 cycles) load value for delay loop
                  dex                           ;(19 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;(2 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             ;(6 cycles) set border color to black

                                                ;RASTER LINE $EE (where the black line is actually displayed)
                                                ;=> 1-2 cycles have passed if NO sprites are displayed on the CURRENT line
                                                ;=> 2-3 cycles have passed if sprites 0-2 ARE displayed on the CURRENT line
                                                ;=> Y = y coordinate of sprite 2

                  cpy         #$da              ;(2 cycles) check if y < current raster line - $14 to see if sprites 0-2 are displayed on the NEXT line
                  bcc         ir24_5            ;(3 cycles) y <, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) y >=, sprites 0-2 are POTENTIALLY displayed on the NEXT line
                  cpy         #$ef              ;(2 cycles) check if y > highest y for which sprites 0-2 are displayed on the NEXT raster line
                  bcs         ir24_6            ;(3 cycles) y >=, sprites 0-2 are NOT displayed on the NEXT line, skip ahead
                                                ;(2 cycles) sprites 0-2 ARE displayed on the NEXT line, which means an extra 9 cycles (3 for taking over the bus
                                                ;and 3 x 2 for fetching the data) will be consumed at the END of the CURRENT line
                                                ;=> 11-12 cycles have passed
                  nop                           ;(2 cycles)
                  ldy         #$06              ;(2 cycles) load value for delay loop
                  jmp         ir24_7            ;(3 cycles)

                                                ;sprites 0-2 are NOT displayed on the next raster line
                                                ;=> 7-8 cycles have passed
ir24_5            nop                           ;(2 cycles) wait n cycles
                  nop                           ;(2 cycles)

                                                ;=> 11-12 cycles have passed
ir24_6            jmp         *+3               ;(3 cycles) wait n cycles
                  ldy         #$08              ;(2 cycles) load value for delay loop
ir24_7            dey                           ;(34/39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  jmp         *+3               ;(3 cycles) wait n cycles
                  lda         bgcol             ;(4 cycles) load background color code

                                                ;=> 54-55 cycles have passed if sprites 0-2 ARE displayed on the NEXT line
                                                ;=> 60-61 cycles have passed if sprites 0-2 are NOT displayed on the NEXT line
                  sta         $d020             

;============================================================================================================================================================

                                                ;(re)set scroller sprites that have been used otherwise
                                                ;runs always, although only needed in a few parts
SPRTRST           lda         eyedur            ;check if duration is <> $00, i.e. if the duration has passed
                  bne         sprtrst_s1        ;if not, skip ahead
                  lda         mnanidly11        ;check if delay is $01 - this is needed so the eye does not immediately disappear after the last blink
                  cmp         #$01              ;if not, skip ahead
                  bne         sprtrst_s1        
                  lda         #$0d              ;activate next animation part
                  sta         mnanipt           
                  lda         #$40              ;reset delay between animation parts
                  sta         mnanidly11        
                  lda         #05               ;reset duration of eye animation
                  sta         eyedur            
sprtrst_s1        lda         tmpscrlcol        ;restore color of scroller sprites $00-$05
                  sta         $d027             
                  sta         $d028             
                  sta         $d029             
                  sta         $d02a             
                  sta         $d02b             
                  sta         $d02c             
                  sta         $d02d             

                  lda         #$7f              ;turn on x/y expansion
                  sta         $d017             
                  sta         $d01d             

                  lda         #$00              ;set priority to "in front of graphics"
                  sta         $d01b             

                  lda         #$ff              ;restore y coordinate for scroller sprites $00-$05
                  sta         $d001             
                  sta         $d003             
                  sta         $d005             
                  sta         $d007             
                  sta         $d009             
                  sta         $d00b             

                  lda         #$18              ;restore x coordinate for scroller sprites $00-$05
                  sta         $d000             
                  lda         #$48              
                  sta         $d002             
                  lda         #$78              
                  sta         $d004             
                  lda         #$a8              
                  sta         $d006             
                  lda         #$d8              
                  sta         $d008             
                  lda         #$08              
                  sta         $d00a             

                  lda         $d010             ;restore x > $ff for sprites $05, $06
                  ora         #$60              
                  sta         $d010             
                  lda         #$30              ;restore pointers for scroller sprites $00-$05
                  sta         $4bf8             
                  lda         #$31              
                  sta         $4bf9             
                  lda         #$32              
                  sta         $4bfa             
                  lda         #$33              
                  sta         $4bfb             
                  lda         #$34              
                  sta         $4bfc             
                  lda         #$35              
                  sta         $4bfd             
                  lda         #$36              
                  sta         $4bfe             

;============================================================================================================================================================

ir24_e            lda         #$f4              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir25            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir25            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir25              lda         #<ir25_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir25_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir25 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir25_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir25_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $F5

ir25_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X

                  ldy         #$08              ;(2 cycles)
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               

                                                ;=> 57-58 cycles have passed
                  lda         #$00              ;(2 cycles)
                  sta         $d020             ;(4 cycles) set border color to black

                                                ;RASTER LINE $F6 (where the black line is actually displayed)
                                                ;=> 1-2 cycles have passed

                  ldy         #$0b              ;(2 cycles)
                  dey                           ;(54 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               

                                                ;=> 57-58 cycles have passed 
                  
                  lda         bgcol             ;(4 cycles) load background color code
                  sta         $d020             ;reset border color

;============================================================================================================================================================

;COLOR SCROLLER

CLRSCROLL         ldx         scrlclndx         ;load pointer for scroller color
                  bne         clrscroll_s1      ;if it is $00, the pointer needs to be reset
                                                ;set pointer for scroll color to number of frames per color
                                                ;multiplied with number of colors used
                  ldx         #scrlclfrms*scrlcls
                  stx         scrlclndx         
clrscroll_s1      lda         scrlcol-1,x       ;load color for scroller
                  sta         $d027             ;set in scroller sprites
                  sta         $d028             
                  sta         $d029             
                  sta         $d02a             
                  sta         $d02b             
                  sta         $d02c             
                  sta         $d02d             
                  dec         scrlclndx         ;decrease pointer for scoller color

;============================================================================================================================================================

ir25_e            lda         #$f8              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir26            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir26            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

ir26              lsr         $d019             ;acknowledge raster interrupt
                  lda         #$13              ;switch to 24 line mode to open border
                  sta         $d011             

;============================================================================================================================================================

                  lda         #$fb              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<ir27            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir27            
                  sta         $ffff             

;============================================================================================================================================================
;ELECTRIC ARC ANIMATION

ELECTRICARCS      lda         eactv             ;check if an animation is running
                  beq         electricarcs_s1   
                  jmp         electricarcs_s3   ;if yes, continue animation

electricarcs_s1   ldx         eandx
                  dex
                  bpl         electricarcs_s2   
                  ldx         #$04              
electricarcs_s2   stx         eandx
                  txa
                  asl                           ;multiply animation index by 4 to get offset for electric arc animation meta data (eaanimd)
                  asl
                  tax
                  lda         eaanimd,x         ;set sprite data pointer
                  sta         $4bff             
                  lda         eaanimd+1,x       ;set x coordinate
                  sta         $d00e             
                  lda         eaanimd+2,x       ;set y coordinate
                  sta         $d00f             
                  lda         eaanimd+3,x       ;set x coordinate > $f
                  sta         $d010             
                  ldx         eafrmndx          ;set color
                  lda         eaanicol,x        
                  sta         $d02e             
                  lda         #$ff              ;turn on electric arc sprite
                  sta         $d015             
                  lda         #$01              ;set eactv to $01 (animation active)
                  sta         eactv             
                  dec         eafrmndx          ;set pointer for next animation frame
                  jmp         earcskip          
                                                ;continue running animation
electricarcs_s3   dec         eadly             ;decrease delay and check if delay has reached $00
                  beq         electricarcs_s4   
                  jmp         earcskip          ;if not, do nothing
electricarcs_s4   lda         #$03              ;reset delay
                  sta         eadly             
                  ldx         eafrmndx          ;get and set current animation frame color
                  lda         eaanicol,x        
                  sta         $d02e             
                  inc         $4bff             ;set sprite pointer to next frame of animation
                  dec         eafrmndx          ;decrease animation frame pointer
                  bpl         earcskip          
                  lda         #$0a              ;if animation frame pointer is $00, reset pointer
                  sta         eafrmndx          
                  lda         #$00              ;and set eactv to $00 (no active animation)
                  sta         eactv             
                  sta         $d00f             ;move sprite to neutral position, because the raster line timers check the y location of the sprites to adjust timing
                  lda         #$7f              ;turn off electric arc sprite - the last animation could just have stopped
                  sta         $d015             

;============================================================================================================================================================

earcskip          rti


;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir27              lda         #<ir27_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir27_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir27 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  lda         #$00              ;(2 cycles) load empty pattern for border
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir27_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir27_1 part starts, 8-9 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register)

                                                ;RASTER LINE $FC

ir27_1            sta         $7fff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  lda         #$02              ;(2 cycles) load color code for red scroller band
                                                ;=> 24-25 cycles have passed

                  ldy         #$07              ;(2 cycles)
                  dey                           ;(34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles)

                                                ;=> 59-60 cycles have passed
                  sta         $d020             ;(4 cycles) set border and screen color for scroller band
                  sta         $d021             ;(4 cycles)

;============================================================================================================================================================
;SCROLL THE MONITOR GRID
                                                ;direction ids are based on bits 0-3
                                                ;%0001 = up
                                                ;%0010 = right
                                                ;%0100 = down
                                                ;%1000 = left
GRIDSCROLL        dec         grdscrldly
                  beq         gridscroll_s01    

                  jmp         ir27_e            

gridscroll_s01    lda         #04               ;reset delay for grid scroll
                  sta         grdscrldly        
                  lda         $dc04             ;create a pseudo random value
                  eor         $dc05             
                  sbc         $dc06             
                  eor         $dc07             
                  cmp         #$e0              ;if <$e0, keep current scroll direction
                  bcc         slctdir           
                  lda         $dc04             ;create a pseudo random value
                  ora         $dc05             
                  sbc         $dc06             
                  and         $dc07             
                  cmp         #$e0              ;if >= $e0, set direction to up (%0001)
                  bcc         gridscroll_s02    
                  lda         #$01              
                  jmp         strdir            
gridscroll_s02    cmp         #$c0              ;if >= $c0, set direction to up/left (%0011)
                  bcc         gridscroll_s03    
                  lda         #$03              
                  jmp         strdir            
gridscroll_s03    cmp         #$a0              ;if >= $a0, set direction to left (%0010)
                  bcc         gridscroll_s04    
                  lda         #$02              
                  jmp         strdir            
gridscroll_s04    cmp         #$80              ;if >= $80, set direction to down/left (%0110)
                  bcc         gridscroll_s05    
                  lda         #$06              
                  jmp         strdir            
gridscroll_s05    cmp         #$60              ;if >= $60, set direction to down (%0100)
                  bcc         gridscroll_s06    
                  lda         #$04              
                  jmp         strdir            
gridscroll_s06    cmp         #$40              ;if >= $40, set direction to down/right (%1100)
                  bcc         gridscroll_s07    
                  lda         #$0c              
                  jmp         strdir            
gridscroll_s07    cmp         #$20              ;if >= $20, set direction to right (%1000)
                  bcc         gridscroll_s08    
                  lda         #$08              
                  jmp         strdir            
gridscroll_s08    lda         #$09              ;else set direction to up/right (%1001)
strdir            sta         dirscrll

slctdir           lda         dirscrll          ;load grid shift direction

                                                ;the grid char consists of only 4 discreet bytes and is shifted two pixels up,
                                                ;therefore only bytes 0,2,4 and 6 of the char need to be loaded
shftup            ror                           ;rotate right to check if bit for shift up is set
                  bcc         shftrght          
                  tax                           ;store dirscrll in x because it is needed again (needs less cycles then PHA/PLA)
                  lda         $60f0             ;push two bytes of grid char on stack
                  pha
                  lda         $60f2             ;copy the rest of the grid chars two bytes up
                  sta         $60f0             
                  sta         $60f1             
                  lda         $60f4             
                  sta         $60f2             
                  sta         $60f3             
                  lda         $60f6             
                  sta         $60f4             
                  sta         $60f5             
                  pla                           ;store top bytes from stack in bottom two bytes of grid char
                  sta         $60f7             
                  sta         $60f6             
                  txa                           ;restore dirscrll

                                                ;the grid char consists of only 4 discreet bytes
                                                ;therefore only bytes 0,2,4 and 6 of the char need to be loaded/processed
shftrght          ror                           ;rotate right to check if bit for shift left is set
                  bcc         shftdwn           
                  tax                           ;store dirscrll in x because it is needed again
                  lda         $60f0             ;shift byte 0 of grid char two bits to the right
                  lsr
                  lsr
                  bcc         gridscroll_s09    ;if the carry is set, the leftmost multicolor pixel was set
                  ora         #$80              ;add multiocolor pixel on the right
gridscroll_s09    sta         $60f0
                  sta         $60f1             ;also store in byte 1
                  lda         $60f2             ;shift byte 2 of grid char two bits to the right
                  lsr
                  lsr
                  bcc         gridscroll_s10    
                  ora         #$80              
gridscroll_s10    sta         $60f2
                  sta         $60f3             ;also store in byte 3
                  lda         $60f4             ;shift byte 4 of grid char two bits to the right
                  lsr
                  lsr
                  bcc         gridscroll_s11    
                  ora         #$80              
gridscroll_s11    sta         $60f4
                  sta         $60f5             ;also store in byte 5
                  lda         $60f6             ;shift byte 6 of grid char two bits to the right
                  lsr
                  lsr
                  bcc         gridscroll_s12    
                  ora         #$80              
gridscroll_s12    sta         $60f6
                  sta         $60f7             ;also store in byte 7
                  txa                           ;restore dirscrll

                                                ;the grid char consists of only 4 discreet bytes and is shifted two pixels down,
                                                ;therefore only bytes 0,2,4 and 6 of the char need to be loaded
shftdwn           ror                           ;rotate right to check if bit for shift up is set
                  bcc         shftlft           
                  tax                           ;store dirscrll in x because it is needed again
                  lda         $60f6             ;push bottom two bytes of grid char on stack
                  pha
                  lda         $60f4             ;copy the rest of the grid chars two bytes down
                  sta         $60f6             
                  sta         $60f7             
                  lda         $60f2             
                  sta         $60f4             
                  sta         $60f5             
                  lda         $60f0             
                  sta         $60f2             
                  sta         $60f3             
                  pla                           ;store bottom bytes from stack in top two bytes of grid char
                  sta         $60f0             
                  sta         $60f1             
                  txa                           ;restore dirscrll

                                                ;the grid char consists of only 4 discreet bytes
                                                ;therefore only bytes 0,2,4 and 6 of the char need to be loaded/processed
shftlft           ror                           ;rotate right to check if bit for shift up is set
                  bcs         gridscroll_s13    
                  jmp         gridscroll_s22    
gridscroll_s13    lda         $60f0             ;shift byte 0 of the grid on bit to the left
                  asl
                  bcs         gridscroll_s14    ;if the carry is set, a multicolor pixel is being shifted out
                                                ;(only       the left bit is set for the grid pixels)
                  asl                           ;no multicolor pixel, shift one more to the right
                  jmp         gridscroll_s15    
gridscroll_s14    asl                           ;shift one more bit to the left
                  ora         #$02              ;add multicolor pixel on the right
gridscroll_s15    sta         $60f0
                  sta         $60f1             ;also store in byte 1
                  lda         $60f2             ;shift byte 2 of the grid on bit to the left
                  asl
                  bcs         gridscroll_s16    
                  asl
                  jmp         gridscroll_s17    
gridscroll_s16    asl
                  ora         #$02              
gridscroll_s17    sta         $60f2
                  sta         $60f3             ;also store in byte 3
                  lda         $60f4             ;shift byte 4 of the grid on bit to the left
                  asl
                  bcs         gridscroll_s18    
                  asl
                  jmp         gridscroll_s19    
gridscroll_s18    asl
                  ora         #$02              
gridscroll_s19    sta         $60f4
                  sta         $60f5             ;also store in byte 5
                  lda         $60f6             ;shift byte 6 of the grid on bit to the left
                  asl
                  bcs         gridscroll_s20    
                  asl
                  jmp         gridscroll_s21    
gridscroll_s20    asl
                  ora         #$02              
gridscroll_s21    sta         $60f6
                  sta         $60f7             ;also store in byte 1
                                                ;copy the new grid character data to the characters to be used for the various animations
gridscroll_s22    lda         $60f0             ;bytes 0 & 1
                  sta         $67f8             ;standard grid char / monitor row 1
                  sta         $67f0             ;grid char monitor row 3
                  sta         $67e8             ;grid char monitor row 5
                  sta         $67e0             ;grid char monitor row 7
                  sta         $67f9             ;char $fc
                  sta         $67f1             ;char $fd
                  sta         $67e9             ;char $fe
                  sta         $67e1             ;char $ff
                  lda         $60f2             ;bytes 2 & 3
                  sta         $67fa             
                  sta         $67f2             
                  sta         $67ea             
                  sta         $67e2             
                  sta         $67fb             
                  sta         $67f3             
                  sta         $67eb             
                  sta         $67e3             
                  lda         $60f4             ;bytes 4 & 5
                  sta         $67fc             
                  sta         $67f4             
                  sta         $67ec             
                  sta         $67e4             
                  sta         $67fd             
                  sta         $67f5             
                  sta         $67ed             
                  sta         $67e5             
                  lda         $60f6             ;bytes 6 & 7
                  sta         $67fe             
                  sta         $67f6             
                  sta         $67ee             
                  sta         $67e6             
                  sta         $67ff             
                  sta         $67f7             
                  sta         $67ef             
                  sta         $67e7             

;============================================================================================================================================================
;TEXT SCROLLER - ADD NEW CHARACTER

TXTSCRLLC         lda         scrldly           ;check scroller delay
                  cmp         #02               ;if not $02 (i.e. freshly reset), skip ahead
                  beq         txtscrllc_s1      
                  jmp         ir27_e            
txtscrllc_s1      lda         scrlndx           ;check scroller index if 8 bit shifts have occured ((=$00),
                  beq         txtscrllc_s2      ;i.e. if a new char has to be added
                  jmp         ir27_e            
txtscrllc_s2      lda         #$08              ;reset scroll index
                  sta         scrlndx           
txtscrllc_s3      lda         _SCROLLTEXT       ;read character code from scroll text
                  cmp         #$ee              ;check if text terminator $ee has been reached
                  bne         txtscrllc_s4      
                                                ;[!!!SELF MODIFYING CODE!!!]
                  lda         #<_SCROLLTEXT-1   ;if the terminator has bee reached, restore the start address for scroller text
                  sta         txtscrllc_s3+1    ;(-1, because it will be increased right away)
                  lda         #>_SCROLLTEXT         
                  sta         txtscrllc_s3+2    
                  lda         #$20              ;load character code for blank (otherwise, charcter $ee would be displayed, which is not defined and therefore garbage)
                                                ;[!!!SELF MODIFYING CODE!!!]
txtscrllc_s4      inc         txtscrllc_s3+1    ;increase start address for reading scroller text by 1
                  bne         *+5               
                  inc         txtscrllc_s3+2    

                                                ;add new character to scroller
                  sta         $fb               ;store character code and mulitply with $08 for offset from start of scroller character memory
                  lda         #$00              
                  sta         $fc               
                  asl         $fb               
                  rol         $fc               
                  asl         $fb               
                  rol         $fc               
                  asl         $fb               
                  rol         $fc               
                  lda         $fc               
                  clc
                  adc         #$a0              ;add $a0 to hi byte to get actual address of scroller character memory address
                  sta         $fc               

                  ldy         #$00              
                  lda         ($fb),y           ;copy character data bytes and store in sprite data bytes
                  sta         scrspr+$19a       
                  iny
                  lda         ($fb),y           ;byte $01 of character
                  sta         scrspr+$19d       ;byte $05 of sprite
                  iny
                  lda         ($fb),y           ;byte $02 of character
                  sta         scrspr+$1a0       ;byte $08 of sprite
                  iny
                  lda         ($fb),y           ;byte $03 of character
                  sta         scrspr+$1a3       ;byte $0b of sprite
                  iny
                  lda         ($fb),y           ;byte $04 of character
                  sta         scrspr+$1a6       ;byte $0e of sprite
                  iny
                  lda         ($fb),y           ;byte $05 of character
                  sta         scrspr+$1a9       ;byte $11 of sprite
                  iny
                  lda         ($fb),y           ;byte $06 of character
                  sta         scrspr+$1ac       ;byte $14 of sprite
                  iny
                  lda         ($fb),y           ;byte $07 of character
                  sta         scrspr+$1af       ;byte $17 of sprite

;============================================================================================================================================================

ir27_e            lda         #$0f              ;set up next raster line trigger
                  sta         $d012             
                  lda         #$93              
                  sta         $d011             
                  lda         #<ir28            ;set next raster routine address
                  sta         $fffe             
                  lda         #>ir28            
                  sta         $ffff             
                  rti

;############################################################################################################################################################

                                                ;before the actual routine starts, 9-16 cycles pass (2-9 for finishing current command, 7 for saving
                                                ;return address and status register)
ir28              lda         #<ir28_1          ;(2 cycles) set address for 2nd interrupt to allow stable raster line
                  sta         $fffe             ;(4 cycles)
                  lda         #>ir28_1          ;(2 cycles)
                  sta         $ffff             ;(4 cycles)
                  lsr         $d019             ;(6 cycles) acknowledge interrupt
                  tsx                           ;(2 cycles) save stack in X because there is a second interrupt, but rti should return to where the call for ir28 came from
                  inc         $d012             ;(6 cycles) set raster trigger for next line
                  cli                           ;(2 cycles) enable interrupts (2 cycles) => 37-51 cycles up to here
                  nop                           ;(2 cycles) only NOPs from here so no matter if and how many sprites are displayed on the raster line, the call for ir28_1
                                                ;always happens during a NOP for stability
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;before the ir28_1 part starts, 16-17 cycles pass (1-2 for finishing NOP command, 7 for saving
                                                ;return address and status register, 8 for fetching data for sprites 3-6 (bus takeover happened on the previous line))

                                                ;RASTER LINE $110

ir28_1            lsr         $d019             ;(6 cycles) acknowledge interrupt
                  txs                           ;(2 cycles) restore stack from X
                  lda         #$0f              ;(2 cycles) load color code to end red scroller band
                                                ;=> 26-27 cycles have passed

                  ldy         #$05              ;(2 cycles)
                  dey                           ;(24 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               

                                                ;=> 52-53 cycles have passed
                  sta         $d020             ;(4 cycles) set border color for end of scroller band

                                                ;RASTER LINE $110
                                                ;=> 12-13 cycles have passed

                  sta         $d021             ;(4 cycles) set screen color for end of scroller band
                  ldx         #$10              ;(2 cycles) load pattern for border

                  ldy         #$07              ;(2 cycles)
                  dey                           ;(34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                                                ;=> 52-53 cycles have passed
                  stx         $7fff             ;(4 cycles) set pattern for border

                  lda         #$20              ;activate gfx char set 1
                  sta         $d018             

;============================================================================================================================================================
;TEXT SCROLLER  - DELAY AND SETTING INDEX

TXTSCRLLS         dec         scrldly           ;decrease scroll delay
                  bne         ERASEBUILDLOGO    ;if not $00, skip ahead
                  dec         scrlndx           ;decrease scroller index

;============================================================================================================================================================
;LOGO ERASE/BUILD LOGO ANIMATION

ERASEBUILDLOGO    lda         erlgdly2          ;check if delay before next build/erase has passed (n frames)
                  beq         ersbldlogo_s1     
                  dec         erlgdly2          ;decrease delay counter
                  jmp         sound_01          
ersbldlogo_s1     dec         erlgdly           ;check if animation delay has passed (n frames)
                  beq         ersbldlogo_s2     
                  jmp         sound_01          
ersbldlogo_s2     ldx         erlgfrmndx        ;load pointer to current animation frame
                  lda         #>ercdblo         ;hi byte of address for pixel fade/erase character data - FIXED MEMORY LOCATION: hi byte of ercdblo
                  sta         $a4               
                  lda         erlganitype       ;check which animation to use
                  beq         ersbldlogo_s3     

                  jmp         ersbldlogo_s6     

                                                ;erase logo animation
ersbldlogo_s3     lda         ernifrmloe,x      ;lo byte address for pixel erase character data for current animation frame
                  sta         $a3               
                  ldx         erlgslcndx        ;load pointer to current slice
                  lda         erlgslcstrt,x     ;load offset for start of slice data
                  tax
ersbldlogo_s4     lda         erlgchrlo,x       ;load lo & hi byte of slice character to process
                  cmp         #$ff              ;$ff in lo means all characters of the slice have been processed
                  bne         ersbldlogo_s5     
                  jmp         ersbldlogo_s9     
ersbldlogo_s5     sta         $a5
                  lda         erlgchrhi,x       
                  sta         $a6               
                  ldy         #$07              ;process 8 bytes of logo character
                  lda         ($a3),y           ;load fade character data
                  and         ($a5),y           ;AND with original character data to eliminate any bits not present in the fade character but in the character
                  sta         ($a5),y           ;store character data
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a5),y           
                  sta         ($a5),y           

                  inx                           ;increase X for next character in slice
                  jmp         ersbldlogo_s4     

                                                ;build logo animation - works mostly the same as the erase animation
ersbldlogo_s6     lda         ernifrmlob,x      ;lo byte address for pixel build character data for current animation frame
                  sta         $a3               
                  ldx         erlgslcndx        
                  lda         erlgslcstrt,x     
                  tax
ersbldlogo_s7     lda         erlgchrlo,x       ;while setting memory address for slice character, also set memory address for logo character backup data
                  cmp         #$ff              ;located at +$7000
                  bne         ersbldlogo_s8     
                  jmp         ersbldlogo_s9     
ersbldlogo_s8     sta         $a5
                  sta         $a7               
                  lda         erlgchrhi,x       
                  sta         $a6               
                  clc
                  adc         #$70              
                  sta         $a8               
                  ldy         #$07              ;process 8 bytes of logo character
                  lda         ($a3),y           ;load fade character data
                  and         ($a7),y           ;AND to restore bits that are set in both the fade character and the backup character data and erase any that are only in one or neither
                  sta         ($a5),y           ;store character data
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           
                  dey
                  lda         ($a3),y           
                  and         ($a7),y           
                  sta         ($a5),y           

                  inx
                  jmp         ersbldlogo_s7     

ersbldlogo_s9     dec         erlgfrmndx        ;decrease pointer for animation frame
                  bpl         ersbldlogo_s10    ;if < $00, whole slice has been processed
                  lda         #$09              ;restore animation frame pointer
                  sta         erlgfrmndx        
                  dec         erlgslcndx        ;decrease pointer for logo slice
                  bpl         ersbldlogo_s10    ;if < $00, all slices have been processed
                  lda         #$0e              ;restore logo slice pointer
                  sta         erlgslcndx        
                  lda         erlganitype       ;flip bit 0 of lganitype to switch between erase & build animation (works both ways)
                  eor         #$01              
                  sta         erlganitype       
                  lda         #$2a              ;set delay for start of next build/erase
                  sta         erlgdly2          
ersbldlogo_s10    lda         #$01              ;restore logo delay
                  sta         erlgdly           

                  jmp         sound_01          

;============================================================================================================================================================
;SOUND
                                                ;routine provided by SOUNDMASTER v3.1 (1989, SoedeSoft)
_SOUND            jmp         irm_sub01
sound_01          jsr         _SOUND

;============================================================================================================================================================
;HIDDEN FEATURE
                  lda         hfact
                  lsr
                  bcs         hf_01             
                  lda         #$0f              ;always set background color to $0f when hidden feature is not active
                  sta         bgcol             

                  jmp         ir28_e            
                  
hf_01             ldx         hfcolndx
                  lda         hfcol,x           
                  sta         bgcol             
                  dex
                  bpl         hf_02            
                  ldx         #$07              
hf_02             stx         hfcolndx

;============================================================================================================================================================

ir28_e            lda         strpt             ;check if part $11 of startup routines is set            
                  cmp         #$12              
                  beq         sound_02          ;if yes, start the actual demo
            
                  lda         #$00              ;set up next raster line trigger for startup
                  sta         $d012             
                  lda         #$1b              ;restore 25 line mode and clear bit 8 of raster line register
                  sta         $d011 
                  lda         #<strir_00        ;set next raster routine address for startup
                  sta         $fffe             
                  lda         #>strir_00        
                  sta         $ffff             
                  rti
                  
sound_02          lda         #$2c              ;set up next raster line trigger for actual demo
                  sta         $d012
                  lda         #$1b              ;restore 25 line mode and clear bit 8 of raster line register
                  sta         $d011
                  lda         #<ir00            ;set next raster routine address for actual demo
                  sta         $fffe
                  lda         #>ir00
                  sta         $ffff
                  rti

;============================================================================================================================================================
;SOUND ROUTINE CONTINUED

irm_sub01         inc         $037c
                  lda         $037c             
                  cmp         soundsrc+$4       
                  bne         irm_sub01_01      
                  lda         #$00              
                  sta         $037c             
irm_sub01_01      lda         soundsrc-$200
                  bne         irm_sub01_02      
                  ldx         #$00              
                  jsr         irm_sub07_06      
irm_sub01_02      lda         soundsrc-$1ff
                  bne         irm_sub01_03      
                  ldx         #$07              
                  jsr         irm_sub07_06      
irm_sub01_03      lda         soundsrc-$1fe
                  bne         irm_sub01_04      
                  ldx         #$0e              
                  jsr         irm_sub07_06      
irm_sub01_04      lda         $037c
                  bne         irm_sub01_05      
                  jsr         irm_sub13         
irm_sub01_05      lda         $0380
                  beq         irm_sub02         
                  bmi         irm_sub01_06      
                  dec         $0380             
irm_sub01_06      lda         $02bd
                  sta         $d416             
                  clc
                  adc         $0384             
                  sta         $02bd             
irm_sub01_07      rts

;============================================================================================================================================================
irm_sub02         lda         soundsrc+$8
                  and         #$01              
                  beq         irm_sub01_07      
                  lda         #$00              
                  sec
                  sbc         $0384             
                  sta         $0384             
                  lda         soundsrc+$c       
                  sta         $0380             
                  jmp         irm_sub01_06      
irm_sub02_00      jsr         irm_sub03
                  lda         $0337,x           
                  beq         irm_sub02_04      
                  ldy         $0339,x           
                  lda         soundsrc+$110,y   
                  and         $0363,x           
                  sta         $d404,x           
                  lda         soundsrc+$110,y   
                  and         #$08              
                  bne         irm_sub02_03      
                  lda         soundsrc+$10,y    
                  cmp         #$7f              
                  bne         irm_sub02_01      
                  ldy         soundsrc+$f       
                  bne         irm_sub02_02      
irm_sub02_01      clc
                  adc         $0335,x           
                  sta         $0335,x           
                  tay
irm_sub02_02      lda         soundsrc-$2c9,y
                  sta         $d401,x           
                  lda         soundsrc-$269,y   
                  sta         $d400,x           
                  jmp         irm_sub02_06      
irm_sub02_03      jsr         irm_sub02_06
irm_sub02_04      lda         $034e,x
                  bne         irm_sub02_05      
                  jmp         irm_sub07         
irm_sub02_05      jmp         irm_sub05
irm_sub02_06      inc         $0339,x
                  lda         $0339,x           
                  cmp         $0337,x           
                  bne         irm_sub02_07      
                  lda         $0338,x           
irm_sub02_07      sta         $0339,x
                  rts

;============================================================================================================================================================
irm_sub03         lda         $02a9,x
                  sta         $d402,x           
                  lda         $02aa,x           
                  sta         $d403,x           
                  lda         $0373,x           
                  bne         irm_sub04         
                  lda         $02a9,x           
                  clc
                  adc         $0334,x           
                  sta         $02a9,x           
                  lda         $02aa,x           
                  adc         #$00              
                  sta         $02aa,x           
                  cmp         soundsrc+$d       
                  bne         irm_sub03_01      
                  inc         $0373,x           
irm_sub03_01      rts

;============================================================================================================================================================
irm_sub04         lda         $02a9,x
                  sec
                  sbc         $0334,x           
                  sta         $02a9,x           
                  lda         $02aa,x           
                  sbc         #$00              
                  sta         $02aa,x           
                  cmp         soundsrc+$e       
                  bne         irm_sub04_01      
                  dec         $0373,x           
irm_sub04_01      rts

;============================================================================================================================================================
irm_sub05         lda         $034e,x
                  bne         irm_sub06         
                  rts

;============================================================================================================================================================
irm_sub06         cmp         #$02
                  beq         irm_sub06_03      
                  clc
                  lda         $035e,x           
                  adc         $02a7,x           
                  sta         $02a7,x           
                  lda         $034f,x           
                  adc         $02a8,x           
                  sta         $02a8,x           
                  lda         $02a8,x           
                  cmp         $034d,x           
                  beq         irm_sub06_01      
                  bcc         irm_sub06_06      
                  bcs         irm_sub06_02      
irm_sub06_01      lda         $02a7,x
                  cmp         $034c,x           
                  bcc         irm_sub06_06      
irm_sub06_02      lda         $034c,x
                  sta         $02a7,x           
                  lda         $034d,x           
                  sta         $02a8,x           
                  lda         #$00              
                  sta         $034e,x           
                  jmp         irm_sub06_06      
irm_sub06_03      sec
                  lda         $02a7,x           
                  sbc         $035e,x           
                  sta         $02a7,x           
                  lda         $02a8,x           
                  sbc         $034f,x           
                  sta         $02a8,x           
                  lda         $034d,x           
                  cmp         $02a8,x           
                  bcc         irm_sub06_06      
                  beq         irm_sub06_04      
                  bcs         irm_sub06_05      
irm_sub06_04      lda         $034c,x
                  cmp         $02a7,x           
                  bcc         irm_sub06_06      
irm_sub06_05      lda         $034c,x
                  sta         $02a7,x           
                  lda         $034d,x           
                  sta         $02a8,x           
                  lda         #$00              
                  sta         $034e,x           
                  jmp         irm_sub06_06      
irm_sub06_06      lda         $02a7,x
                  sta         $d400,x           
                  lda         $02a8,x           
                  sta         $d401,x           
                  rts

;============================================================================================================================================================
irm_sub07         lda         $033a,x
                  beq         irm_sub07_05      
                  lda         $034b,x           
                  beq         irm_sub07_01      
                  dec         $034b,x           
                  jmp         irm_sub07_05      
irm_sub07_01      inc         $0349,x
                  lda         $0349,x           
                  cmp         soundsrc+$6       
                  bne         irm_sub07_02      
                  lda         $034a,x           
                  eor         #$01              
                  sta         $034a,x           
                  lda         #$00              
                  sta         $0349,x           
irm_sub07_02      lda         $034a,x
                  bne         irm_sub07_03      
                  clc
                  lda         $02a7,x           
                  adc         $033a,x           
                  sta         $02a7,x           
                  lda         $02a8,x           
                  adc         #$00              
                  sta         $02a8,x           
                  jmp         irm_sub07_04      
irm_sub07_03      sec
                  lda         $02a7,x           
                  sbc         $033a,x           
                  sta         $02a7,x           
                  lda         $02a8,x           
                  sbc         #$00              
                  sta         $02a8,x           
irm_sub07_04      clc
                  lda         $033a,x           
                  adc         $0374,x           
                  cmp         $033a,x           
                  bcc         irm_sub07_05      
                  sta         $033a,x           
irm_sub07_05      jmp         irm_sub06_06
irm_sub07_06      stx         $037d
                  lda         $037c             
                  bne         irm_sub07_07      
                  jsr         irm_sub07_08      
irm_sub07_07      ldx         $037d
                  jmp         irm_sub02_00      
irm_sub07_08      lda         #$00
                  sta         $0375             
                  lda         $0360,x           
                  sta         $a6               
                  lda         $0361,x           
                  sta         $a7              
                  ldy         $0377             
                  lda         ($a6),y           
                  beq         irm_sub08_03      
                  bpl         irm_sub08         
                  cmp         #$ff              
                  beq         irm_sub07_09      
                  inc         $0375             
                  jmp         irm_sub08         
irm_sub07_09      rts

;============================================================================================================================================================
irm_sub08         iny
                  ldx         #$00              
                  lda         ($a6),y           
                  bpl         irm_sub08_01      
                  inx
irm_sub08_01      and         #$3f
                  pha
                  txa
                  ldx         $037d             
                  sta         $034e,x           
                  pla
                  clc
                  adc         $035f,x           
                  tay
                  lda         soundsrc-$160,y   
                  sta         $a5               
                  lda         soundsrc-$190,y   
                  sta         $0337,x           
                  lda         soundsrc-$1f0,y   
                  sta         $0339,x           
                  lda         soundsrc-$1c0,y   
                  sta         $0338,x           
                  ldy         $a5               
                  lda         $0375             
                  bne         irm_sub08_02      
                  cpx         soundsrc+$b       
                  bne         irm_sub08_02      
                  lda         soundsrc-$50,y    
                  sta         $02bd             
                  lda         soundsrc-$30,y    
                  sta         $0384             
                  lda         soundsrc+$c       
                  sta         $0380             
irm_sub08_02      ldy         $0377
                  iny
                  lda         ($a6),y           
                  and         #$40              
                  bne         irm_sub08_04      
                  dey
                  lda         ($a6),y           
                  and         #$7f              
                  clc
                  adc         $0364,x           
                  clc
                  adc         $0386             
irm_sub08_03      tax
                  jmp         irm_sub08_05      
irm_sub08_04      dey
                  lda         ($a6),y           
                  and         #$7f              
                  tax
irm_sub08_05      cpx         #$00
                  bne         irm_sub08_06      
                  jmp         irm_sub11         
irm_sub08_06      ldy         $037d
                  lda         soundsrc-$2c9,x   
                  sta         $0378             
                  lda         soundsrc-$269,x   
                  sta         $0379             
                  txa
                  sta         $0335,y           
                  ldx         $037d             
                  lda         $034e,y           
                  beq         irm_sub08_12      
                  lda         $0379             
                  sta         $034c,x           
                  lda         $0378             
                  sta         $034d,x           
                  lda         $02a8,x           
                  cmp         $034d,x           
                  bcc         irm_sub08_11      
                  beq         irm_sub08_09      
                  bcs         irm_sub08_10      
irm_sub08_09      lda         $02a7,x
                  cmp         $034c,x           
                  bcc         irm_sub08_11      
irm_sub08_10      lda         #$02
                  sta         $034e,x           
irm_sub08_11      jmp         irm_sub08_13
irm_sub08_12      lda         $0378
                  sta         $02a8,x           
                  sta         $d401,x           
                  lda         $0379             
                  sta         $02a7,x           
                  sta         $d400,x           
irm_sub08_13      ldy         $a5
                  lda         $0375             
                  beq         irm_sub08_14      
                  jmp         irm_sub09         
irm_sub08_14      lda         soundsrc-$130,y
                  sta         $d405,x           
                  lda         soundsrc-$110,y   
                  sta         $d406,x           
                  lda         #$00              
                  sta         $0373,x           
                  lda         soundsrc-$f0,y    
                  lsr
                  lsr
                  lsr
                  lsr
                  sta         $02aa,x           
                  lda         soundsrc-$f0,y    
                  asl
                  asl
                  asl
                  asl
                  sta         $02a9,x           
                  lda         soundsrc-$d0,y    
                  sta         $0334,x           
                  lda         soundsrc-$b0,y    
                  sta         $033a,x           
                  beq         irm_sub08_16      
                  bmi         irm_sub08_15      
                  lda         #$00              
                  sta         $0374,x           
                  beq         irm_sub08_16      
irm_sub08_15      and         #$7f
                  sta         $0374,x           
                  lda         soundsrc+$5       
                  sta         $033a,x           
irm_sub08_16      lda         #$00
                  sta         $034a,x           
                  lda         soundsrc+$7       
                  sta         $0349,x           
                  lda         soundsrc-$90,y    
                  lsr
                  lsr
                  lsr
                  sta         $034b,x           
                  lda         soundsrc-$90,y    
                  and         #$07              
                  sta         $034f,x           
                  lda         soundsrc-$70,y    
                  sta         $035e,x           
                  lda         $0337,x           
                  bne         irm_sub10         
                  lda         $0338,x           
                  sta         $0362,x           
                  sta         $d404,x           
                  lda         $0339,x           
                  sta         $d404,x           
                  sta         $02ab,x           
                  rts

;============================================================================================================================================================
irm_sub09         lda         #$00
                  sta         $034a,x           
                  lda         soundsrc+$7       
                  sta         $0349,x           
                  rts

;============================================================================================================================================================
irm_sub10         ldy         $0339,x
                  lda         #$f7              
                  sta         $0363,x           
                  lda         soundsrc+$110,y   
                  and         #$f6              
                  sta         $d404,x           
                  rts

;============================================================================================================================================================
irm_sub11         ldx         $037d
                  lda         $0337,x           
                  bne         irm_sub12         
                  lda         $0362,x           
                  cmp         $02ab,x           
                  beq         irm_sub11_01      
                  sta         $d404,x           
                  sta         $02ab,x           
irm_sub11_01      rts

;============================================================================================================================================================
irm_sub12         lda         #$f6
                  sta         $0363,x           
                  rts

;============================================================================================================================================================
irm_sub13         inc         $0377
                  inc         $0377             
                  lda         $0377             
                  cmp         soundsrc+$1       
                  bne         irm_sub13_3       
                  lda         #$00              
                  sta         $0377             
                  inc         $0376             
                  ldy         soundsrc+$3       
                  iny
                  cpy         $0376             
                  bne         irm_sub13_2       
                  inc         $0385             
                  ldy         soundsrc          
                  iny
                  cpy         $0385             
                  bne         irm_sub13_1       
                  ldy         soundsrc-$1       
                  sty         $0385             
irm_sub13_1       jsr         irm_sub14
irm_sub13_2       jsr         irm_sub15
irm_sub13_3       rts

;============================================================================================================================================================
irm_sub14         ldy         $0385
                  lda         soundsrc+$810,y   
                  sta         $0376             
                  sta         soundsrc+$2       
                  lda         soundsrc+$860,y   
                  sta         soundsrc+$3       
                  lda         soundsrc+$8b0,y   
                  sta         $0386             
                  lda         soundsrc+$900,y   
                  sta         $035f             
                  lda         soundsrc+$950,y   
                  sta         $0366             
                  lda         soundsrc+$9a0,y   
                  sta         $036d             
                  rts

;============================================================================================================================================================
irm_sub15         ldy         $0376
                  lda         soundsrc+$510,y   
                  sta         $0364             
                  lda         soundsrc+$210,y   
                  jsr         irm_sub16         
                  sty         $0361             
                  stx         $0360             
                  ldy         $0376             
                  lda         soundsrc+$610,y   
                  sta         $036b             
                  lda         soundsrc+$310,y   
                  jsr         irm_sub16         
                  sty         $0368             
                  stx         $0367             
                  ldy         $0376             
                  lda         soundsrc+$710,y   
                  sta         $0372             
                  lda         soundsrc+$410,y   
                  jsr         irm_sub16         
                  sty         $036f             
                  stx         $036e             
                  rts

;============================================================================================================================================================
irm_sub16         sta         $a6                
                  lda         soundsrc+$1       
                  sta         $a7               
                  ldx         #$08              
                  lda         #$00              
irm_sub16_01      lsr         $a7
                  bcc         irm_sub16_02      
                  clc
                  adc         $a6               
irm_sub16_02      ror
                  ror         $037e             
                  dex
                  bne         irm_sub16_01      
                  sta         $037f             
                  clc
                  lda         $037e             
                  adc         #$00              
                  sta         $037e             
                  lda         $037f             
                  adc         #$92              ;(original: #$72) - add $0d to the hi byte of the start adress of the sound data (see below)
                  tay
                  ldx         $037e             
                  rts

;############################################################################################################################################################
;VARIABLES FOR STARTUP ($20)

*=$c4f0

;startup part

strpt             = $c4f0                       ;determines the part of start up currently running:
                                                ;$00 = bring in vertical lines in upper border
                                                ;$01 = set vertical lines in screen memory
                                                ;$02 = bring in vertical lines in lower border
                                                ;$03 = bring in horizontal lines
                                                ;$04 = punch left top arc hole
                                                ;$05 = punch right bottom arc hole
                                                ;$06 = punch left bottom arc hole
                                                ;$07 = punch right top arc hole
                                                ;$08 = punch left center arc hole
                                                ;$09 = punch logo hole phase 1
                                                ;$0a = punch logo hole phase 2
                                                ;$0b = punch logo hole phase 3
                                                ;$0c = punch logo hole phase 4
                                                ;$0d = punch logo hole phase 5
                                                ;$0e = punch logo hole phase 6
                                                ;$0f = create monitor area
                                                ;$10 = color logo area
                                                ;$11 = wait a bit and then switch to actual demo
                  byte        $00

ptdly             = $c4f1                       ;delay within part (initially used in part $04)
                  byte        $f8

bptdly            = $c4f2                       ;delay before part
                  byte        $c0

;create vertical lines

vlbrdrl           = $c4f3                       ;raster line where the pattern in the border is removed
                  byte        $01

vlchr             = $c4f4                       ;code for character for brigning in vertical lines ($32-$35)
                  byte        $32

;create horizontal lines

hlcnt             = $c4f5                       ;counter for how many horizontal lines have been drawn
                  byte        $00

hllmt             = $c4f6                       ;number of horizontal lines that must be drawn
                  byte        $00

hldly             = $c4f7                       ;delay (in frames) before drawing one more horizontal line
                  byte        $04

;############################################################################################################################################################
;START UP ROUTINES - prepare the screen for the demo proper

_CODE_C500

*=$c500

;############################################################################################################################################################

strir_00          lda         #$10              ;set vertical line bit pattern for border
                  sta         $7fff
                  lsr         $d019
                  ldx         strpt             ;load current part of startup routine
                  
;============================================================================================================================================================
;delays before part actually starts

                                                ;delay part $00
                  bne         strir_00_d1       ;if current part <> $00, skip ahead       
                  lda         bptdly            ;check delay before part $00
                  beq         strir_00_00       ;if $00, start/continue part
                  dec         bptdly            ;decrease delay before part $00
                  
                  lda         #$00              ;erase vertical line bit pattern for border
                  sta         $7fff  
            
strir_00_d0       lda         #$f8              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<strir_04        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_04        
                  sta         $ffff             
                  rti

                                                ;delay part $03
strir_00_d1       cpx         #$03
                  bcc         strir_00_01       ;if current part < $03, skip ahead
                  beq         strir_00_d2       
                  jmp         strir_00_05_1     ;if current part > $03, skip ahead

strir_00_d2       lda         bptdly            ;check delay before part $03
                  beq         strir_00_05_1     ;if $00, start/continue part
                  dec         bptdly            ;decrease delay before part $00
                  jmp         strir_00_d0
                  
;============================================================================================================================================================
;set up raster interrupt for erasing upper border pattern

strir_00_00       lda         vlbrdrl           ;set up raster line where vertical line bit pattern is erased
                  sta         $d012             
                  lda         #<strir_03        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_03        
                  sta         $ffff             
                  rti

;============================================================================================================================================================
;SET VERTICAL LINES IN CHARACTER MEMORY
                                                ;in each row of the screen memory, 4 characters (char set 1, $32-35)  are used to bring in the vertical lines
                                                ;uses zeropage $fb/fc for screen memory address

strir_00_01       cpx         #$01              ;check current part of startup routine
                  bne         strir_00_05       ;if <> $01, skip ahead

                  ldy         #$27              ;set counter for writing one row of screen memory
                  lda         vlchr             ;get character code for bringing in the vertical in the row
strir_00_02       sta         ($fb),y           ;write characters to screen memory
                  dey
                  bpl         strir_00_02       
                  cmp         #$35              ;check if the last used character code was $35 - if yes, the display of the vertical lines for the
                                                ;current row of screen memory is finished
                  bne         strir_00_04       ;if <> $35, skip ahead

                  lda         #$32              ;set first character code for bringing in the vertical in the row
                  sta         vlchr             
                  lda         $fb               ;set the screen memory address to the start of the next row (+$28)
                  clc
                  adc         #$28              
                  sta         $fb               
                  bcc         strir_00_03       
                  inc         $fc               
strir_00_03       lda         $fc               ;check if hi byte of new screen memory is $4b
                  cmp         #$4b              
                  bne         strir_00_e        ;if not, skip ahead
                  lda         $fb               ;check if lo byte of new screen memory is $e8
                  cmp         #$e8              ;if yes, bringing in the vertical lines to the screen memory is finished
                  bne         strir_00_e        ;if not, skip ahead

                  lda         #$00              ;reset screen memory address for start up part $03 (fill screen memory with standard grid charcter)
                  sta         $fb               
                  lda         #$48              
                  sta         $fc               
                  inc         strpt             ;activate part $02 of startup routine

                  bne         strir_00_e        ;branch is always taken

strir_00_04       inc         vlchr             ;set next character code for bringing in the vertical in the row

                  bne         strir_00_e        ;branch is always taken

;============================================================================================================================================================
;set raster trigger for first horizontal line

strir_00_05       cpx         #$02              ;check current part of startup routine
                  beq         strir_00_e        ;if = $02, skip ahead
strir_00_05_1     lda         #$2d              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<strir_01        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_01        
                  sta         $ffff             
                  rti

;============================================================================================================================================================

strir_00_e        lda         #$f8              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<strir_04        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_04        
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;DRAW HORIZONTAL LINES #01

                                                ;first horizontal line is in (opened) upper border
                                                ;raster line $2d: 16-17 cycles have passed
strir_01          lsr         $d019             ;(6 cycles) acknowledge raster interrupt
                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles)
                  inc         $d020             ;(6 cycles) set border color to black

                                                ;raster line $2e: 0-1 cycle has passed
                  inc         $d021             ;(6 cycles) set screen color to black
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  dec         $d020             ;(6 cycles) set border color to light grey
                  dec         $d021             ;(6 cycles) set screen color to light grey



;============================================================================================================================================================

strir_01_e        lda         #$35              ;set up next raster line trigger
                  sta         $d012             
                  ldx         strpt             ;check current part of startup routine
                  cpx         #$03              
                  bne         strir_01_e1       ;if <> $03, skip ahead
                  lda         #<strir_02        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_02        
                  sta         $ffff             
                  rti

strir_01_e1       lda         #<strir_02a       ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_02a       
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;DRAW HORIZONTAL LINES #02 - ONE BY ONE

                                                ;draw horizontal lines in screen memory area
                                                ;on each iteration (after the delay has passed, see below), one more horizontal line is drawn
                                                ;until all 25 are drawn
                                                ;raster line $35+hlcnt*8: 16-17 cycles have passed
strir_02          lda         hllmt             ;(4 cycles) load number of horizontal lines that must be drawn
                  beq         strir_02_02       ;(3 cycles - branch taken) hlcnt = $00, no line to be drawn in this iteration
                                                ;(2 cycles - branch not taken)
                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles)
                  inc         $d020             ;(6 cycles) set border color to black

                                                ;raster line $36+hlcnt*8: 0-1 cycle has passed
                  inc         $d021             ;(6 cycles) set screen color to black
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  dec         $d020             ;(6 cycles) set border color to light grey
                  dec         $d021             ;(6 cycles) set screen color to light grey

                                                ;raster line $37+hlcnt*8: 7-8 cycles have passed
                                                ;wait until raster line comes where next horizontal line has to be drawn
strir_02_1        inc         hlcnt             ;(6 cycles) increase number of lines that have been drawn by 1
                  lda         hlcnt             ;(4 cycles) load number of lines that have been drawn
                  cmp         hllmt             ;(4 cycles) check if limit of horizontal lines to draw on this frame has been reached
                  beq         strir_02_02       ;(3 cycles - branch taken) limit reached, skip ahead
                                                ;(2 cycles - branch not taken)
                  ldy         #$3f              ;(2 cycles) load value for delay loop
                  dey                           ;(314 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles) wait n cycles

                  jmp         strir_02          ;(3 cycles) continue drawing horizontal lines
                                                ;346 cycles have passed, raster position reached to draw next horizontal line

strir_02_02       lda         #$00              ;reset counter for how many horizontal lines have been drawn
                  sta         hlcnt             
                  dec         hldly             ;decrease delay
                  bpl         strir_02_04       ;if delay >= $00, skip ahead
                  lda         #$04              ;reset delay
                  sta         hldly             
                  lda         hllmt             ;check the number of horizontal lines that must be drawn
                  cmp         #$19              ;if it $19, all horizonal lines are being drawn
                  beq         strir_02_03       
                  inc         hllmt             ;increase number of horizontal lines that must be drawn

                  jmp         strir_02_04       ;skip ahead

strir_02_03       lda         strpt             ;if all horizontal lines are being drawn
                  cmp         #$03              ;and part 03 of startup routine is still active...
                  bne         strir_02_04       
                  inc         strpt             ;...activate part $04 of startup routine

strir_02_04       lsr         $d019             ;acknowledge raster interrupt

;============================================================================================================================================================

strir_02_e        lda         #$f8              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<strir_04        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_04        
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;DRAW HORIZONTAL LINES #02 - ALL

                                                ;draw all 25 horizontal lines in screen memory area, but only in the border
                                                ;raster line $35+hlcnt*8: 16-17 cycles have passed
strir_02a         lda         hllmt             ;(4 cycles) load number of horizontal lines that must be drawn
                  beq         strir_02a_02      ;(3 cycles - branch taken) hlcnt = $00, no line to be drawn in this iteration
                                                ;(2 cycles - branch not taken)
                  ldy         #$08              ;(2 cycles) load value for delay loop
                  dey                           ;(39 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles)
                  inc         $d020             ;(6 cycles) set border color to black

                                                ;raster line $36+hlcnt*8: 0-1 cycle has passed
                  nop                           ;(2 cycles) wait n cycles - replaces the inc $d021 from the strir_02 routine
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)
                  ldy         #$0a              ;(2 cycles) load value for delay loop
                  dey                           ;(49 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  dec         $d020             ;(6 cycles) set border color to light grey
                  nop                           ;(2 cycles) wait n cycles - replaces the dec $d021 from the strir_02 routine
                  nop                           ;(2 cycles)
                  nop                           ;(2 cycles)

                                                ;raster line $37+hlcnt*8: 7-8 cycles have passed
                                                ;wait until raster line comes where next horizontal line has to be drawn
strir_02_1a       inc         hlcnt             ;(6 cycles) increase number of lines that have been drawn by 1
                  lda         hlcnt             ;(4 cycles) load number of lines that have been drawn
                  cmp         hllmt             ;(4 cycles) check if limit of horizontal lines to draw on this frame has been reached
                  beq         strir_02a_02      ;(3 cycles - branch taken) limit reached, skip ahead
                                                ;(2 cycles - branch not taken)
                  ldy         #$3f              ;(2 cycles) load value for delay loop
                  dey                           ;(314 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  nop                           ;(2 cycles) wait n cycles

                  jmp         strir_02a         ;(3 cycles) continue drawing horizontal lines
                                                ;346 cycles have passed, raster position reached to draw next horizontal line

strir_02a_02      lda         #$00              ;reset counter for how many horizontal lines have been drawn
                  sta         hlcnt             
                  lsr         $d019             ;acknowledge raster interrupt
                  jmp         strir_02_e        ;next raster routine is the same as for strir_02

;############################################################################################################################################################
;DELETE VERTICAL PATTERN IN UPPER BORDER

strir_03          lsr         $d019             ;acknowledge raster interrupt
                  ldy         #$07              ;wait n cycles until raster line is in left side border
                  dey                           ;(34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;delete vertical line pattern for border
                  sta         $7fff             

                  lda         vlbrdrl           ;load current raster line for erasing upper border pattern
                  cmp         #$33              ;if = $33, display of vertical lines in upper border is complete
                  bcc         strir_03_01       ;otherwise, skip ahead
                  inc         strpt             ;activate part $01 of startup routine
                  lda         #$fc              ;set up raster line for part $02 (bring in vertical lines in lower border)
                  sta         vlbrdrl
                  lda         #$38              ;set delay before part $03            
                  sta         bptdly

                  jmp         strir_03_e        

strir_03_01       clc                           ;set new raster line for deleting vertical line pattern (+$02)
                  adc         #$02              
                  sta         vlbrdrl           


;============================================================================================================================================================

strir_03_e        lda         #$f8              ;set up next raster line trigger
                  sta         $d012             
                  lda         #<strir_04        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_04        
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;OPEN BORDER

strir_04          lsr         $d019             ;acknowledge raster interrupt
                  lda         #$13              ;switch to 24 line mode to open border
                  sta         $d011             
                  ldx         strpt             ;check current part of startup routine
                  beq         strir_04_1_3      ;if = $00, skip ahead

                  cpx         #$01              
                  bne         strir_04_1_1      ;if <> $01, skip ahead
                  lda         #$00              ;set empty pattern for border
                  sta         $7fff             

                  jmp         sound_01          ;jump to sound routine        

strir_04_1_1      cpx         #$02
                  bne         strir_04_1_2      

                  jmp         strir_04_e1       ;if = $02, skip to set interrupt for deleting vertical line pattern for border in specific line

strir_04_1_2      cpx         #$03
                  beq         strir_04_2        ;if = $03, skip to filling screen memory rows with $00 grid character
                  bcc         strir_04_1_3      ;if < $03, skip ahead

                  jmp         strir_04_10       ;if < $11 (i.e. between $04 & $10), skip ahead to selecting next part

strir_04_1_3      jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
;FILL SCREEN MEMORY ROWS WITH $00 GRID CHARACTER

strir_04_2        lda         hllmt             ;check the number of horizontal lines that must be drawn
                  beq         strir_04_4        ;if it is zero, nothing needs to be done the first horizontal line is in the upper border, not the screen memory area
                  lda         hldly             ;check if the delay is $04, i.e. has been freshly reset
                  cmp         #$04              
                  bne         strir_04_4        ;if not, skip ahead
                  ldy         #$27              ;set up loop
                  lda         #$00              
strir_04_3        sta         ($fb),y           ;draw standard grid character $00 in the entire row starting with the screen memory address in $fb/$fc
                  dey
                  bpl         strir_04_3        
                  lda         $fb               ;set the screen memory address to the start of the next row (+$28)
                  clc
                  adc         #$28              
                  sta         $fb               
                  bcc         strir_04_4        
                  inc         $fc               

strir_04_4        jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
;SELECT NEXT PART

strir_04_10       dec         ptdly             ;decrease delay
                  beq         strir_04_10_0     ;if = $00 go to part selection

                  jmp         strir_05_e        ;jump to set up for next raster line trigger

strir_04_10_0     ldx         strpt             ;check current part of startup routine and branch accordingly
                  cpx         #$04              
                  beq         strir_04_11       ;branch to punch left top arc hole

                  cpx         #$05              
                  bne         strir_04_10_0a    

                  jmp         strir_04_12       ;jump to punch right bottom arc hole

strir_04_10_0a    cpx         #$06
                  bne         strir_04_10_0b    

                  jmp         strir_04_13       ;jump to punch left bottom arc hole

strir_04_10_0b    cpx         #$07
                  bne         strir_04_10_1     

                  jmp         strir_04_14       ;jump to punch right top arc hole

strir_04_10_1     cpx         #$08
                  bne         strir_04_10_2     

                  jmp         strir_04_15       ;jump to punch left center arc hole

strir_04_10_2     cpx         #$09              
                  bne         strir_04_10_3     

                  jmp         strir_04_16       ;jump to punch logo hole phase 1

strir_04_10_3     cpx         #$0a
                  bne         strir_04_10_4     

                  jmp         strir_04_17       ;jump to punch logo hole phase 2

strir_04_10_4     cpx         #$0b
                  bne         strir_04_10_5     

                  jmp         strir_04_18       ;jump to punch logo hole phase 3

strir_04_10_5     cpx         #$0c
                  bne         strir_04_10_6     

                  jmp         strir_04_19       ;jump to punch logo hole phase 4

strir_04_10_6     cpx         #$0d
                  bne         strir_04_10_7     

                  jmp         strir_04_20       ;jump to punch logo hole phase 5

strir_04_10_7     cpx         #$0e
                  bne         strir_04_10_8     

                  jmp         strir_04_21       ;jump to punch logo hole phase 6

strir_04_10_8     cpx         #$0f
                  bne         strir_04_10_9    

                  jmp         strir_04_22       ;jump to create monitor area

strir_04_10_9     cpx         #$10
                  bne         strir_04_10_10    

                  jmp         strir_04_23       ;jump to color logo area

strir_04_10_10    jmp         strir_04_24       ;jump to adjust sound 

;============================================================================================================================================================
;PUNCH ELECTRIC ARC HOLES
                                                ;left top arc hole
strir_04_11       lda         #$48
                  sta         $482e             
                  lda         #$49              
                  sta         $482f             
                  lda         #$4a              
                  sta         $4830             
                  lda         #$4b              
                  sta         $4856             
                  lda         #$4c              
                  sta         $4857             
                  lda         #$4d              
                  sta         $4858 
            
                  inc         strpt             ;activate next part of startup routine

                  lda         #$60              ;set delay before next electric arc hole punch
                  sta         ptdly  

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;right bottom arc hole
strir_04_12       lda         #$55
                  sta         $4961             
                  sta         $4962             
                  lda         #$56              
                  sta         $4988             
                  lda         #$57              
                  sta         $4989             
                  lda         #$58              
                  sta         $498a             
                  lda         #$59              
                  sta         $49b0             
                  lda         #$31              
                  sta         $49b1             
                  lda         #$5a              
                  sta         $49b2             
                  lda         #$5b              
                  sta         $49d9             
                  lda         #$5c              
                  sta         $49da 
            
                  inc         strpt             ;activate next part of startup routine
                  
                  lda         #$48              ;set delay before next electric arc hole punch
                  sta         ptdly 

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;left bottom arc hole
strir_04_13       lda         #$41
                  sta         $496f             
                  lda         #$42              
                  sta         $4970             
                  lda         #$43              
                  sta         $4971             
                  lda         #$44              
                  sta         $4997             
                  lda         #$45              
                  sta         $4998             
                  lda         #$46              
                  sta         $4999             
                  lda         #$47              
                  sta         $49c0             
                  lda         #$2d              
                  sta         $49c1  
           
                  inc         strpt             ;activate next part of startup routine
                  
                  lda         #$48              ;set delay before next electric arc hole punch
                  sta         ptdly 

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;right top arc hole
strir_04_14       lda         #$4e
                  sta         $4872             
                  lda         #$4f              
                  sta         $4873             
                  lda         #$50              
                  sta         $4874             
                  lda         #$51              
                  sta         $4875             
                  lda         #$52              
                  sta         $489b             
                  lda         #$53              
                  sta         $489c             
                  lda         #$54              
                  sta         $489d             
                  lda         #$2d              
                  sta         $48c3  
           
                  inc         strpt             ;activate next part of startup routine

                  lda         #$30              ;set delay before next electric arc hole punch
                  sta         ptdly 

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;left center arc hole
strir_04_15       lda         #$3a
                  sta         $48cb             
                  lda         #$3b              
                  sta         $48cc             
                  lda         #$3c              
                  sta         $48f3             
                  lda         #$3d              
                  sta         $48f4             
                  lda         #$3e              
                  sta         $491a             
                  lda         #$3f              
                  sta         $491b             
                  lda         #$40              
                  sta         $491c   
         
                  inc         strpt             ;activate next part of startup routine

                  lda         #$18              ;set delay before logo hole punch
                  sta         ptdly 

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
;PUNCH LOGO HOLE & COLOR LOGO AREA
                                                ;logo hole phase 1
strir_04_16       ldx         #$e1              
                  stx         $480D             
                  ldx         #$26              
                  stx         $49C4             
                  ldx         #$25              
                  stx         $49D4             
                  ldx         #$2c              
                  stx         $49ED             
                  ldx         #$2d              
                  stx         $49FB             
                  ldx         #$2f              
                  stx         $49FC  
           
                  inc         strpt             ;activate next part of startup routine

                  lda         #$02              ;set delay for between punching logo holes phases
                  sta         ptdly             

                  jmp         sound_01          ;jump to sound routine   
                  
;============================================================================================================================================================
                                                ;logo hole phase 2
strir_04_17       ldx         #$e8              
                  stx         $4813             
                  ldx         #$e4              
                  stx         $4819             
                  ldx         #$31              
                  stx         $4836             
                  ldx         #$31              
                  stx         $483C             
                  ldx         #$5e              
                  stx         $4842             
                  ldx         #$0d              
                  stx         $485D             
                  ldx         #$10              
                  stx         $486B             
                  ldx         #$12              
                  stx         $4884             
                  ldx         #$1f              
                  stx         $4984             
                  ldx         #$c4              
                  stx         $499D             
                  ldx         #$d1              
                  stx         $49AB             
                  ldx         #$31              
                  stx         $49C6             
                  ldx         #$d3              
                  stx         $49CC             
                  ldx         #$d5              
                  stx         $49D2             
                  ldx         #$2e              
                  stx         $49F5             
                  ldx         #$e2              
                  stx         $480E             
                  ldx         #$09              
                  stx         $4814             
                  ldx         #$e2              
                  stx         $481A             
                  ldx         #$e5              
                  stx         $4835             
                  ldx         #$0b              
                  stx         $4843             
                  ldx         #$0c              
                  stx         $485C             
                  ldx         #$11              
                  stx         $486C             
                  ldx         #$30              
                  stx         $4883             
                  ldx         #$23              
                  stx         $499C             
                  ldx         #$25              
                  stx         $49AC             
                  ldx         #$d2              
                  stx         $49C5             
                  ldx         #$d6              
                  stx         $49D3             
                  ldx         #$2d              
                  stx         $49F1             
                  ldx         #$2d              
                  stx         $49F4   
          
                  inc         strpt             ;activate next part of startup routine

                  lda         #$02              ;set delay for between punching logo holes phases
                  sta         ptdly   

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================

                                                ;logo hole phase 3
strir_04_18       ldx         #$e2              
                  stx         $4811             
                  ldx         #$e7              
                  stx         $4838             
                  ldx         #$5d              
                  stx         $483A             
                  ldx         #$31              
                  stx         $4840             
                  ldx         #$60              
                  stx         $485F             
                  ldx         #$64              
                  stx         $4863             
                  ldx         #$0e              
                  stx         $4865             
                  ldx         #$67              
                  stx         $4869             
                  ldx         #$6a              
                  stx         $4886             
                  ldx         #$70              
                  stx         $488C             
                  ldx         #$74              
                  stx         $4892             
                  ldx         #$76              
                  stx         $48AD             
                  ldx         #$82              
                  stx         $48BB             
                  ldx         #$19              
                  stx         $48D4             
                  ldx         #$1b              
                  stx         $48E4             
                  ldx         #$1e              
                  stx         $4924             
                  ldx         #$1f              
                  stx         $4934             
                  ldx         #$aa              
                  stx         $494D             
                  ldx         #$b6              
                  stx         $495B             
                  ldx         #$b7              
                  stx         $4976             
                  ldx         #$bc              
                  stx         $497C             
                  ldx         #$c2              
                  stx         $4982             
                  ldx         #$c6              
                  stx         $499F             
                  ldx         #$c9              
                  stx         $49A3             
                  ldx         #$cb              
                  stx         $49A5             
                  ldx         #$cf              
                  stx         $49A9             
                  ldx         #$31              
                  stx         $49C8             
                  ldx         #$28              
                  stx         $49CA             
                  ldx         #$2a              
                  stx         $49CE             
                  ldx         #$31              
                  stx         $49D0             
                  ldx         #$e3              
                  stx         $4812             
                  ldx         #$e3              
                  stx         $4818             
                  ldx         #$e6              
                  stx         $4837             
                  ldx         #$31              
                  stx         $483B             
                  ldx         #$31              
                  stx         $4841             
                  ldx         #$5f              
                  stx         $485E             
                  ldx         #$65              
                  stx         $4864             
                  ldx         #$68              
                  stx         $486A             
                  ldx         #$69              
                  stx         $4885             
                  ldx         #$75              
                  stx         $4893             
                  ldx         #$15              
                  stx         $48AC             
                  ldx         #$18              
                  stx         $48BC             
                  ldx         #$20              
                  stx         $494C             
                  ldx         #$21              
                  stx         $495C             
                  ldx         #$22              
                  stx         $4975             
                  ldx         #$c3              
                  stx         $4983             
                  ldx         #$c5              
                  stx         $499E             
                  ldx         #$ca              
                  stx         $49A4             
                  ldx         #$d0              
                  stx         $49AA             
                  ldx         #$27              
                  stx         $49C7             
                  ldx         #$29              
                  stx         $49CB             
                  ldx         #$d4              
                  stx         $49CD             
                  ldx         #$31              
                  stx         $49D1  
           
                  inc         strpt             ;activate next part of startup routine

                  lda         #$02              ;set delay for between punching logo holes phases
                  sta         ptdly             
                  
                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;logo hole phase 4
strir_04_19       ldx         #$62              
                  stx         $4861             
                  ldx         #$0f              
                  stx         $4867             
                  ldx         #$6c              
                  stx         $4888             
                  ldx         #$6e              
                  stx         $488A             
                  ldx         #$14              
                  stx         $488E             
                  ldx         #$72              
                  stx         $4890             
                  ldx         #$78              
                  stx         $48AF             
                  ldx         #$7c              
                  stx         $48B3             
                  ldx         #$16              
                  stx         $48B5             
                  ldx         #$80              
                  stx         $48B9             
                  ldx         #$84              
                  stx         $48D6             
                  ldx         #$31              
                  stx         $48DC             
                  ldx         #$8d              
                  stx         $48E2             
                  ldx         #$8f              
                  stx         $48FD             
                  ldx         #$9d              
                  stx         $490B             
                  ldx         #$9f              
                  stx         $4926             
                  ldx         #$a4              
                  stx         $492C             
                  ldx         #$31              
                  stx         $4932             
                  ldx         #$ac              
                  stx         $494F             
                  ldx         #$31              
                  stx         $4953             
                  ldx         #$b1              
                  stx         $4955             
                  ldx         #$b5              
                  stx         $4959             
                  ldx         #$31              
                  stx         $4978             
                  ldx         #$ba              
                  stx         $497A             
                  ldx         #$be              
                  stx         $497E             
                  ldx         #$c0              
                  stx         $4980             
                  ldx         #$c8              
                  stx         $49A1             
                  ldx         #$cd              
                  stx         $49A7             
                  ldx         #$31              
                  stx         $4839             
                  ldx         #$0a              
                  stx         $483F             
                  ldx         #$61              
                  stx         $4860             
                  ldx         #$63              
                  stx         $4862             
                  ldx         #$66              
                  stx         $4868             
                  ldx         #$6b              
                  stx         $4887             
                  ldx         #$6f              
                  stx         $488B             
                  ldx         #$13              
                  stx         $488D             
                  ldx         #$73              
                  stx         $4891             
                  ldx         #$77              
                  stx         $48AE             
                  ldx         #$7d              
                  stx         $48B4             
                  ldx         #$81              
                  stx         $48BA             
                  ldx         #$83              
                  stx         $48D5             
                  ldx         #$8e              
                  stx         $48E3             
                  ldx         #$1c              
                  stx         $48FC             
                  ldx         #$1d              
                  stx         $490C             
                  ldx         #$9e              
                  stx         $4925             
                  ldx         #$a9              
                  stx         $4933             
                  ldx         #$ab              
                  stx         $494E             
                  ldx         #$b0              
                  stx         $4954             
                  ldx         #$31              
                  stx         $495A             
                  ldx         #$b8              
                  stx         $4977             
                  ldx         #$bb              
                  stx         $497B             
                  ldx         #$bd              
                  stx         $497D             
                  ldx         #$c1              
                  stx         $4981             
                  ldx         #$c7              
                  stx         $49A0             
                  ldx         #$24              
                  stx         $49A2             
                  ldx         #$cc              
                  stx         $49A6             
                  ldx         #$ce              
                  stx         $49A8             
                  ldx         #$31              
                  stx         $49C9             
                  ldx         #$2b              
                  stx         $49CF  
           
                  inc         strpt             ;activate next part of startup routine

                  lda         #$02              ;set delay for between punching logo holes phases
                  sta         ptdly             
                  
                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;logo hole phase 5
strir_04_20       ldx         #$7a              
                  stx         $48B1             
                  ldx         #$7e              
                  stx         $48B7             
                  ldx         #$86              
                  stx         $48D8             
                  ldx         #$88              
                  stx         $48DA             
                  ldx         #$1a              
                  stx         $48DE             
                  ldx         #$8b              
                  stx         $48E0             
                  ldx         #$91              
                  stx         $48FF             
                  ldx         #$95              
                  stx         $4903             
                  ldx         #$97              
                  stx         $4905             
                  ldx         #$9b              
                  stx         $4909             
                  ldx         #$a0              
                  stx         $4928             
                  ldx         #$a2              
                  stx         $492A             
                  ldx         #$31              
                  stx         $492E             
                  ldx         #$a7              
                  stx         $4930             
                  ldx         #$ae              
                  stx         $4951             
                  ldx         #$b3              
                  stx         $4957             
                  ldx         #$6d              
                  stx         $4889             
                  ldx         #$71              
                  stx         $488F             
                  ldx         #$79              
                  stx         $48B0             
                  ldx         #$7b              
                  stx         $48B2             
                  ldx         #$17              
                  stx         $48B6             
                  ldx         #$7f              
                  stx         $48B8             
                  ldx         #$85              
                  stx         $48D7             
                  ldx         #$89              
                  stx         $48DB             
                  ldx         #$31              
                  stx         $48DD             
                  ldx         #$8c              
                  stx         $48E1             
                  ldx         #$90              
                  stx         $48FE             
                  ldx         #$96              
                  stx         $4904             
                  ldx         #$9c              
                  stx         $490A             
                  ldx         #$31              
                  stx         $4927             
                  ldx         #$a3              
                  stx         $492B             
                  ldx         #$a5              
                  stx         $492D             
                  ldx         #$a8              
                  stx         $4931             
                  ldx         #$ad              
                  stx         $4950             
                  ldx         #$af              
                  stx         $4952             
                  ldx         #$b2              
                  stx         $4956             
                  ldx         #$b4              
                  stx         $4958             
                  ldx         #$b9              
                  stx         $4979             
                  ldx         #$bf              
                  stx         $497F 
            
                  inc         strpt             ;activate next part of startup routine

                  lda         #$02              ;set delay for between punching logo holes phases
                  sta         ptdly             
                  
                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
                                                ;logo hole phase 6
strir_04_21       ldx         #$93              
                  stx         $4901             
                  ldx         #$99              
                  stx         $4907             
                  ldx         #$87              
                  stx         $48D9             
                  ldx         #$8a              
                  stx         $48DF             
                  ldx         #$92              
                  stx         $4900             
                  ldx         #$94              
                  stx         $4902             
                  ldx         #$98              
                  stx         $4906             
                  ldx         #$9a              
                  stx         $4908             
                  ldx         #$a1              
                  stx         $4929             
                  ldx         #$a6              
                  stx         $492F   
          
                  inc         strpt             ;activate next part of startup routine

                  lda         #$ff              ;set delay before creating monitor area
                  sta         ptdly  

                  jmp         sound_01          ;jump to sound routine   
                  
;============================================================================================================================================================
;CREATE MONITOR AREA

strir_04_22       lda         #$19              ;restore delay
                  sta         ptdly             
                  ldy         #$12              ;set index for creating monitor rows
strir_04_22_1     lda         #$02              ;load character code for upper monitor border
                  sta         $4a63,y           
                  lda         #$f1              ;load character code for monitor display area
                  sta         $4a8b,y           
                  sta         $4ab3,y           
                  sta         $4adb,y           
                  sta         $4b03,y           
                  sta         $4b2b,y           
                  sta         $4b53,y           
                  sta         $4b7b,y           
                  lda         #$07              ;load character code for lower monitor border
                  sta         $4ba3,y           
                  lda         #$08              ;load color code for monitor display area
                  sta         $da8b,y           
                  sta         $dab3,y           
                  sta         $dadb,y           
                  sta         $db03,y           
                  sta         $db2b,y           
                  sta         $db53,y           
                  sta         $db7b,y           
                  dey
                  bpl         strir_04_22_1       

                  ldy         #$00              ;set index for creating monitor columns
strir_04_22_2     lda         #$04              ;load character code for left monitor border
                  sta         $4a8a,y           
                  lda         #$f2              ;load character code for 1st monitor column (overwrites value set above)
                  sta         $4a8b,y           
                  lda         #$05              ;load character code for right monitor border
                  sta         $4a9e,y           
                  tya                           ;increase index by $28 for next row
                  clc
                  adc         #$28              
                  bcs         strir_04_22_3       
                  tay
                  bne         strir_04_22_2        

strir_04_22_3     ldy         #$01              ;load character code for upper left monitor corner
                  sty         $4a62             
                  ldy         #$03              ;load character code for upper right monitor corner
                  sty         $4a76             
                  ldy         #$06              ;load character code for lower left monitor corner
                  sty         $4ba2             
                  ldy         #$08              ;load character code for lower right monitor corner
                  sty         $4bb6             

                  inc         strpt             ;activate next part of startup routine

                  jmp         sound_01          ;jump to sound routine   
                  
;============================================================================================================================================================
;COLOR LOGO AREA

                                                ;[!!!SELF MODIFYING CODE!!!]
strir_04_23       ldy         #$02              ;load color code for red
                  ldx         #$44              ;set index for fetching color memory locations
strir_04_23_1     lda         lgcold9,x         ;fetch low byte for $d9** color memory location
                  sta         col_d900+1        ;change code for setting the color in $d9** color memory
                  cpx         #$35              ;check if index is >= $35 because there are less $d8** than $d9** locations
                  bcs         col_d900          ;skip ahead if >=
                  lda         lgcold8,x         ;fetch low byte for $d8** color memory location
                  sta         col_d800+1        ;change code for setting the color in $d8** color memory
col_d800          sty         $d800             ;store color code in color memory
col_d900          sty         $d900
                  dex                           ;decrease index
                  bpl         strir_04_23_1     ;loop until index is < $00

                  inc         strpt             ;activate next part of startup routine

                  lda         #$a8              ;set delay before starting actual demo
                  sta         ptdly  

                  jmp         sound_01          ;jump to sound routine   

;============================================================================================================================================================
;ADJUST SOUND

strir_04_24       lda         #$01              ;set last step of block $00 from $07 to $01 for when demo loops (intro obviously not needed anymore ;)
                  sta         soundsrc+$860
                  
                  inc         strpt             ;activate next part of startup routine

                  jmp         sound_01          ;jump to sound routine

;============================================================================================================================================================

strir_04_e1       lda         vlbrdrl           ;set up next raster line trigger
                  sta         $d012             
                  cmp         #$fc              
                  bcs         strir_04_e2       ;if the vlbrdr value is >$fc, bit 9 of raster register must no be set
                                                ;the actual check is whether it is > $fc, but this way, no CMP is needed
                  lda         #$93              ;set bit 9 of raster register
                  sta         $d011             
strir_04_e2       lda         #<strir_05        ;set next raster routine address
                  sta         $fffe             
                  lda         #>strir_05        
                  sta         $ffff             
                  rti

;############################################################################################################################################################
;DELETE VERTICAL PATTERN IN LOWER BORDER

strir_05          lsr         $d019             ;acknowledge raster interrupt
                  ldy         #$07              ;wait n cycles until raster line is in left side border
                  dey                           ;(34 cycles = Y * 5 (DEY 2 cycles, BNE 3 cycles)- 1 (last BNE only 2 cycles))
                  bne         *-1               
                  lda         #$00              ;delete vertical line pattern for border
                  sta         $7fff             
                  lda         vlbrdrl           ;set new raster line for deleting vertical line pattern (+$02)
                  clc
                  adc         #$02              
                  sta         vlbrdrl           
                  cmp         #$2a              ;check if new raster line is > $138 (last raster line)
                  bne         strir_05_e        ;if not, skip ahead
                  inc         strpt             ;activate part $04 of startup routine

;============================================================================================================================================================

strir_05_e        jmp         sound_01          ;jump to sound routine   

;############################################################################################################################################################

_ASSETS_4000

;============================================================================================================================================================
;FONT 01

_FONT_4000

*=$4000                                         ;font for upper part of screen
                                                ;$00    : normal grid
                                                ;$01-$08: monitor frame, identical in code and content to characters $01-$08 of font 02
                                                ;$09-$30: broken grid
                                                ;$31    : blank
                                                ;$32-$35: bring in vertical lines in startup routine (see strir_00)
                                                ;$36-$39: unused
                                                ;$3a-$5c: grid/monitor box chars
                                                ;$5d-$d6: logo chars (starts @ $42e8)
                                                ;$d7-$e1: unused
                                                ;$e2-$e8: used to be broken grid characters located at $02-$08, there are needed otherwise, see above
                                                ;$e9-$f0: unused
                                                ;$f1-$f2: initial monitor fill, identical in code and content to characters $f1-$f2 of font 02
                                                ;$ff    : stores hidden feature color data
incbin            c_otg_gfx_1.bin

*=$42e8                                          ;overwrite logo character data in memory so the logo is not shown initially
                  dcb         $3d0,$00

*=$47f8
hfcol             byte        $01,$0f,$0c,$0b,$00,$0b,$0c,$0f

;============================================================================================================================================================
;MAIN SCREEN DATA

_MAINSCRN

*=$4800
                  dcb         $3e8,$31;fill screen with empy character

;============================================================================================================================================================
;DATA FOR SPRITES #1

*=$4c00                                         ;scroller sprites (empty at startup)
                                                ;7 sprites
                                                ;from $4c00-$4dbf
                  dcb         $1c0,$00
                                                ;electric arc animation sprite data (each animation = $0b sprites)
                                                ;5x11 sprites
                                                ;from $4dc0-$5b7f
incbin            s_otg_earc1.bin
incbin            s_otg_earc2.bin
incbin            s_otg_earc3.bin
incbin            s_otg_earc4.bin
incbin            s_otg_earc5.bin
                                                ;blinking eye sprites
                                                ;9 sprites
                                                ;from $5b80-$5dbf
                                                ;6 animation frames:
                                                ;     frame $00:    $6e,$6f,$70
                                                ;     frame $01,05: $71,$72,$70
                                                ;     frame $02,04: $73,$74,$75
                                                ;     frame $03:    $76
incbin            s_otg_eye.bin

                                                ;empty sprite used for
                                                ; - masking out the rising rotating squares in animation part $11 / sub part $03
                                                ;from $5dc0-$5dff
                                                ;pointer: $77
                  dcb         $40,$00

                                                ;white noise bar 1
                                                ;$5e00 (pointer = $78)
whtnsbrspr        byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
                  byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$ff,$ff,$ff,$ff,$ff,$ff
                  byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;============================================================================================================================================================
;WHITE NOISE CHARACTER CODES
                                                ;array of pseudo-random numbers ($00-$0f) used by the $17 animation part to pick the code to display
whtnscc           byte        $28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35

;============================================================================================================================================================
;DATA FOR PIXELING PYRAMID IN/OUT (ANIMATION PART $0a,$0e)
                                                ;bit masks for pixeling in the pyramid
pxland1           byte        $ff,$ff,$3f,$f3,$3c,$c3,$0c,$c0
pxlora1           byte        $00,$00,$40,$04,$41,$14,$51,$15
pxland2           byte        $ff,$ff,$f3,$cf,$33,$c3,$30,$03
pxlora2           byte        $00,$00,$04,$10,$44,$14,$45,$54

                                                ;bit masks for pixeling out the pyramid
pxlando1          byte        $00,$00,$c0,$0c,$c3,$3c,$f3,$3f
pxlorao1          byte        $55,$55,$15,$51,$14,$41,$04,$40
pxlando2          byte        $00,$00,$0c,$30,$cc,$3c,$cf,$fc
pxlorao2          byte        $55,$55,$51,$45,$11,$41,$10,$01

;============================================================================================================================================================
;DATA FOR ROTATING PYRAMID (ANIMATION PART $0b,$0d)
                                                ;each line of bytes represents 1 frame of the pyramid animation (character codes)
                                                ;1st line = frame $00, last line = frame $0bb
pyrdt             byte        $94,$95,$96,$94,$97,$98,$99,$96,$9a,$9b,$9c,$9c,$9c,$9d,$96
                  byte        $9e,$9f,$96,$9e,$a0,$98,$99,$96,$9a,$a1,$a2,$9c,$9c,$9d,$96
                  byte        $9e,$a3,$96,$9e,$b7,$a4,$99,$96,$9a,$a1,$a5,$9c,$9c,$9d,$96
                  byte        $9e,$b4,$96,$9e,$b7,$a6,$99,$96,$9a,$a1,$a7,$a8,$9c,$9d,$96
                  byte        $9e,$b4,$96,$9e,$b7,$a9,$99,$96,$9a,$a1,$a7,$a5,$9c,$9d,$96
                  byte        $9e,$b4,$96,$9e,$b7,$ab,$ac,$96,$9a,$a1,$a7,$a7,$ad,$9d,$96
                  byte        $9e,$ae,$96,$9e,$b7,$b3,$af,$96,$9a,$a1,$a7,$a7,$a7,$b0,$96
                  byte        $94,$b1,$96,$94,$b2,$b3,$af,$96,$9a,$9b,$b5,$a7,$a7,$b0,$96
                  byte        $94,$b6,$96,$94,$97,$b8,$af,$96,$9a,$9b,$b9,$a7,$a7,$b0,$96
                  byte        $94,$b6,$96,$94,$97,$ba,$af,$96,$9a,$9b,$9c,$bb,$a7,$b0,$96
                  byte        $94,$b6,$96,$94,$97,$bc,$af,$96,$9a,$9b,$9c,$b9,$a7,$b0,$96
                  byte        $94,$bd,$96,$94,$97,$be,$bf,$96,$9a,$9b,$9c,$9c,$c0,$b0,$96

;============================================================================================================================================================
;FONT 02

_FONT_6000

*=$6000                                         ;font for lower part of screen & the monitor animations
                                                ;$00-$1d: grid & monitor
                                                ;$1e    : scroll grid multicolor #02
                                                ;$1f-$24: sawtooth
                                                ;$25-$27: flatline (3 needed because they are wiped out seperately)
                                                ;$28-$37: white noise
                                                ;$38    : horizontal line for monitor switch off (animation part $17)
                                                ;$39    : final dot for monitor switch off (animation part $17)
                                                ;$48-$8b: rotating rectangle
                                                ;$8c-$93: expanding rectangle
                                                ;$94-$c0: rotating pyramid
                                                ;$c1-$ca: segmented rectangle
                                                ;$cb-$e8: draw welding line
                                                ;$e9    : square with glowing center
                                                ;$ea    : temporary character used in wldlns04 that merges a weld line with the scrolling grid
                                                ;$eb    : temporary character used in animation part $15 (grid + static pixel in bytes $04 and $05)
                                                ;$f0    : temporary character used to flash in grid (animation part $06)
                                                ;$f1    : filled square multicolor #01 (dark grey monitor)
                                                ;$f2    : monitor wipe in temporary character
                                                ;$f3    : working charcter for:
                                                ;         - flatline (merged with grid for row 6 of monitor)
                                                ;$f4    : working charcter for:
                                                ;         - flatline (merged with grid for row 4 of monitor)
                                                ;$f5    : working charcter for:
                                                ;         - flatline (merged with grid for row 2 of monitor)
                                                ;$f6-$fb: sawtooth & grid merged for monitor rows 2,4,6
                                                ;$fc    : copy of normal grid character for: row 7 of monitor wipe out (part $05), line for bringing in rectangle (part $07),
                                                ;         pixel wave (part $12)
                                                ;$fd    : copy of normal grid character for: row 5 of monitor wipe out (part $05), line for bringing in rectangle (part $07),
                                                ;         pixel wave (part $12)
                                                ;$fe    : copy of normal grid character for: row 3 of monitor wipe out (part $05), pixel wave (part $12)
                                                ;$ff    : copy of normal grid character for: row 1 of monitor wipe out (part $05), pixel wave (part $12)

incbin            c_otg_gfx_2.bin


*=$64a0                                         ;overwrite pyramid character data in memory so the pyramid is initially not shown (will be pixeled in)
                                                ;the character data is the flashing part of the rectangle
                  dcb         $50,$55

;============================================================================================================================================================
;DATA FOR SPRITES #2

*=$6800
                                                ;welding
                                                ;4 animation phases consisting of 3 sprites each = 12 sprites
                                                ;from $6800-$6aff
                                                ;pointers: $a0-$a3 - core
                                                ;          $a4-$a7 - inner ring
                                                ;          $a8-$ab - outer ring and sparks
incbin            s_otg_weld.bin
                                                ;expanding & rotating square
                                                ;from $6b00-$6f7f
                                                ;pointers: $ac-$b0 - expand small square
                                                ;          $b0-$b4 - rotate square
                                                ;          $b5-$ba - expand small square color filling
                                                ;          $ba-$be - rotate square filling
incbin            s_otg_sq_exp_rot.bin

;============================================================================================================================================================
;COLOR DATA FOR SCROLLER

scrlcol           dcb         scrlclfrms,$0b
                  dcb         scrlclfrms,$0c
                  dcb         scrlclfrms,$0f
                  dcb         scrlclfrms,$01
                  dcb         scrlclfrms,$0f
                  dcb         scrlclfrms,$0c

;============================================================================================================================================================
;DATA FOR ELECTRIC ARC ANIMATIONS
                                                ;electric arc animation meta data
                                                ;byte $00: sprite data pointer
                                                ;byte $01: x coordinate
                                                ;byte $02: y coordinate
                                                ;byte $03: x > $ff - since two scroller sprites have > $ff,
                                                ;          $e0 means that the animation sprite has to be displayed > $ff,
                                                ;          $60 means <= $ff (scroller sprites 5 and 6 are always > $ff)
eaanimd           byte        $37,$2f,$60,$60   ;#1: left center
                  byte        $42,$59,$7a,$60   ;#2: left bottom
                  byte        $4e,$1f,$7a,$e0   ;#3: right bottom
                  byte        $58,$2f,$3d,$e0   ;#4: right top
                  byte        $63,$51,$3d,$60   ;#5: left top

                                                ;electric arc color data
eaanicol          byte        $01,$0f,$01,$0f,$01,$0f,$01,$0f,$01,$0f,$01

;============================================================================================================================================================
;MASKING DATA FOR MONITOR WIPE IN (ANIMATION PART $00)
                                                ;mask for erasing the parts of the grid not needed
mnwpers           byte        $fc,$f0,$c0
                                                ;mask for rest of dark grey monitor display
mnwpdgm           byte        $01,$05,$15

;============================================================================================================================================================
;DATA FOR SAWTOOTH ANIMATION  (ANIMATION PARTS $01-$04)
                                                ;character codes for monitor with saw tooth animation
swtrwd1           byte        $f6,$f7,$f8,$f9,$fa,$fb,$f6,$f7,$f8,$f9,$fa,$fb,$f6,$f7,$f8,$f9,$fa,$fb

                                                ;color information for saw tooth animation rows
swtclr1_5         byte        $08,$09
swtclr3           byte        $09,$08

;============================================================================================================================================================
;DATA FOR RECTANGLE ANIMATION (ANIMATION PARTS $07-$09)
                                                ;color codes for rectangle flash
rectclr           byte        $0c,$0f,$0c,$0b

;============================================================================================================================================================
;DATA FOR FLICKERING IN GRID (ANIMATION PART $06)
                                                ;delay for displaying dark square (left to right) and grid (right to left)
dlyflckr          byte        $01,$02,$04,$08,$10,$18,$20,$22,$24,$26,$28

;============================================================================================================================================================
;$7000-$8500 used for code

;============================================================================================================================================================
;BIT PATTERN IN BORDER

*=$7fff
                  byte        $10

;============================================================================================================================================================
;SOUND DATA

_SOUND_DATA

*=$850f                                   ;(original: $650f) - low byte must always be $0f, high byte can range from $16-$8a

incbin            otg_sound.bin

;============================================================================================================================================================
;SCROLLER FONT

_ASSETS_A000

                                                ;characters $00-$3f
                                                ;$1c = scroller fade out left
                                                ;$24 = scroller fade in right

*=$a000
incbin            c_otg_txt.bin


;============================================================================================================================================================
;DATA FOR LOGO ANIMATION
                                                ;lo byte of the start addresses for character data for erase/build logo animation (see ercdblo and ercdelo)
                                                ;instead of doing calculations, it is faster to store them
                                                ;lo byte only, hi byte the same for all
                                                ;FIXED MEMORY LOCATIONS: low byte of ercdblo/ercdelo +$08 for each following address

                                                ;build
ernifrmlob        byte        <ercdblo+$48,<ercdblo+$40,<ercdblo+$38,<ercdblo+$30,<ercdblo+$28,<ercdblo+$20,<ercdblo+$18,<ercdblo+$10,<ercdblo+$08,<ercdblo
                                                ;erase
ernifrmloe        byte        <ercdelo+$48,<ercdelo+$40,<ercdelo+$38,<ercdelo+$30,<ercdelo+$28,<ercdelo+$20,<ercdelo+$18,<ercdelo+$10,<ercdelo+$08,<ercdelo

                                                ;each byte represents the offset from the start of erlgchrlo/hi & erlgcollo/hi to
                                                ;where the data representing a vertical slice of the logo starts
                                                ;the last value represents the 1st slice due to the indexing of the slices from $0e to $00
erlgslcstrt       byte        $7f,$75,$6b,$61,$58,$53,$4c,$42,$39,$2f,$25,$1c,$13,$09,$00

                                                ;logo cross-section character data memory locations
                                                ;$ff is the terminator signalling the end of the data for one slice
                                                ;split up into lo and hi byte
erlgchrlo         byte        $48,$b0,$18,$78,$f0,$50,$20,$90,$ff
                  byte        $f8,$50,$b8,$20,$80,$f8,$58,$b8,$28,$ff
                  byte        $00,$58,$c0,$28,$88,$60,$c0,$30,$ff
                  byte        $08,$60,$c8,$30,$90,$00,$68,$38,$ff
                  byte        $10,$68,$d0,$38,$98,$08,$70,$c8,$40,$ff
                  byte        $e8,$18,$70,$d8,$40,$a0,$10,$78,$d0,$ff
                  byte        $20,$78,$e0,$48,$a8,$18,$d8,$48,$ff
                  byte        $28,$80,$e8,$b0,$20,$80,$e0,$50,$98,$ff
                  byte        $b8,$28,$88,$e8,$58,$a0,$ff
                  byte        $c0,$90,$f0,$60,$ff
                  byte        $88,$f0,$50,$c8,$30,$98,$f8,$68,$ff
                  byte        $30,$90,$f8,$58,$d0,$38,$a0,$00,$70,$ff
                  byte        $38,$98,$00,$60,$d8,$40,$a8,$08,$78,$ff
                  byte        $f0,$40,$a0,$08,$68,$e0,$10,$80,$a8,$ff
                  byte        $a8,$10,$70,$e8,$48,$b0,$18,$88,$b0,$ff

erlgchrhi         byte        $43,$43,$44,$44,$44,$45,$46,$46,$ff
                  byte        $42,$43,$43,$44,$44,$44,$45,$45,$46,$ff
                  byte        $43,$43,$43,$44,$44,$45,$45,$46,$ff
                  byte        $43,$43,$43,$44,$44,$45,$45,$46,$ff
                  byte        $43,$43,$43,$44,$44,$45,$45,$45,$46,$ff
                  byte        $42,$43,$43,$43,$44,$44,$45,$45,$45,$ff
                  byte        $43,$43,$43,$44,$44,$45,$45,$46,$ff
                  byte        $43,$43,$43,$44,$45,$45,$45,$46,$46,$ff
                  byte        $44,$45,$45,$45,$46,$46,$ff
                  byte        $44,$45,$45,$46,$ff
                  byte        $43,$43,$44,$44,$45,$45,$45,$46,$ff
                  byte        $43,$43,$43,$44,$44,$45,$45,$46,$46,$ff
                  byte        $43,$43,$44,$44,$44,$45,$45,$46,$46,$ff
                  byte        $42,$43,$43,$44,$44,$44,$46,$46,$46,$ff
                  byte        $43,$44,$44,$44,$45,$45,$46,$46,$46,$ff

;============================================================================================================================================================
;DATA FOR WELDING SPRITES
                                                ;pointers to welding sprite data
                                                ;1st line = sprite $00, 2nd line = sprite $01; 3rd line = sprite $02
wldsprt           byte        $a0,$a1,$a2,$a3
                  byte        $a4,$a5,$a6,$a7
                  byte        $a8,$a9,$aa,$ab

;DATA FOR MOVING WELDING SPRITES
                                                ;each line is one section of the movement
                                                ;1st byte: $00 = decrease coordinate; $01 = increase coordinate
                                                ;2nd byte: target x coordinate; if = $ff, x is not changed in that section
                                                ;3nd byte: target y coordinate; if = $ff, y is not changed in that section
wldmv             byte        $01,$ff,$d8       ;index $00
                  byte        $01,$df,$ff       ;index $03
                  byte        $00,$ff,$c8       ;index $06
                  byte        $00,$c7,$ff       ;index $09
                  byte        $00,$ff,$b2       ;index $0c
                  byte        $01,$df,$ff       ;index $0f
                  byte        $01,$ff,$c8       ;index $12
                  byte        $00,$b1,$ff       ;index $15
                  byte        $00,$ff,$ba       ;index $18
                  byte        $01,$bf,$ff       ;index $1b
                  byte        $01,$ff,$c8       ;index $1e
                  byte        $00,$b7,$ff       ;index $21
                  byte        $00,$ff,$c2       ;index $24
                  byte        $00,$b1,$ff       ;index $27

;DATA FOR CREATING WELDING LINES IN RECTANGLE
                                                ;each line represents the character codes for drawing the welding lines
                                                ;data is split across each section of welding line drawing
wldln1            byte        $4a,$48,$48,$48,$4e
                  byte        $cb,$48,$48,$48,$4e
                  byte        $cc,$48,$48,$48,$4e
                  byte        $49,$48,$48,$48,$4e
                  byte        $49,$cd,$48,$48,$4e
                  byte        $49,$ce,$48,$48,$4e
                  byte        $49,$cf,$48,$48,$4e
                  byte        $49,$50,$48,$48,$4e
                  byte        $49,$50,$cd,$48,$4e
                  byte        $49,$50,$ce,$48,$4e
                  byte        $49,$50,$cf,$48,$4e
                  byte        $49,$50,$50,$48,$4e
                  byte        $49,$50,$50,$cd,$4e
                  byte        $49,$50,$50,$ce,$4e
                  byte        $49,$50,$50,$cf,$4e
                  byte        $49,$50,$50,$50,$4e
                  byte        $49,$50,$50,$50,$d0
                  byte        $49,$50,$50,$50,$d1
                  byte        $49,$50,$50,$50,$4f

wldln2            byte        $48,$48,$48,$4c
                  byte        $48,$48,$48,$d2
                  byte        $48,$48,$48,$d3
                  byte        $48,$48,$48,$4d
                  byte        $48,$48,$d4,$4d
                  byte        $48,$48,$d5,$4d
                  byte        $48,$48,$d6,$4d
                  byte        $48,$48,$4e,$4d
                  byte        $48,$d4,$4e,$4d
                  byte        $48,$d5,$4e,$4d
                  byte        $48,$d6,$4e,$4d
                  byte        $48,$4e,$4e,$4d
                  byte        $d4,$4e,$4e,$4d

wldln3            byte        $4a,$48,$d4
                  byte        $4a,$48,$d7
                  byte        $4a,$48,$d8
                  byte        $4a,$48,$4c
                  byte        $4a,$d4,$4c
                  byte        $4a,$d7,$4c
                  byte        $4a,$d8,$4c
                  byte        $4a,$4c,$4c
                  byte        $d9,$4c,$4c
                  byte        $da,$4c,$4c
                  byte        $4b,$4c,$4c
                  byte        $4b,$4c,$4c

wldln4            byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$4c,$ea,$ea,$ea
                  byte        $50,$48,$d2,$ea,$ea,$ea
                  byte        $50,$48,$d3,$ea,$ea,$ea
                  byte        $50,$48,$4d,$ea,$ea,$ea
                  byte        $50,$d4,$4d,$ea,$ea,$ea
                  byte        $50,$d5,$4d,$ea,$ea,$ea
                  byte        $50,$d6,$4d,$ea,$ea,$ea
                  byte        $50,$4e,$4d,$ea,$ea,$ea
                  byte        $db,$4e,$4d,$ea,$ea,$ea
                  byte        $dc,$4e,$4d,$ea,$ea,$ea
                  byte        $4f,$4e,$4d,$ea,$ea,$ea

wldln5            byte        $50,$48
                  byte        $dd,$48
                  byte        $de,$48
                  byte        $49,$48
                  byte        $49,$cd
                  byte        $49,$df
                  byte        $49,$e0
                  byte        $49,$4a

wldln6            byte        $4a,$4e
                  byte        $4a,$4e
                  byte        $e1,$4e
                  byte        $e2,$4e
                  byte        $4b,$4e
                  byte        $4b,$e3
                  byte        $4b,$e4
                  byte        $4b,$4d

wldln7            byte        $4f
                  byte        $e5
                  byte        $e6
                  byte        $e7

wldln8            byte        $e7
                  byte        $e8
                  byte        $e9
                  byte        $e9

;============================================================================================================================================================

                                                ;  characte codes used for pixel wave (scrollers)
                                                ;  $1e = scrolling grid only
                                                ;  $fc = scrolling grid + 2x2 pixel in bytes $00 and $01
                                                ;  $fd = scrolling grid + 2x2 pixel in bytes $02 and $03
                                                ;  $fe = scrolling grid + 2x2 pixel in bytes $04 and $05
                                                ;  $ff = scrolling grid + 2x2 pixel in bytes $06 and $07

;PIXEL WAVE DATA
                                                ;codes for characters making up one full pixel wave
pxlwvd1           byte        $ff,$fe,$fd,$fc,$fd,$fe

;PIXEL SCROLLER RIGHT > LEFT DATA
                                                ;characters displayed in animation part $12 in lines 1-5 of monitor
*=$a500
                  byte        $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$fe,$fe,$fe,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$fe,$fe,$fe,$fe,$1e,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$1e,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a600
                  byte        $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a700
                  byte        $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$fe,$fe,$1e,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a800
                  byte        $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a900
                  byte        $fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$fe,$fe,$fe,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$fe,$fe,$fe,$fe,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$fe,$fe,$fe,$fe,$1e,$1e,$1e,$1e,$fe,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e

; WAVY PIXEL SCROLLER LEFT > RIGHT DATA
                                                ;characters displayed in animation part $15 in lines 1-5 of monitor:
*=$a580
                  byte        $eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$1e,$1e,$1e,$1e,$fd,$1e,$ff,$1e,$1e,$1e,$1e,$fe,$ff,$fe,$1e,$1e,$fd,$fe,$ff,$fe,$fd,$1e,$fd,$fe,$ff,$fe,$fd,$1e,$1e,$1e,$ff,$fe,$fd,$fc,$fd,$1e,$ff,$1e,$1e,$1e,$fd,$1e,$ff,$fe,$fd,$fc,$fd,$1e,$1e,$1e,$1e,$fc,$fd,$fe,$ff,$1e,$fd,$fc,$fd,$fe,$1e,$1e,$fd,$1e,$fd,$fe,$ff,$fe,$1e,$1e,$1e,$1e,$ff,$1e,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a680
                  byte        $eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$1e,$1e,$1e,$fd,$fe,$ff,$fe,$fd,$1e,$1e,$fe,$1e,$1e,$1e,$fc,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fc,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fc,$1e,$1e,$1e,$1e,$1e,$fc,$1e,$1e,$1e,$fe,$1e,$fc,$1e,$fe,$1e,$1e,$1e,$fc,$1e,$1e,$ff,$fe,$fd,$fc,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a780
                  byte        $eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$1e,$1e,$1e,$1e,$ff,$1e,$fd,$1e,$1e,$1e,$ff,$1e,$1e,$1e,$fd,$1e,$ff,$fe,$fd,$1e,$1e,$1e,$ff,$fe,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fd,$1e,$1e,$1e,$fd,$fc,$fd,$fe,$ff,$1e,$fd,$fc,$fd,$fe,$ff,$1e,$1e,$1e,$fd,$1e,$1e,$fe,$fd,$1e,$fd,$fe,$ff,$fe,$1e,$1e,$fd,$1e,$ff,$1e,$1e,$1e,$fd,$1e,$1e,$1e,$fd,$1e,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a880
                  byte        $eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$1e,$1e,$1e,$fd,$fe,$ff,$fe,$fd,$1e,$1e,$fe,$1e,$1e,$1e,$fc,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fc,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$fe,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fc,$1e,$1e,$1e,$fe,$1e,$fc,$1e,$1e,$1e,$fe,$1e,$fc,$1e,$fe,$1e,$1e,$1e,$fc,$1e,$1e,$ff,$fe,$fd,$fc,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e
*=$a980
                  byte        $eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$eb,$1e,$1e,$1e,$1e,$fd,$1e,$ff,$1e,$1e,$1e,$1e,$fe,$ff,$fe,$1e,$1e,$fd,$1e,$1e,$1e,$1e,$1e,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$fd,$1e,$1e,$1e,$ff,$1e,$1e,$1e,$fd,$1e,$ff,$fe,$fd,$fc,$fd,$1e,$1e,$1e,$1e,$fc,$fd,$fe,$ff,$1e,$fd,$1e,$1e,$1e,$ff,$1e,$fd,$1e,$fd,$fe,$ff,$fe,$1e,$1e,$1e,$1e,$ff,$1e,$fd,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e,$1e

;============================================================================================================================================================
;TEXT SCROLLER
                                                ;scrolltext, the $ee is the terminator for the end of the text
_SCROLLTEXT       text        '2021! after spending 35 years with and on the c64, i finally created an old school demo % # '
                  text        'it took way longer than expected (i started in march 2020)... # '
                  text        'in best academy awards fashion, i have to say i (or rather this demo) would not be here without the following: '
                  text        'the forum @ lemon64.com - retro-programming.de (especially helpful for all things raster interrupty) - '
                  text        'codebase64.org (excellent reference) - c64-wiki.com - dustlayer.com (great tutorials) # '
                  text        'greetings are due: psychobilly - dandee - szmt - drp (digitalretropark.net) - qtct # '
                  text        'can you find the super secret disco epilepsy mode? # visit ldx40.net for more c= stuff as well as music, videos and more.'
                  text        '                                                                                           '
                  byte        $ee

;============================================================================================================================================================
;$ade0-$b297 used for code

;============================================================================================================================================================

_ASSETS_B298

;PYRAMID CHARACTER DATA BACKUP
                                                ;the pyramid (animation part $0b) is pixeled in (animation part $0a) and out (animation part $0x) with the character data
                                                ;therefore a  backup of the characters initally constituting the pyramid ($94-$9d) is needed
                                                ;put @ original charset location +$5000 for easy processing in animation routine
*=$b298
incbin            c_otg_pyr_pxl.bin

;============================================================================================================================================================
;LOGO CHARACTER DATA BACKUP
*=$b2e8                                         ;logo character data in charset gets erased by animation
                                                ;put @ original charset location +$7000 for easy processing in animation routine

incbin            c_otg_gfx_logo.bin


;============================================================================================================================================================
;DATA FOR ERASE/BUILD LOGO ANIMATIONS
*=$ce60                                         ;character data for building logo animation
                                                ;must start between $**00 and $**60 because the erase/build routine needs all the data with 1 page
                                                ;ernifrmlob and ernifrmloe list the low byte of the start address of each build/erase character
                                                ;!!!UNCLEAR  : PUTTING THIS AT THE END OF THE CODE OR SETTING IT TO A LOCATION > $CE60 HERE MESSES UP STARTUP ROUTINE TIMING
                                                ;!!!SUSPICION: SOMEHOW AFFECTS MEMORY >= $D000 - BUT WHY?
ercdblo           byte        $80,$00,$80,$00,$80,$00,$80,$00
                  byte        $80,$40,$80,$40,$80,$40,$80,$40
                  byte        $a0,$c0,$a0,$c0,$a0,$c0,$a0,$c0
                  byte        $e0,$d0,$e0,$d0,$e0,$d0,$e0,$d0
                  byte        $e8,$f0,$e8,$f0,$e8,$f0,$e8,$f0
                  byte        $f8,$f4,$f8,$f4,$f8,$f4,$f8,$f4
                  byte        $fa,$fc,$fa,$fc,$fa,$fc,$fa,$fc
                  byte        $fe,$fd,$fe,$fd,$fe,$fd,$fe,$fd
                  byte        $fe,$ff,$fe,$ff,$fe,$ff,$fe,$ff
                  byte        $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff

                                                ;character data for erasing logo animation
ercdelo           byte        $7f,$ff,$7f,$ff,$7f,$ff,$7f,$ff
                  byte        $7f,$bf,$7f,$bf,$7f,$bf,$7f,$bf
                  byte        $5f,$3f,$5f,$3f,$5f,$3f,$5f,$3f
                  byte        $1f,$2f,$1f,$2f,$1f,$2f,$1f,$2f
                  byte        $17,$0f,$17,$0f,$17,$0f,$17,$0f
                  byte        $07,$0b,$07,$0b,$07,$0b,$07,$0b
                  byte        $05,$03,$05,$03,$05,$03,$05,$03
                  byte        $02,$01,$02,$01,$02,$01,$02,$01
                  byte        $01,$00,$01,$00,$01,$00,$01,$00
                  byte        $00,$00,$00,$00,$00,$00,$00,$00
                  
;============================================================================================================================================================
;COLOR MEMOR LOCATIONS OF LOGO
                                                ;high byte: $d8
lgcold8           byte        $3a,$42,$5e,$5f,$60,$61,$62,$63,$64,$68,$69,$6a,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8f,$90,$91,$92,$93,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b7,$b8,$b9,$ba,$bb,$d5,$d6,$d7,$d8,$d9,$da,$db,$df,$e0,$e1,$e2,$e3,$fd,$fe,$ff

                                                ;high byte: $d9
lgcold9           byte        $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0a,$0b,$25,$26,$28,$29,$2a,$2b,$2c,$2d,$2f,$30,$31,$33,$4d,$4e,$4f,$50,$51,$52,$54,$55,$56,$57,$58,$59,$5b,$76,$77,$79,$7a,$7b,$7c,$7d,$7e,$7f,$80,$81,$82,$83,$9d,$9e,$9f,$a0,$a1,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$c5,$cc,$cd,$d2,$d3

